# function for drawing a subsector map for exploration without stats

function draw_chart(trav)

hold on

mapdraw();

for j=1:length(trav)
if (trav(j).starnum>0)
  sn=trav(j).starnum;
  st=[0 0 0];
  trav(j).restriction=0; # can't know if it's bad there or not
  for a=1:sn    # choose color for drawing stars
    if ((trav(j).startype(a,1)=='r')+(trav(j).startype(1,6)=='S')+(trav(j).startype(1,1)=='M'))
        st(a)=1;
      elseif ((trav(j).startype(a,1)=='o')+(trav(j).startype(1,1)=='f'))
        st(a)=2;
      elseif ((trav(j).startype(a,1)=='y')+(trav(j).startype(1,1)=='R'))
        st(a)=3;
      elseif ((trav(j).startype(a,1)=='w')+(trav(j).startype(1,6)=='W'))
        st(a)=4;
      elseif ((trav(j).startype(a,6)=='D')+(trav(j).startype(1,1)=='p')+ (trav(j).startype(a,1)=='T'))
        st(a)=5;
      elseif ((trav(j).startype(a,6)=='T')+(trav(j).startype(1,6)=='N'))
        st(a)=6;
      elseif ((trav(j).startype(a,6)=='A')+(trav(j).startype(a,1)=='C'))
        st(a)=7;
      elseif ((trav(j).startype(a,6)=="B")+(trav(j).startype(a,6)=='O'))
        st(a)=8;  
      endif
    endfor
  # define scaling factor for size of star
  if ((trav(j).startype(1,6)=='S')+(trav(j).startype(1,6)=='O')+(trav(j).startype(1,6)=='W')+(trav(j).startype(1,6)=='N')+ (trav(j).startype(1,1)=='p'))
      q=2;
    elseif (trav(j).startype(1,6)=='A')
      q=1.3;
    else  
      q=1;
    endif

  if ((trav(j).period(2)>0)+(trav(j).startype(1,1)=='p')+(trav(j).startype(1,1)=='T'))
      starcircle(trav(j).subsector(1), trav(j).subsector(2), st, q, trav(j).restriction);
    else  
      stardraw(trav(j).subsector(1), trav(j).subsector(2), sn, st, trav(j).restriction,q);
    endif  
  code=['a' '?' 'g' num2str(trav(j).giants) 'h' '?'];
  charttext(trav(j).subsector(1), trav(j).subsector(2), trav(j).name, code);
  endif
  endfor
  
title(strcat('[', num2str(trav(1).sector(1)), ',', num2str(trav(1).sector(2)), ']', " Subsector"),"fontsize",18);  
orient("tall");
axis("off");
papersize = [8.5 11];
        set (gcf, "papersize", papersize)
        set (gcf, "paperposition", [0.25 0.25, papersize-0.5])
        
hold off
 namefile= strcat('Subsector_chart', num2str(trav(1).sector(1)), ',', num2str(trav(1).sector(2)),'.pdf');

 saveas(1,namefile, "pdf");
# print -dsvg namefile
 fflush(1);

 close;

endfunction

function EWhex(h,v,a,b,c)
  plot([h+.1 h+.1+a], [v+.1+b v+.1])
  plot([h+.1+a h+.1+a+c], [v+.1 v+.1])
  plot([h+.1+a+c h+.1+2*c], [v+.1 v+.1+b])
  plot([h+.1+2*c h+.1+a+c], [v+.1+b v+.1+2*b])
  plot([h+.1+a+c h+.1+a], [v+.1+2*b v+.1+2*b])
  plot([h+.1+a h+.1], [v+.1+2*b v+.1+b])
  endfunction

#draw hex subsectors 8x10
function mapdraw()
c=1;
a=0.5*c;
b=sin(pi/3)*c;
axis ([0 13 0 19]);

for y=0:9
  for x=0:7
    ex=num2str(dec2hex(x+1,2));
    ey=num2str(dec2hex(10-y,2));
    if (y==0)
        ey="10";
      endif
    loc=[ex ey];

    if (x/2== floor(x/2))
        EWhex((floor(x/2)*3*c), (y*2*b),a,b,c);
        text((floor(x/2)*3*c+b/2+.45), (y*2*b+1.7),loc,"fontsize",8);
      else
        EWhex(floor(x/2)*3*c+(a+c), y*2*b+b,a,b,c)
        text((floor(x/2)*3*c+(a+c)+b/2+.45), (y*2*b+b+1.7),loc,"fontsize",8);         
      endif
    endfor
  endfor

endfunction  

 
function stardraw(x,y,n,ty,s,q)  #x=xpos, y=ypos, n=#stars, ty=startype, s= system status q= giant scaling factor
sx= [0 -.03 -.12 -.03 0 .03 .12 .03 0];
sy= [.12 .03 0 -.03 -.12 -.03 0 .03 .12];
col(1,:)=[1 0 0];
col(2,:)=[.90 .57 .16];
col(3,:)=[1 1 0];
col(4,:)=[1 1 1];
col(5,:)=[.7 .7 .7];
col(6,:)=[.6 .3 .15];
col(7,:)=[.5 .5 1];
col(8,:)=[0 0 1];
red=[.75 0 0];
amber=[.7 .7 0];
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1;
y=y-1;
y=9-y;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
# printf("sx%d sy%d q%d xm%d ym%d, ty:%d r:%d g:%d b:%d", sx, sy, q, xm, ym, ty, col(ty(1),1), col(ty(1),2), col(ty(1),3));
if (n==1)
    fill(2*sx*q+xm, 2*sy*q+0.2+ym, col(ty(1),:));
    
  elseif (n==2)
    fill(sx*1.5-.2+xm, sy*1.5+.2+ym, col(ty(1),:));
    fill(sx*1.5+.2+xm, sy*1.5+.2+ym, col(ty(2),:));
  else
    fill(sx-.15+xm, sy+.1+ym, col(ty(1),:));
    fill(sx+xm, sy+.3+ym, col(ty(2),:));
    fill(sx+.15+xm, sy+.1+ym, col(ty(3),:));
  endif  
cx= -.5:.01:.5;

if (s==1)
    plot(xm+cx, ym-.05, "color", amber, "linewidth",1);
  elseif(s==2)
    plot(xm+cx, ym-.05, "color", red, "linewidth",1);
  endif
endfunction  


function starcircle(x,y,co,q,s) # x=Xpos  y=Ypos  co=[R G B] q= scaling oval s=restriction
  col(1,:)=[1 0 0];
  col(2,:)=[.90 .57 .16];
  col(3,:)=[1 1 0];
  col(4,:)=[1 1 1];
  col(5,:)=[.7 .7 .7];
  col(6,:)=[.6 .3 .15];
  col(7,:)=[.5 .5 1];
  col(8,:)=[0 0 1];
  red=[.75 0 0];
  amber=[.7 .7 0];
  t=(1/80:1/40:1)'*2*pi;
  sx=cos(t)/10;
  sy=sin(t)/10;
  c=1;
  a=0.5*c;
  b=sin(pi/3)*c;
  x=x-1;
  y=y-1;
  y=9-y;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
  
      
  fill(1.5*sx+xm, 1.5*sy+0.2+ym, col(co(1),:));
  plot(2.5*sx*q+xm, 2.5*sy+0.2+ym, "color", col(co(1),:), "linewidth", 1)

cx= -.5:.01:.5;
  if (s==1)  # draw restriction line
      plot(xm+cx, ym-.05, "color", amber, "linewidth",1);
    elseif(s==2)
      plot(xm+cx, ym-.05, "color", red, "linewidth",1);
    endif
    
  endfunction
  

 
function charttext(x, y, planets, code)
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1;
y=y-1;
y=9-y;
# name= [num2str(planets), ' planets'];
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
    text(xm-0.086*length(planets), ym-.23 ,planets,"fontsize",12);      
    text(xm-.7, ym-.55 ,'???????-?',"fontsize",9);
    text(xm-.5, ym-.8, code, "fontsize",9);    

endfunction  
 