clear   # get rid of all variables and start a fresh slate

full_variables    #grab file of construction conditions

more off

newdir=input("What is the name of your new setting? ","s");
newdir=strrep(newdir, " ", "");
olddir=pwd();
# only for Octave 5.0+
if (isfolder(newdir)==0)
    mkdir(newdir);                                             # put files in new directory
  endif  
# use for Octave 4.?
#mkdir(newdir);

cnt=1;   #count of systems in the cluster
for Xsec=1:length(M3(:,1))         #cycle through M3 variable in X and Y directions
  for Ysec=1:length(M3(1,:))
    printf("Working on %d,%d.\n",Xsec, Ysec);
    fflush(stdout);
    full_system       #construct a basic subsector
#    trav_mapping      #draw a pdf map of subsector
    for lp=1:length(trav)
      trav(lp).count=lp;
      trav(lp).popcenter=popcenters(trav(lp));
      tr(cnt)= trav(lp);
      cnt=cnt+1;   
      endfor
    clear trav  # must remove array or they will add back up in trav
    endfor
  endfor
clear temp
if (syst_pockets==1)
    # set up influ base variable
    temp.confed=0;
    temp.self=0;
    temp.independent=0;
    temp.dominate(1)=0;
    temp.ally= [0 0 0];
    temp.score(1)=0;
    temp.ndx= [0 0 0];
    
    for x=1:length(tr)
      tr(x).influ=temp;  # set up the influence array for consistency
      endfor
    clear temp
  endif     
#{
    for x=1:length(sys(:,1,1))
      for y=1:length(sys(1,:,1))
        printf("Calculating influence and empires for subsector %d-%d.\n", x, y);
        fflush(stdout);
        newconfed    # calculate the confederation influence and pocket empires per subsector
        endfor
      endfor  
  endif
#}

full_locationdistance


if (syst_pockets==1)
    printf("Calculating influence array.\n");
    fflush(stdout);
    fast_influence   
  endif


for aa=1:length(tr)
  if (syst_confederation==1)
      tr(aa).influ.confed=testconfedonly(aa, tr, distance_array);
    endif
  endfor 

# break cluster into subsector arrays
# sys(x,y,c)   x=x position, 1=left, higher=right
#              y=y position, 1=bottom, higher=top
#              c=subsector index, max number of systems in cluster
c=ones(length(M3(:,1)),length(M3(1,:)));
for a=1:length(tr)
  x=tr(a).sector(1);
  y=tr(a).sector(2);
  sys(x,y,c(x,y))=tr(a);
  c(x,y)=c(x,y)+1;
  endfor

# does a dominant world's tech level set an upper limit on all subject worlds?
if (syst_pocket_tech_max==1)
   cnt=1;
   for a=1:length(sys(:,1,1))
      for b=1:length(sys(1,:,1))
        for c=1:length(sys(a,b,:))
          if (sys(a,b,c).starnum>0)
              if (sys(a,b,c).influ.independent==0)   #if it is a subject world
                  d= sys(a,b,c).influ.ndx(1,1);
                  e= sys(a,b,c).influ.ndx(1,2);
                  f= sys(a,b,c).influ.ndx(1,3);
                  if (sys(a,b,c).tech>sys(d,e,f).tech)
                      sys(a,b,c).tech=sys(d,e,f).tech; #it's max tech is it's dominant world
                      for g=1:sys(a,b,c).planets
                        sys(a,b,c).uwp(g,9)=dec2hex(sys(d,e,f).tech);
                        for h=1:sys(a,b,c).lmoons(g)                             #rewrite moon and planet uwp value
                          sys(a,b,c).moon.uwp(g,h,9)=dec2hex(sys(d,e,f).tech);
                          endfor
                        endfor
                      sys(a,b,c).trade(6)=(sys(d,e,f).tech>13);
                    endif                  
                endif
              tr(cnt)=sys(a,b,c); # assign linear array to modified sys variabls
              cnt=cnt+1;  
            endif
          endfor
        endfor
      endfor  
    printf("Re-calculating influence and empires.\n");
    fflush(stdout);
    fast_influence    # recalculate the confederation influence and pocket empires per subsector
    # break cluster into subsector arrays again
    c=ones(length(M3(:,1)),length(M3(1,:)));
    for a=1:length(tr)
      x=tr(a).sector(1);
      y=tr(a).sector(2);
      sys(x,y,c(x,y))=tr(a);
      c(x,y)=c(x,y)+1;
      endfor
    
  endif

if (syst_pockets==1)
    remove_nondominant  # cleans up weaker worlds originally established as dominant
    printf("Saving influence array data.\n");
    temp=[newdir "-pocketinfluence.mat"];
    save(temp, "planetinflu");
  endif

# work on determining aliens  

# make sure full_alien function is loaded
a=exist("alien");
if (a==0)
    full_alien
  endif
rac=0;   #count of random races in the cluster
if (syst_race<13)
   for a=1:length(sys(:,1,1))
      for b=1:length(sys(1,:,1))
        for c=1:length(sys(a,b,:))
          if ((sys(a,b,c).native>0)*(sys(a,b,c).starnum>0)*(syst_race<13))    #is there a native race and a star?
              new=alien(sys(a,b,c));   #create, print, and identify it
              xenowrite(new);
              new.name= input("What is the name of this race?", "s");
              sys(a,b,c).race=new;
              newrace(rac+1)=sys(a,b,c);
              printf("\n\n\n");
              rac=rac+1;
            endif
          endfor
        endfor
      endfor  
  endif
if (rac==0)
    newrace=0;
  else
    chdir(newdir);
    save "newrace.mat" newrace   # save the races separately for later population distribution
    chdir(olddir);
    save "newrace.mat" newrace   # save the races separately for later population distribution
  endif  
      
if ((syst_popfind==1)*(syst_racebypocket==0)*(syst_favorable==1)) # requires 3 conditions to be correct
    full_populate      # populate each sector and finally save subsector mat files
  endif

if (syst_racebypocket==1)
    racial_empires
  endif  

if (syst_personalities==1)
    setting_personalities
  endif  

#fixes that are not working elsewhere
for a=1:length(sys(:,1,1))
  for b=1:length(sys(1,:,1))
    clear trav
    for c=1:length(sys(1,1,:))
      if (sys(a,b,c).starnum>0)
          if (sys(a,b,c).native>0)
              for d=1:sys(a,b,c).race.traits
                if (sys(a,b,c).race.trait(d)==70) # feral homeworlds of maximum tech level
                    sys(a,b,c).tech=min(sys(a,b,c).tech,9);
                  elseif (sys(a,b,c).race.trait(d)==23)  # psionic homeworlds approve of psionics
                    sys(a,b,c).personality(13)=max(sys(a,b,c).personality(13),10);
                  endif
                endfor
            endif
        endif
      endfor
    endfor
  endfor
  #print out maps after everything has been adjusted
for a=1:length(sys(:,1,1))
  for b=1:length(sys(1,:,1))
    clear trav
    for c=1:length(sys(1,1,:))
      if (sys(a,b,c).starnum>0)
          trav(c)= sys(a,b,c);
        endif
      endfor  
    trav_mapping;
    endfor
  endfor  

chdir(newdir);
temp=[newdir "_array.mat"];  
save(temp, "sys*");   # save setting as one big array along with syst* variables

# combine sys variables into a new linear array
clear tr
cnt=1;
for a=1:length(sys(:,1,1))
  for b=1:length(sys(1,:,1))
    for c=1:length(sys(a,b,:))
      if (sys(a,b,c).starnum>0)
          tr(cnt)=sys(a,b,c);     # only add if there is a system there
          cnt=cnt+1;
        endif
      endfor
    endfor
  endfor
temp= [newdir "_linear.mat"];
save(temp, "tr"); 

chdir(olddir);
csvsetting(sys, newdir, olddir);      # make csv file for python/javascript functions

# full_printsector    # print all subsector text files about the setting
html_printsector
 
# full_map_subsectors   # print out an overview of subsectors
html_print_all_sectors   # print a single combined summary text file for the setting

# move assisting files to setting directory
tempname= [newdir "-*.mat"];
movefile(tempname,newdir);


clear functions

trav=sys;
jpeg_map

cd(olddir);
delete "newrace.mat"

more on
 #}
