# create alien race based on a given homeworld

# race            structure descriptions
# .name           name of the race
# .homeworld      system, planet moon of origin
# .sector         2 numbers X and Y
# .subsectname    name of subsector
# .subsector      2 numbers x and y location within subsector
# .str(2)         str(1)=dice  str(2)=pips
# .dex(2)         dex(1)=dice  dex(2)=pips
# .endu(2)        endu(1)=dice  endu(2)=pips
# .edu(2)         edu(1)=dice  edu(2)=pips
# .int(2)         int(1)=dice  int(2)=pips
# .soc(2)         soc(1)=dice  soc(2)=pips
# .psy(2)         psy(1)=dice  psy(2)=pips

# .ecotype(2)     ecotype(1)= primary ecological type, ecotype(2)= subtype
# .height(2)      height(1)=base, height(2)=d6 added
# .weight(2)      weight(1)=base, weight(2)=d6 added
# .aging(3)       aging(1)= starting age, aging(2)=#terms before aging, aging(3)=modifier
# .size           1=tiny, 2=small, 3=medium, 4=large, 5=huge
# .gender         0=asexual, 1=hermaphrodite, 2=2 genders, n=1d3+2 genders
# .reproduction   1=budding, 2=live bearing, 3=eggs
# .breathe        0=producer, 1=air, 2=water, 3= either
# .swimmer        0=no, 1=yes, 2=exclusive
# .climber        0=no, 1=yes
# .flier          0=no, 1=yes, 2=exclusive
# .burrow         0=no, 1=yes
# .symmetry       1=radial, 2=bilateral, 3=trilateral
# .limbs          # of limbs total (flight, arms, legs, fins, etc)
# .arms           # of limbs useable as manipulative limbs
# .legs           # of limbs used for land movement
# .dual           # of limbs for manipulation or movement
# .armor          # of points of natural armor
# .weapon         # type(s) of natural weapon(s)

# .swims          rate of swimming speed
# .flys           rate of flying speed
# .digs           rate of burrowing speed
# .climbs         rate of climbing speed
# .land           rate of land movement speed
# .vision         0=blind, 1= poor vision, 2= normal, 3 acute vision
# .vocalize       0=no vocal communication, 1= makes sounds
# .hearing        0=deaf, 1= poor hearing, 2= normal, 3= acute hearing, 4= outstanding hearing
# .scent          0=anosmic, 1= poor scent, 2= normal, 3= scent, 4= acute scent

# .traits         number of traits a race has (relates to the trait array below)
# .trait()        array of values regarding special alien characteristics
#                 1=  acid resistance
#                 2=  acid vulnerability
#                 3=  altitude adaptation
#                 4=  regeneration
#                 5=  bad first impression
#                 6=  blind-fighter
#                 7=  cold endurance
#                 8=  cold resistance; fire vulnerability
#                 9=  electricity resistance
#                 10= observant
#                 11= fast healing
#                 12= fire resistance; cold vulnerability
#                 13= frightful presence
#                 14= good first impression
#                 15= heat endurance
#                 16= hibernation
#                 17= improved grab
#                 18= improved grab: constrict
#                 19= improved grab: entangle
#                 20= improved reach
#                 21= no fine manipulators
#                 22= pleasant odor
#                 23= psionic
#                 24= radiation resistance
#                 25= anti-psionic
#                 26= resistant to diseases
#                 27= resistant to fear
#                 28= resistant to poisons
#                 29= resistant to psionics
#                 30= spitting attack
#                 31= unusual hand structure
#                 32= major unusual life support requirement
#                 33= minor unusual life support requirement
#                 34= unusual sleep cycle
#                 35= xenoempathy
#                 36= alertness
#                 37= athletic
#                 38= offensive stench
#                 39= closed book
#                 40= eidetic memory
#                 41= fast talker
#                 42= gearhead
#                 43= bioelectric shock
#                 44= haggler
#                 45= interrogator
#                 46= intolerant
#                 47= natural advocate
#                 48= natural born leader
#                 49= natural compass
#                 50= natural pilot
#                 51= natural survivalist
#                 52= natural thief
#                 53= naturally honest
#                 54= overly aggressive
#                 55= racial defense
#                 56= racial enemy
#                 57= racial phobia
#                 58= racial weapon
#                 59= well traveled
#                 60= trustworthy
#                 
#                 
#                 63= amphibious
#                 64= aquatic
#                 65= burst of speed
#                 66= cold blooded
#                 67= fast metabolism
#                 68= deep diver
#                 69= desert adaptation
#                 70= feral
#                 71= fragile
#                 72= gravity intolerance
#                 73= heavy gravity adaptation
#                 74= low gravity adaptation
#                 75= slow metabolism
#                 76= stability
#                 77= stalwart movement
#                 78= taint immunity
#                 79= taint breather
#                 80= trace breather
#                 81= trace breather, limited
#                 82= vacuum survival, limited
#                 83= water dependent
#                 84= atmospheric requirement
#                 85= natural swimmer
#                 86= gendermorphic
#                 87= no land movement
#                 88= multiple limbs
#                 89= slow speed
#                 90= fast speed
#                 91= armored
#                 92= natural weapon
#                 93= poisonous
#                 94= no vocal cords
#                 95= organic radio communication
#                 96= vibration sense
#                 97= telepathy, limited
#                 98= telepathy
#                 99= light sensitivity
#                 100= color blindness
#                 101= low-light vision
#                 102= IR vision
#                 103= UV vision


a=1;

function d=roll(a)  # roll a number of d6
  d=0;
  for b=1:a
    d=d+ceil(rand()*6);
    endfor  
  endfunction
  
function stp=stepper(m)
  a=roll(2)+m;
  if (a<-8)
      stp=-5;
    elseif (a<-5)
      stp=-4;
    elseif (a<-2)
      stp=-3;
    elseif (a<1)
      stp=-2;
    elseif (a<4)
      stp=-1;
    elseif (a<11)
      stp=0;
    elseif (a<14)
      stp=1;
    elseif (a<17)
      stp=2;
    elseif (a<20)
      stp=3;
    elseif (a<23)
      stp=4;
    else
      stp=5;
    endif
  endfunction
  

function race=alien(sys)   #pass the home system to the alien function

full_variables

# identify and extract the native species homeworld info
    hsize=sys.habit.size(sys.native);
    race.homename=sys.name;
    race.subsectname= sys.subsectname;
    race.subsector=sys.subsector;
    race.sector=sys.sector;
    
if (sys.habit.moon(sys.native)==0)
    hgravity=sys.gravity(sys.habit.planet(sys.native));
  else
    hgravity=sys.moon.gravity(sys.habit.planet(sys.native),sys.habit.moon(sys.native));
  endif  
    hatm=sys.habit.atm(sys.native);
    hhydro=sys.habit.hydro(sys.native);
    htemp=sys.habit.temp(sys.native);

#determine homeworld name
if (sys.habit.companion(sys.native)==0)
    bas=sys.habit.planet(sys.native);
    if (sys.starlocation==0)
        let="";
      elseif (sys.starlocation==1)
        let="AB";
      else
        let="A";
      endif
  else
    if (sys.planets==sys.companions)
        bas=sys.habit.planet(sys.native);
      else
        bas=sys.habit.planet(sys.native)- (sys.planets-sys.companions);
      endif 
    if (sys.starlocation==2)
        let="B";
      else
        let="C";
      endif
  endif

if (sys.habit.moon(sys.native)>0)
    race.homeworld= [sys.name,'-' let char('a'-1+bas) num2str(sys.habit.moon(sys.native))]; 
  else
    race.homeworld= [sys.name,'-' let char('a'-1+bas)]; 
  endif    
 
# assign traits based upon homeworld physical properties
race.traits=0;          # total number of racial traits assigned
rcnt=1;                 # count of the current trait array
race.trait(rcnt)=1;

if (hgravity<0.35)              # assign traits based on gravity
    race.trait(rcnt)=72;
    race.trait(rcnt+1)=74;
    rcnt=rcnt+2;
  elseif (hgravity<0.70)
    race.trait(rcnt)=74;
    rcnt=rcnt+1;
  elseif (hgravity>1.20)
    race.trait(rcnt)=73;
    rcnt=rcnt+1;
  endif

if (hatm<4)                      # assign traits based on homeworld atmosphere
    if (roll(2)>10)
        race.trait(rcnt)=80;
        race.trait(rcnt+1)=82;
        rcnt=rcnt+2;
      else
        race.trait(rcnt)=81;
        rcnt=rcnt+1;
      endif
  elseif (hatm>9)
    race.trait(rcnt)=84;
    rcnt=rcnt+1;
  endif
if ((hatm==2)+(hatm==4)+(hatm==7)+(hatm==9))
    if (roll(2)>8) 
        race.trait(rcnt)=78;
      else
        race.trait(rcnt)=79;
      endif
    rcnt=rcnt+1;
  endif

race.breathe=1;
race.swimmer=0;                   # default air breather, no special swimmer
b=0;                              #
if (hhydro<2)                     # assign traits based on hydrographics
    race.trait(rcnt)=69;
    rcnt=rcnt+1;
  elseif (hhydro>7)
    aqu=(hhydro-7)*2;
    if (roll(1)<(aqu+1))
        race.trait(rcnt)=64;
        race.swimmer=1+ (roll(1)<3);
        rcnt=rcnt+1;
        race.breathe=2 + (roll(2)>8);
        if (roll(1)>2)
            race.trait(rcnt)=83;
            rcnt=rcnt+1;
          endif
        if (roll(1)>2)
            race.trait(rcnt)=85;
            rcnt=rcnt+1;
          endif
        
      else
        race.trait(rcnt)=63;
        rcnt=rcnt+1;
        race.breathe=1 + 2*(roll(2)>8);
        race.swimmer=1;
        if (roll(1)>4)
            race.trait(rcnt)=83;
            rcnt=rcnt+1;
          endif
        if (roll(1)>4)
            race.trait(rcnt)=85;
            rcnt=rcnt+1;
          endif
      endif


#{
  elseif (hhydro==10)
    race.trait(rcnt)=64;                      # aquatic
    race.swimmer=1+(roll(2)>8);
    race.breathe=1+(roll(2)>6)+(roll(2)>7);   # may be air, water, or either
    race.trait(rcnt+1)=85;
    rcnt=rcnt+2;
  elseif (hhydro>7)
    if (roll(2)>8)
        race.trait(rcnt)=63;
        race.breathe=1+2*(roll(2)>8);  #may be air or either breather
        race.swimmer=1;
        rcnt=rcnt+1;
        if (roll(2)>7)
            race.trait(rcnt)=85;
            rcnt=rcnt+1;
          endif  
      if (roll(2)<hhydro)
          race.trait(rcnt)=83;
          rcnt=rcnt+1;
        endif  
      endif
#}
  endif

for b=1:rcnt-1                              # natural swimmers can be deep divers
  if ((race.trait(b)==85)*(roll(2)>8))
      race.trait(rcnt)=68;
      rcnt=rcnt+1;
    endif
  endfor  
            

if (htemp<3)                       #assign traits based on temperature
  race.trait(rcnt)=7;
  rcnt=rcnt+1;
  endif
if (htemp<2)
  race.trait(rcnt)=8;
  rcnt=rcnt+1;
  endif
if (htemp>5)
  race.trait(rcnt)=15;
  rcnt=rcnt+1;
  endif
if (htemp>6)
  race.trait(rcnt)=12;
  rcnt=rcnt+1;
  endif
  
  
# determine the primary and secondary ecotype for the native species
a=roll(2);
b=roll(2);

if (a==2)
    race.ecotype(1)=1;       # producer- makes own food at least sometimes
    race.breathe=0;
    novac=0;
    for b=1:(rcnt-1)
      novac=novac+(race.trait(b)==82);
      endfor
    if (novac==0)    
        race.trait(rcnt)=82;
      endif
    if (roll(1)>4)
        race.trait(rcnt+1)=84;
        rcnt=rcnt+2;
      else
        rcnt=rcnt+1;
      endif
    if (b==2)
        race.ecotype(2)=1;
      elseif (b<8)
        race.ecotype(2)=2;
      elseif (b<10)
        race.ecotype(2)=3;
      elseif (b<11)
        race.ecotype(2)=4;
      else
        race.ecotype(2)=5;
      endif  
  elseif (a<6)              # herbivore- fruits and veges only
    race.ecotype(1)=3;
    if (b<4)
        race.ecotype(2)=1;
      elseif (b<8)
        race.ecotype(2)=2;
      else
        race.ecotype(2)=3;
      endif  
  elseif (a<10)             # omnivore- plants and animals
    race.ecotype(1)=4;
    if (b<5)
        race.ecotype(2)=1;
      elseif (b<10)
        race.ecotype(2)=2;
      else
        race.ecotype(2)=3;
      endif  
  elseif (a<11)            
    race.ecotype(1)=2;       # scavenger- eats the leftovers of others
    if (b==2)
        race.ecotype(2)=1;
      elseif (b<5)
        race.ecotype(2)=2;
      elseif (b<10)
        race.ecotype(2)=3;
      else
        race.ecotype(2)=4;
      endif  
  else
    race.ecotype(1)=5;       # carnivore- meat eater only
    if (b<5)
        race.ecotype(2)=1;
      elseif (b<6)
        race.ecotype(2)=2;
      elseif (b<10)
        race.ecotype(2)=3;
      elseif (b<11)
        race.ecotype(2)=4;
      else
        race.ecotype(2)=5;
      endif  
  endif

# determine metabolism
if (roll(2)>10)
    race.trait(rcnt)= 66;
    rcnt=rcnt+1;
  endif
if (roll(2)>10)
    race.trait(rcnt)=67;
    rcnt=rcnt+1;
  elseif (roll(2)>10)
    race.trait(rcnt)=75;
    rcnt+rcnt+1;
  endif  
  
  
  
# determine genders
a=roll(2);
if (a<3)
    race.gender=0;
  elseif (a<5)
    race.gender=1;
  elseif (a>11)
    race.gender=ceil(roll(1)/2)+2;
  else
    race.gender=2;
  endif
if (roll(2)>11)*(race.gender>1)        # rare to have genders switching if 2+
    race.trait(rcnt)=86;
    rcnt=rcnt+1;
  endif
if (race.gender==1)(roll(2)>8)         # common to have gender switching in hermaphrodites
    race.trait(rcnt)=86;
    rcnt=rcnt+1;
  endif

# determine reproductive method
a=roll(2);
a=a+3*(race.gender==0);
for b=1:(rcnt-1)
  a=a-3*(race.trait(b)==66);
  endfor 
if (a==2)
    race.reproduction=1;
  elseif (a<9)
    race.reproduction=2;
  else
    race.reproduction=3;
  endif

# determine locomotion (climber, burrower, flyer)
race.burrow=0;
race.flier=0;
race.climber=0;
a=roll(2);
if ((a==2)*(race.swimmer==0))
    race.burrow=1;
    race.digs= 0.2*roll(1);
  elseif ((a==5)*(race.swimmer==0))
    race.climber=1;
  endif  
a=roll(2);                        # low grav/atm ratio, not climber or burrower
a=a+ (((hatm==6)+(hatm==7))*10*(hgravity<0.6)*abs(hgravity-.5));
a=a+ (((hatm==8)+(hatm==9))*10*(hgravity<0.9)*abs(hgravity-.8));
a=a*(hgravity<.9);
a=a*(hgravity<0.6*(hatm>4)*(hatm<10));
a=a*(race.burrow==0)*(race.climber==0)*(race.swimmer==0);
race.flier=(a>9)+(a>9)*(roll(2)>9);

# determine size
a=roll(2);
a=a-(hsize>7);
a=a+(hsize<5);
a=a-3*(race.burrow==1);          # burrowing and flying races are smaller
a=a-(race.flier*2);
for b=1:rcnt-1
  a=a+2*(race.trait(b)==85);     # natural swimmers are larger
  endfor
if (a<3)
    race.size=1;
  elseif (a<5)
    race.size=2;
  elseif (a<11)
    race.size=3;
  elseif (a<14)
    race.size=4;
  else
    race.size=5;
  endif
  
# body symmetry and limbs
a=roll(2);
race.dual=0;
race.arms=0;
race.legs=0;
if (a==2)
    race.symmetry=3;
    race.limbs=3*(ceil(roll(1)/2)+1);
  elseif (a==12)
    race.symmetry=1;
    race.limbs= (ceil(roll(1)/2))+ceil(roll(1)/2)+1;
  else
    race.symmetry=2;
    race.limbs=4;
    if (a>10)
        race.limbs=race.limbs+2*roll(1);
      elseif (a>9)
        race.limbs=8;
      elseif (a>8)  
        race.limbs=6;
      endif
  endif
if (race.flier==2)                      #no legs for exclusive swimmers/fliers
    race.trait(rcnt)=87;
    rcnt=rcnt+1;
    race.legs=0;
    race.arms=race.limbs-race.symmetry;
  endif
if (race.swimmer==2)
    race.trait(rcnt)=87;
    rcnt=rcnt+1;
    race.legs=0;
    race.arms=race.limbs-race.symmetry;
  endif
if (race.symmetry==3)                    #trilateral symmetry choices
    a=race.limbs/3;
    if ((race.flier==1)+(race.swimmer==1))  
        a=a-1;
        race.dual=3*(a==1);
        race.legs=3*(a>1)*(a-1);
        race.arms=3*(a>1);
      elseif ((race.flier==0)+(race.swimmer==0))
        b=roll(2);
        race.dual= race.limbs*(b>9);
        race.legs= (b<10)* 3*(ceil(rand()*(a-1)));        
        race.arms= race.limbs-race.legs-race.dual;
        if (race.arms>3)
            race.trait(rcnt)=88;
            rcnt=rcnt+1;
          endif  
      endif
    if race.legs>2
        race.trait(rcnt)=76;
        rcnt=rcnt+1;
      endif  
  endif
if (race.symmetry==1)                   #radial symmetry
  if ((race.flier==2)+(race.swimmer==2))
      race.arms=race.limbs-floor(rand()*race.limbs);
      race.legs=0;
    else  
      b=roll(2);
      if (b<7)
          race.dual=race.limbs;
          race.trait(rcnt)=76;
          rcnt=rcnt+1;
        else
          race.legs=max(2,ceil(rand()*(race.limbs-1)));
          race.arms=race.limbs-race.legs;
        endif
      if (race.arms>2)
          race.trait(rcnt)=88;
          rcnt=rcnt+1;
        endif
      if (race.legs>2)
          race.trait(rcnt)=76;
          rcnt=rcnt+1;
        endif
    endif
  endif

if (race.symmetry==2)                  #bilateral symmetry
    if ((race.swimmer==2)+(race.flier==2))  
        race.arms=ceil(rand()*(race.limbs/2))*2;
        race.legs=0;
      elseif ((race.swimmer==1)+(race.flier==1))
        a=race.limbs/2;
        if (roll(2)<10)
            race.legs= 2*(1+ floor(rand()*(a-2)));   
            race.arms= 2*(race.swimmer+ floor(rand()*(a-1-(race.legs/2))));
          else
            race.dual=race.limbs-2*floor(race.flier+rand()*(a-2));
          endif  
      else
        a=race.limbs/2;
        if (roll(2)<10)
            race.legs=2*ceil(rand()*(a-1));
            race.arms=race.limbs-race.legs;
          else
            race.dual=race.limbs;
          endif  
      endif
    if ((race.legs>(roll(1)+2))+(race.dual>(roll(1)+3)))
        race.trait(rcnt)=76;
        rcnt=rcnt+1;
      endif
    if ((race.arms>2)+(race.dual>2))
        race.trait(rcnt)=88;
        rcnt=rcnt+1;
      endif
  endif

# movement rates for non-burrowers
race.climbs=0;
race.swims=0;
race.flys=0;
if (race.burrow==0)
  race.digs=0;
  endif
speed(1,:)=[-4 -2 -3 -2 -1];
speed(2,:)=[-2 0 2 0 0];
speed(3,:)=[1 0 1 0 0];
speed(4,:)=[0 2 -2 -2 1];
speed(5,:)=[0 0 0 0 0];  
landmove(1,:)=[1.5 3 4.5];
landmove(2,:)=[3 4.5 6];
landmove(3,:)=[4.5 6 9];
landmove(4,:)=[6 9 12];
landmove(5,:)=[6 9 12];
land4(1,:)=[1.5 1.5 1.5];
land4(2,:)=[3 3 3];
land4(3,:)=[1.5 3 3];
land4(4,:)=[3 3 3];
land4(5,:)=[3 3 3];
flymove(1,:)=[4.5 6 7.5];
flymove(2,:)=[6 9 12];
flymove(3,:)=[6 12 18];
flymove(4,:)=[12 18 24];
flymove(5,:)=[15 21 27];

a=roll(2);
a=a+ speed(race.ecotype(1),race.ecotype(2)); 
if (a<4)
    sm=1;
  elseif (a<11)
    sm=2;
  else
    sm=3;
  endif 
if ((race.flier==2)+(race.swimmer==2))    # identify land movers
    race.land=0;
  else
    race.land=landmove(race.size,sm) + (race.legs>3)*land4(race.size,sm);
  endif
if (race.swimmer>0)         #swimmers
    race.swims=6*sm;
  endif
if (race.climber==1)
    race.climbs=3*sm + 1.5*(sm==0);
  endif
if (race.flier>0)            #fliers
    race.flys=flymove(race.size,sm);
  endif
if (race.land<6)             # slow or fast land movement
    race.trait(rcnt)=89;
    rcnt=rcnt+1;
  elseif (race.land>8)
    race.trait(rcnt)=90;
    rcnt=rcnt+1;
  endif
a=roll(2)-(sm==1);          # check for burst of speed
if a>10
    race.trait(rcnt)= 65;
    rcnt=rcnt+1;
  endif
a=roll(2)-(sm==2);          # check for stalwart movement
if a>10
    race.trait(rcnt)=77;
    rcnt=rcnt+1;
  endif  

# is the race feral?
a=-2*((sys.starport=='A')+(sys.starport=='B'));
a=2*((sys.starport=='E')+(sys.starport=='X'));
if ((a+roll(2))>11)
    race.trait(rcnt)=70;
    sys.tech=min(9, sys.tech);  # feral homeworlds cannot have better tech than 9
    rcnt=rcnt+1;
  endif

# determine ability modifiers
m=floor((hgravity-1)/.2);
m=m+ 3*(race.ecotype(1)==2)+ 3*(race.ecotype(1)==5)- 3*(race.ecotype(1)==1);
strm= stepper(m);

m=3*(race.ecotype(1)==5) - 3*(race.ecotype(1)==2) -3*(race.ecotype(1)==1);
m=m- 2*strm;
dexm= stepper(m);

m=floor((hgravity-1)/.3);
m=m+3*(race.size==5) -3*(race.ecotype(1)==1);
m=m-2*(strm+dexm);
endm= stepper(m);

m=2*(sys.starport=='A') - 2*((sys.starport=='E')+(sys.starport=='X'));
m=m - 2*sys.restriction -2*(strm+dexm+endm);
edum= stepper(m);

m=-2*(strm+dexm+endm+edum);
intm= stepper(m);

m=1*(sys.starport=='A') - 1*(sys.starport=='E')-2*(sys.starport=='X');
m=m+floor((sys.tech-11)/2) -2*sys.restriction -2*(strm+dexm+endm+edum+intm);
socm= stepper(m);

m=-2*(strm+dexm+endm+edum+socm);
psym= stepper(m);

# determine abilities
stra=[3 4 6 8 9];
dexa=[9 8 6 4 3];
enda=[3 4 6 8 9];

st=stra(race.size)+strm;
st=max(st,2);
st=min(st,14);
race.str(1)=ceil(st/3);
race.str(2)=st-3*race.str(1);

dx=dexa(race.size)+dexm;
dx=max(dx,3);
dx=min(dx,10);
race.dex(1)=ceil(dx/3);
race.dex(2)=dx-3*race.dex(1);

en=enda(race.size)+endm;
en=max(en,4);
en=min(en,14);
race.endu(1)=ceil(en/3);
race.endu(2)=en-3*race.endu(1);

so=6+socm;
so=max(so,3);
so=min(so,7);
race.soc(1)=2;
race.soc(2)=so-3*race.soc(1);

ed=6+edum;
race.edu(1)=2;
for a=1:rcnt-1
  if (race.trait(a)==70)
      race.edu(1)=1;
      ed=ed-3;
    endif
  endfor  
ed=max(ed,3);
ed=min(ed,9);
race.edu(2)=ed-3*race.edu(1);

in=6+intm;
in=max(in,4);
in=min(in,10);
race.int(1)=2;
race.int(2)=in-3*race.int(1);

# natural armor determination
a=roll(2)+ 4*(race.flier>0);
race.armor=0;
if (a>11)
    race.trait(rcnt)=71;
    rcnt=rcnt+1;
    race.armor=0;
  else
    b=roll(2)-1*(race.ecotype(1)==5)+ 1*(race.ecotype(1)==1)+ 1*(race.ecotype(1)==4);
    b=b+2*(race.ecotype(1)==2)-1*(race.size==1)+3*(race.size==4)+ 6*(race.size==5);
    if b>10
        race.trait(rcnt)=91;
        rcnt=rcnt+1;
        race.armor=ceil((b-10)/2);
      endif
  endif

# natural weaponry
weap=['none'; 'teeth'; 'horns'; 'hooves and teeth'; 'hooves'; 'teeth'; 'claws'; 'a stinger'; 'a thrasher'; 'claws and teeth'; 'claws'; 'teeth'];
a=roll(2)+3*(race.ecotype(1)==5)-20*(race.ecotype(1)==1)- 1*(race.ecotype(1)==4)-2*(race.ecotype(1)==2);
b=1;
if (a>9)
    race.trait(rcnt)=92;
    rcnt=rcnt+1;
    b=roll(2);
  endif
race.weapon=strtrim(weap(b,:));
a=roll(2);
if ((a>9)*((b/2)==ceil(b/2)))
    race.trait(rcnt)=93;
    rcnt=rcnt+1;
  elseif ((b==8)*(a<10))
    race.trait(rcnt)=93;
    rcnt=rcnt+1;
  endif

# vision
a=roll(2);
if (a<8)
    race.vision=2;
  else
    b=roll(2);
    if (b==2)
        race.vision=0;
        race.trait(rcnt)=6;
        race.trait(rcnt+1)=96;
        rcnt=rcnt+2;
      elseif (b==3)
        race.vision=1;
        race.trait(rcnt)=99;
        rcnt=rcnt+1;
      elseif (b==4)
        race.trait(rcnt)=99;
        rcnt=rcnt+1;
        race.vision=2;
      elseif (b==5)
        race.vision=2;
        race.trait(rcnt)=100;
        rcnt=rcnt+1;
      elseif (b==6)
        race.vision=1;
        race.trait(rcnt)=100;
        rcnt=rcnt+1;
      elseif (b==7)
        race.vision=1;
      elseif (b==8)
        race.vision=3;
        race.trait(rcnt)=101;
        rcnt=rcnt+1;
      elseif (b==9)
        race.vision=3;
        race.trait(rcnt)=102;
        rcnt=rcnt+1;
      elseif (b==10)
        race.vision=3;
        race.trait(rcnt)=103;
      elseif (b==11)
        race.vision=3;
        race.trait(rcnt)=102;
        race.trait(rcnt+1)=103;
        rcnt=rcnt+2;
      else
        race.vision=3;
        race.trait(rcnt)=96;
        race.trait(rcnt+1)=102;  
        rcnt=rcnt+2;
      endif  
  endif

# hearing
a=roll(2);
if (a<10)
    race.hearing=2;
  else
    b=roll(2);
    if (b==2)
        race.hearing=0;
        race.trait(rcnt)=94;
        rcnt=rcnt+1;
      elseif (b<8)
        race.hearing=1;
      else
        race.hearing=3;
      endif
  endif
if ((roll(2)==12)*(b>2))
    race.trait(rcnt)=94;
    rcnt=rcnt+1;
  endif
  
# scent
a=roll(2);
if (a<10)
    race.scent=2;
  else
    b=roll(2);
    if (b==2)
        race.scent=0;
      elseif (b<8)
        race.scent=1;
      else
        race.scent=3;
      endif
  endif

# special senses
if (roll(2)>10)
    a=roll(2);
    if (a==2)
        race.trait(rcnt)=95;
        rcnt=rcnt+1;
      elseif (a<5)
        race.trait(rcnt)=96;
        rcnt=rcnt+1;
      elseif (a<10)
        race.trait(rcnt)=36;
        rcnt=rcnt+1;
      elseif (a<12)
        race.trait(rcnt)=97;
        rcnt=rcnt+1;
      else
        race.trait(rcnt)=98;
        rcnt=rcnt+1;
      endif
  endif

#determine aging variables
ag(1,:)=[10 10 14 14 18 18 18 22 22 26 30];
ag(2,:)=[8 8 12 12 16 16 20 20 24 28 28];
ag(3,:)=[ -2 -1 -1 0 0 0 0 0 +1 +1 +2];
race.aging(1)=ag(1, roll(2)-1);
race.aging(2)=ag(2, roll(2)-1);
race.aging(3)=ag(3, roll(2)-1);

#height and weight
ht(1,:)=[28 45 90 170 270];
ht(2,:)=[2 5 8 10 10];
wt(1,:)=[5 6 30 105 260];
wt(2,:)=[1 3 8 15 20];  
wt(3,:)=[1 3 6 10 15];
a=roll(2)+ floor((hgravity-.9)/.3);
race.height(1)= ht(1,race.size)+ a*ht(2,race.size);
race.weight(1)= wt(1,race.size)+ a*wt(2,race.size);
race.height(2)=2*race.size;
race.weight(2)=wt(3,race.size);

#3 additional traits
for a=1:3
  b=ceil(rand()*20);
  c=b+(a-1)*20;
  e=0;
  for d=1:(rcnt-1)
    if (c==race.trait(d))     # look for incompatable traits and repeats
        e=1;
      elseif ((c==25)*((race.trait(d)==97)+(race.trait(d)==98)))
        e=1;
      elseif (((c==29)+(c==39))*((race.trait(d)==97)+(race.trait(d)==98)))
        e=1;
      elseif ((c==21)*(race.trait(d)==94))
        e=1;
      elseif (((c==22)+(c==48))*(race.trait(d)==5))
        e=1;
      elseif ((c==53)*(race.trait(d)==39))
        e=1;
      elseif ((c==4)*(race.trait(d)==71))
        e=1; 
      elseif (((c==7)+(c==8))*((race.trait(d)==12)+(race.trait(d)==15)))
        e=1;
      elseif (((c==12)+(c==15))*((race.trait(d)==7)+(race.trait(d)==8)))
        e=1;
      elseif ((c==42)*((race.trait(d)==70)+(race.trait(d)==21)))
        e=1;
      elseif (((c==54)+(c==56)+(c==46))*(race.trait(d)==35))
        e=1;
      elseif (((c==52)+(c==42))*(race.trait(d)==21))
        e=1;
      elseif ((c==37)*(race.trait(d)==71))
        e=1;       
      endif  
    endfor    
  if (e>0)
      a=a-1;
    else
      race.trait(rcnt)=c;
      rcnt=rcnt+1;
    endif
  endfor

# calculate psionics after all traits including anti-psion, telepathy, etc are determined
ps=6+psym;
psycnt=[0 0 0];
for a=1:(rcnt-1)
  if (race.trait(a)==25)+(race.trait(a)==29)
      psycnt(1)=1;
    elseif (race.trait(a)==23)
      psycnt(2)=1;
    elseif (race.trait(a)==98)
      psycnt(3)=1;
    endif
  if (race.trait(a)==70)
      sys.tech=min(sys.tech,9);
    endif
  endfor  
if (psycnt(1)==1)
    race.psy(1)=0;
    race.psy(2)=0;
  elseif (psycnt(2)==1)
    race.psy(1)=3;
    race.psy(2)=ps-3*race.psy(1)+2;
  elseif (psycnt(3)==1)
    race.psy(1)=2;
    race.psy(2)=ps-3*race.psy(1)+1;
  else
    race.psy(1)=2;
    race.psy(2)=ps-3*race.psy(1);
  endif

race.traits=rcnt-1;
endfunction  

function xenowrite(race)
# assign names and capabilities to racial abilities
trt(1,:)= 'acid resistance';
trt=cellstr(trt);
desc(1,:)= 'reduces damage caused by acid 50%';
desc=cellstr(desc);

trt(2,:)= 'acid vulnerability';
desc(2,:)= 'allows acid to do 50% extra damage';
trt(3,:)= 'altitude adaptation';
desc(3,:)= 'automatically adapted to high altitude/lower oxygen conditions';
trt(4,:)= 'regeneration';
desc(4,:)= 'allows healing in hours instead of days and allows limbs to regrow';
trt(5,:)= 'bad first impression';
desc(5,:)= 'causes immediate, temporary unfriendly attitude due to appearance/odor';
trt(6,:)= 'blind-fighter';
desc(6,:)= 'allows half normal combat penalties due to lack of vision';
trt(7,:)= 'cold endurance';
desc(7,:)= 'comfortable in the cold, receives -1d6 cold damage';
trt(8,:)= 'cold resistance; fire vulnerability';
desc(8,:)= 'cold adapted.  Half damage from cold, but 50% more from fire';
trt(9,:)= 'electricity resistance';
desc(9,:)= 'reduces damage caused by electricity by 50%';
trt(10,:)= 'observant';
desc(10,:)= 'allows a +2 DM bonus on recon checks';
trt(11,:)= 'fast healing';
desc(11,:)= 'causes +1d6 additional healing per day';
trt(12,:)= 'fire resistance; cold vulnerability';
desc(12,:)= 'heat adapted.  Half damage from fire, but 50% more from cold';
trt(13,:)= 'frightful presence';
desc(13,:)= 'make a leadership skill check or be intimidated with a -1 DM';
trt(14,:)= 'good first impression';
desc(14,:)= 'causes immediate, temporary friendly attitude due to appearance/odor';
trt(15,:)= 'heat endurance';
desc(15,:)= 'comfortable in hot environments, receives -1d6 fire damage';
trt(16,:)= 'hibernation';
desc(16,:)= 'ability to voluntarily enter a deep sleep for up to End days';
trt(17,:)= 'improved grab';
desc(17,:)= 'gives a +2 melee skill in grappling attacks';
trt(18,:)= 'improved grab: constrict';
desc(18,:)= 'gives a +1 melee skill in grappling with 1d6 squeezing damage';
trt(19,:)= 'improved grab: entangle';
desc(19,:)= 'gives a +1 melee skill in grappling with continued holding';
trt(20,:)= 'improved reach';
desc(20,:)= 'gives a +1.5m reach beyond normal for their size';
trt(21,:)= 'no fine manipulators';
desc(21,:)= 'lacks ability to manipulate small items';
trt(22,:)= 'pleasant odor';
desc(22,:)= 'gives +2 DM to detect by scent, make Int check or be unwilling to harm them';
trt(23,:)= 'psionic';
desc(23,:)= 'nearly all members of the species are psionic';
trt(24,:)= 'radiation resistance';
desc(24,:)= 'reduces all radiation exposures by 100 rads';
trt(25,:)= 'anti-psionic';
desc(25,:)= 'gives immunity to psionic abilities, cannot be trained in psionics';
trt(26,:)= 'resistant to diseases';
desc(26,:)= 'gives +2 DM End checks on infections and diseases';
trt(27,:)= 'resistant to fear';
desc(27,:)= 'gives +2 DM on skill checks against fear and intimidation';
trt(28,:)= 'resistant to poisons';
desc(28,:)= 'gives +2 DM on End checks against toxins and poisons';
trt(29,:)= 'resistant to psionics';
desc(29,:)= 'gives +2 DM against all psionics, cannot be trained in psionics';
trt(30,:)= 'spitting attack';
desc(30,:)= 'gives a short range, 1d6 acid attack using athletics skill';
trt(31,:)= 'unusual hand structure';
desc(31,:)= 'gives -1 DM for using instruments designed for humans';
trt(32,:)= 'major unusual life support requirement';
desc(32,:)= 'requires a particular substance or will die from dehydration equivalent';
trt(33,:)= 'minor unusual life support requirement';
desc(33,:)= 'requires a particular substance or will die from starvation equivalent';
trt(34,:)= 'unusual sleep cycle';
desc(34,:)= 'requires sleep on an irregular cycle- unable to adjust physiologically';
trt(35,:)= 'xenoempathy';
desc(35,:)= 'gives +2 DM on carouse rolls due to understanding other species';
trt(36,:)= 'alertness';
desc(36,:)= 'gives a +2 DM on perception based skill checks';
trt(37,:)= 'athletic';
desc(37,:)= 'gives a +2 DM on all athletics skill checks';
trt(38,:)= 'offensive stench';
desc(38,:)= 'causes anyone smelling to make an End check or have -1 DM until leaving the area';
trt(39,:)= 'closed book';
desc(39,:)= 'gives a -2 DM when being read or sensed by others';
trt(40,:)= 'eidetic memory';
desc(40,:)= 'gives perfect memory of previously obtained information';
trt(41,:)= 'fast talker';
desc(41,:)= 'gives +2 DM to verbal deception skill checks';
trt(42,:)= 'gearhead';
desc(42,:)= 'gives a +2 DM for mechanics repair checks';
trt(43,:)= 'bioelectric shock';
desc(43,:)= 'delivers a 1d6 electric shock by touch once per 12 hours';
trt(44,:)= 'haggler';
desc(44,:)= 'gives a +2 DM for any broker check';
trt(45,:)= 'interrogator';
desc(45,:)= 'gives a +2 DM for attempts to extract information from another being';
trt(46,:)= 'intolerant';
desc(46,:)= 'character must make an Int check or take offense at an insult';
trt(47,:)= 'natural advocate';
desc(47,:)= 'gives a +2 DM on advocate checks due to legal tendency';
trt(48,:)= 'natural born leader';
desc(48,:)= 'gives a +2 DM on leadership checks due to species charisma';
trt(49,:)= 'natural compass';
desc(49,:)= 'senses magnetic fields, giving a +2 DM on navigation checks on planets';
trt(50,:)= 'natural pilot';
desc(50,:)= 'gives a +2 DM on pilot checks due to 3D spatial perception';
trt(51,:)= 'natural survivalist';
desc(51,:)= 'gives a +2 DM on survival checks in natural settings';
trt(52,:)= 'natural thief';
desc(52,:)= 'gives a +2 DM on deception checks';
trt(53,:)= 'naturally honest';
desc(53,:)= 'gives a -4 DM when the sophont is telling a lie';
trt(54,:)= 'overly aggressive';
desc(54,:)= 'gives a +2 DM on initiative checks due to violent tendencies';
trt(55,:)= 'racial defense';
desc(55,:)= 'gives a +2 defense bonus in personal combat against a single race';
trt(56,:)= 'racial enemy';
desc(56,:)= 'gives a +1 attack bonus against a single racial enemy';
trt(57,:)= 'racial phobia';
desc(57,:)= 'forces a sophont to make an Int check to overcome their phobia';
trt(58,:)= 'racial weapon';
desc(58,:)= 'gives a +1 attack bonus when using a single historically important weapon';
trt(59,:)= 'well traveled';
desc(59,:)= 'gives a +2 DM on liason checks due to cultural familiarity';
trt(60,:)= 'trustworthy';
desc(60,:)= 'gives -2 DM to bribery, deception, and streetwise checks';
#                 
#                 
trt(63,:)= 'amphibious';
desc(63,:)= 'lives part time in land and water';
trt(64,:)= 'aquatic';
desc(64,:)= 'lives life entirely in the water- can leave for short periods';
trt(65,:)= 'burst of speed';
desc(65,:)= 'move 1.5 m/sec faster than stated speed for End minutes';
trt(66,:)= 'cold blooded';
desc(66,:)= 'gives a -2 DM initiative in cold envrionments; +2 DM vs being found by IR';
trt(67,:)= 'fast metabolism';
desc(67,:)= 'gives a +2 DM initiative, requires 2x life support costs';
trt(68,:)= 'deep diver';
desc(68,:)= 'allows air breathing sophont to dive as deep as 240m';
trt(69,:)= 'desert adaptation';
desc(69,:)= 'gives +2 DM for survival and navigation in desert environments';
trt(70,:)= 'feral';
desc(70,:)= 'uneducatable- roll 1d6 Edu only';
trt(71,:)= 'fragile';
desc(71,:)= 'suffers 1.5x more damage from blunt weapons';
trt(72,:)= 'gravity intolerance';
desc(72,:)= 'gives a -2 DM in normal gravity, -4 DM in high gravity';
trt(73,:)= 'heavy gravity adaptation';
desc(73,:)= 'automatically adapted to high gravity environments';
trt(74,:)= 'low gravity adaptation';
desc(74,:)= 'automatically adapted to low gravity environments';
trt(75,:)= 'slow metabolism';
desc(75,:)= 'gives a -2 DM to initiative, requires only 50% of life support costs';
trt(76,:)= 'stability';
desc(76,:)= 'gives +2 DM to resist forced movement when standing';
trt(77,:)= 'stalwart movement';
desc(77,:)= 'allows movement at full normal speed even when encumbered';
trt(78,:)= 'taint immunity';
desc(78,:)= 'unaffected by presence or absence of atmospheric taint';
trt(79,:)= 'taint breather';
desc(79,:)= 'requires atmospheric taint; treat stnd atmo as tainted';
trt(80,:)= 'trace breather';
desc(80,:)= 'can breathe trace atmospheres without difficulty, but cannot breathe dense atmospheres';
trt(81,:)= 'trace breather, limited';
desc(81,:)= 'allows safely breathing a trace atmosphere for up to 1 hr';
trt(82,:)= 'vacuum survival, limited';
desc(82,:)= 'allows sophont to live for 15 minutes in zero atmosphere safely';
trt(83,:)= 'water dependent';
desc(83,:)= 'sophont can only survive out of the water for 1 hr per 2 pts End';
trt(84,:)= 'atmospheric requirement';
desc(84,:)= 'sophont requires an atmosphere very similar to their own';
trt(85,:)= 'natural swimmer';
desc(85,:)= 'gives a +2 DM on all swimming related skill checks';
trt(86,:)= 'gendermorphic';
desc(86,:)= 'sophont can switch genders over 2d6 days under certain conditions';
trt(87,:)= 'no land movement';
desc(87,:)= 'species does not have an effective way to move around on land';
trt(88,:)= 'multiple limbs';
desc(88,:)= 'species gains one additional action with no penalty- racial multitasking';
trt(89,:)= 'slow speed';
desc(89,:)= 'species moves at a slower speed than humans (less than 6 m/sec)';
trt(90,:)= 'fast speed';
desc(90,:)= 'species moves at a faster speed than humans (more than 8 m/sec)';
trt(91,:)= 'armored';
desc(91,:)= 'species possesses a natural protective armor';
trt(92,:)= 'natural weapon';
desc(92,:)= 'species body has one or more 1d6 weapons as part of their body';
trt(93,:)= 'poisonous';
desc(93,:)= 'bite or stinger attack is poisonous, -1d6 End if End check is failed';
trt(94,:)= 'no vocal cords';
desc(94,:)= 'sophonts lack the physical ability to make vocal noises';
trt(95,:)= 'organic radio communication';
desc(95,:)= 'species can listen and transmit radio waves over 5km distances';
trt(96,:)= 'vibration sense';
desc(96,:)= 'species can detect shapes and locations without light using sound';
trt(97,:)= 'telepathy, limited';
desc(97,:)= 'allows 1.5m range mental communication with any creature with a language';
trt(98,:)= 'telepathy';
desc(98,:)= 'allows medium range mental communication with any creature with a language';
trt(99,:)= 'light sensitivity';
desc(99,:)= 'quick bright light causes blindness for 1 minute.  -1 DM operating in bright light';
trt(100,:)= 'color blindness';
desc(100,:)= 'sophont perceives the world in shades of gray';
trt(101,:)= 'low-light vision';
desc(101,:)= 'species can determine color and detail 2x farther than humans in low light';
trt(102,:)= 'IR vision';
desc(102,:)= 'species sees into the IR (heat) spectrum';
trt(103,:)= 'UV vision';
desc(103,:)= 'species sees into the UV spectrum- sees ionization, electric plasmas';

et1=['producer'; 'scavenger'; 'herbivore'; 'omnivore'; 'carnivore'];
etp=['passive'; 'supplementer'; 'trapper'; 'siren'; 'active'];
ets=['reducer'; 'hijacker'; 'intimidator'; 'carrion-eater'];
eth=['filter'; 'intermittent'; 'grazer'];
eto=['gatherer'; 'hunter'; 'eater'];
etc=['pouncer'; 'trapper'; 'chaser'; 'siren'; 'killer'];
if (race.ecotype(1)==1)
    et=etp(race.ecotype(2),:);
  elseif (race.ecotype(1)==2)
    et=ets(race.ecotype(2),:);
  elseif (race.ecotype(1)==3)
    et=eth(race.ecotype(2),:);
  elseif (race.ecotype(1)==4)
    et=eto(race.ecotype(2),:);
  elseif (race.ecotype(1)==5)
    et=etc(race.ecotype(2),:);
  endif
et=strtrim(et);  
breath=['do not need to breathe'; 'breathe air'; 'breathe water'; 'breathe air or water'];
siz=['tiny'; 'small'; 'average'; 'large'; 'huge']; 
gend=['asexual'; 'hermaphrodites'; 'have 2 genders'; 'have 3 genders'; 'have 4 genders'; 'have 5 genders'];
offsp=['by budding'; 'by bearing their young'; 'by laying eggs'];
symm=['radially'; 'bilaterally'; 'trilaterally'];

more off
 
printf("\n\nThe native sophont species of %s is derived from %s-%s stock.\n", strtrim(race.homeworld(:)), strtrim(et1(race.ecotype(1),:)),et);
printf("%s is located in the %s subsector[%d %d] at location X-%d Y-%d.\n", race.homename, race.subsectname, race.sector(1), race.sector(2), race.subsector(1), race.subsector(2)); 
printf("They %s and are %s in size, standing %d+%dd6 cm tall and weighing %d+%dd6 kg.\n",strtrim(breath(race.breathe+1,:)), strtrim(siz(race.size,:)), race.height(1), race.height(2),race.weight(1),race.weight(2));
printf("They are %s symmetric, %s, and reproduce %s.\n", strtrim(symm(race.symmetry,:)), strtrim(gend(race.gender+1,:)), strtrim(offsp(race.reproduction,:)));
printf("\nThey have %d limbs,", race.limbs);
if (race.limbs==race.dual)
    printf(" all");
  endif  
if (race.dual>0)
    printf(" %d of which can be used as arms or legs.\n", race.dual);
  else
    printf(" %d of which are arms and %d of which are legs.\n", race.arms, race.legs);  
  endif
printf("Using their limbs, they are ");
if (race.land==0)
    printf("unable to effectively move on land.\n");
  else
    printf("able to move at %d meters per second on land.\n", race.land);
  endif  
wing=race.limbs-race.dual-race.arms-race.legs;
if (wing==0)
    meth='lighter than air gasses';
  else
    wing=wing/race.symmetry;
    meth=strcat(num2str(wing),' set(s) of wings');
  endif  
if (race.flier>0)
    printf("The race is able to fly at %d m/sec using %s.\n", race.flys, meth);
  endif
if (race.swimmer>0)
    printf("The race is at home in the water and able to swim at %d m/sec.\n", race.swims);  
  endif
if (race.burrow>0)
    printf("The race is also able to burrow through the ground at %d m/sec.\n", race.digs);
  endif
if (race.climber>0)
    printf("The race is also able to climb remarkably well, climbing at %d m/sec.\n", race.climbs);
  endif
printf("\nThe race matures at age %d, has %d years in its prime, then begins aging with a ", race.aging(1), race.aging(2));
if (race.aging(3)>0)
    printf("+");
  endif
printf("%d DM modifier.\n", race.aging(3));
printf("Their primary characteristic scores are:\n"); 
printf("Str: %dd6",race.str(1));
if (race.str(2)>0)
    printf("+%d   ",race.str(2));
  elseif (race.str(2)==0)
    printf("      ");
  else
    printf("%d    ",race.str(2));
  endif
printf("Dex: %dd6",race.dex(1));
if (race.dex(2)>0)
    printf("+%d   ",race.dex(2));
  elseif (race.dex(2)==0)
    printf("      ");
  else
    printf("%d    ",race.dex(2));
  endif
printf("End: %dd6",race.endu(1));
if (race.endu(2)>0)
    printf("+%d   ",race.endu(2));
  elseif (race.endu(2)==0)
    printf("      ");
  else
    printf("%d    ",race.endu(2));
  endif
printf("Edu: %dd6",race.edu(1));
if (race.edu(2)>0)
    printf("+%d   ",race.edu(2));
  elseif (race.edu(2)==0)
    printf("      ");
  else
    printf("%d    ",race.edu(2));
  endif
printf("Int: %dd6",race.int(1));
if (race.int(2)>0)
    printf("+%d   ",race.int(2));
  elseif (race.int(2)==0)
    printf("      ");
  else
    printf("%d    ",race.int(2));
  endif
printf("Soc: %dd6",race.soc(1));
if (race.soc(2)>0)
    printf("+%d   ",race.soc(2));
  elseif (race.soc(2)==0)
    printf("      ");
  else
    printf("%d    ",race.soc(2));
  endif
printf("Psy: %dd6",race.psy(1));
if (race.psy(2)>0)
    printf("+%d  \n",race.psy(2));
  elseif (race.psy(2)==0)
    printf("\n");
  else
    printf("%d\n",race.psy(2));
  endif
 
if (race.armor>0)
    printf("\nThey possesses %d points of natural armor.\n", race.armor);
  endif
if (length(race.weapon)>4)
    printf("They have %s which cause 1-6 points plus Str modifier of damage per hit.\n", race.weapon);
  endif
vis=['absent'; 'worse than human'; 'human norm'; 'better than human'];
printf("In terms of senses, their vision is %s, hearing is %s, and scent is %s.\n\n",strtrim(vis(race.vision+1,:)), strtrim(vis(race.hearing+1,:)), strtrim(vis(race.scent+1,:))); 
printf("These sophonts have the following special traits:\n");
for a=1:race.traits
  t=strvcat(trt(race.trait(a),:));
  d=strvcat(desc(race.trait(a),:));
  printf("   %s: %s\n",t,d);
  endfor
printf("\n\n\n");  

endfunction
