# function file for writing up a system description

#cycle through all the stars in the cluster, by sector
#for x=1:length(M3(:,1))
#  for y=1:length(M3(1,:))  


sa=0;                #count of type A starports
sb=0;                #count of type B starports
sc=0;                #count of type C starports
sd=0;                #count of type D starports
se=0;                #count of type E starports
sx=0;                #count of type F starports
snav=0;              #count of naval bases
ssco=0;              #count of scout bases
said=0;              #count of explorer's aid society hostels
scon=0;              #count of consulates
st=zeros(16,1);      #counts of trade arrays
stech=0;             #for calculating average tech levels
slaw=0;              #for calculating average law level 
shab=0;              #for calculating average number of habitable worlds per system
  shabe=0;                 # easily habitable worlds
  shabs=0;                 # semi-habitable worlds
  shabb=0;                 # barely habitable worlds
  whab=zeros(15,1);        # count the number of systems with x habitable worlds
spop=0;               #number of uninhabited systems
snat=0;               #number of homeworlds in subsector
sgdp=0;               #GDP sum for averaging across worlds
smoo=0;               #best moons count
vas=0;                #frontier system counts
obs=0;                #observer system count
mem=0;                #member system count
adv=0;                #advisory system counts
amb=0;                #amber system counts
red=0;                #red system counts
sgovs=zeros(15,1);    #count of government types
stl=zeros(16,1);      #count of tech levels
slaws=zeros(10,1);    #count of each law level
demop=zeros(300,1);   #demographics of all races
demow=zeros(300,1);   #count of worlds with each race
spo=0;                #total population
spops=zeros(11,1);    #count of worlds with different population sizes
svegs=0;              #count of vestigial worlds
savi=0;               #count of avian favored worlds
sins=0;               #count of insectan favored worlds
smer=0;               #count of merfolk favored worlds
srep=0;               #count of reptilian favored worlds
stemps=zeros(10,1);   #count of temperatures of habitable worlds
sstars=0;             #total number of stars in star systems
sred=0;               #number of red stars
sora=0;               #number of orange stars
syel=0;               #number of yellow stars
swhi=0;               #number of white stars
mpoc=zeros(10,1);     #number of all pocket empires of 1-5, 6-10,... 46-50 in cluster
clear spoc;           #structure for independent pocket empires
spoc(1).name="";      #name of the pocket empire
spoc(1).loc=[0 0 0];  #location of the pocket empire in cluster
spoc(1).number=0;     #number of worlds in the pocket empires
spoc(1).combined=0;   #number of worlds in the combined pocket empires
spoc(1).independent=0; #base assumption is that the system is NOT independent
poccnt=1;             #count of independent pocket empires
clear dpoc;           #structure for dependent pocket empires
dpoc(1).name="";
dpoc(1).loc=[0 0 0];
dpoc(1).number=0;
dcnt=1;               #count of dependent pocket empires
cpoc=zeros(12,1);     #number of combined empires if bins of 5, like mpoc
ssizes=zeros(11,1);   #count of sizes of habitable planets
mconf=zeros(5,1);      #degree of indpendence from Confederation strength
gdpcnt=zeros(10,1);   #array for counting how many of a gdp bin there are


  
trav=tr;
cnt=length(tr)+1;



    
 # variables used for printing out key concepts 
restrict=['Green'; 'Amber'; 'Red'];
tradecodes=['Ag'; 'Ds'; 'Fl'; 'Ga'; 'Hi'; 'Ht'; 'Ic'; 'In'; 'Lo'; 'Lt'; 'Na'; 'Ni'; 'Po'; 'Ri'; 'Wa'; 'Va'];
habstring=['barely habitable'; 'semi- habitable'; 'easily habitable'];
govstring=['no effective government'; 'a corporation'; 'a participatory democracy'; 'an oligarchy'; 'a republic'; 'a feudal technocracy'; 'a captive government'; 'several balkanized states'; 'a civil service bureaucracy'; 'an impersonal bureaucracy'; 'a charismatic leader'; 'a non-charismatic dictator'; 'a charismatic oligarchy'; 'a religious dictatorship'];
facstring=['minimal'; 'weak'; 'notable'; 'significant'; 'powerful'];
tradestring=['agricultural'; 'desert'; 'fluid ocean'; 'garden'; 'high population'; 'high tech'; 'ice capped'; 'industrial'; 'low population'; 'low tech'; 'non-agricultural'; 'non-industrial'; 'poor'; 'rich'; 'water'; 'vacuum'];
tempstring=['alternating frozen and boiling'; 'frozen ice'; 'very cold'; 'cold'; 'cool'; 'temperate'; 'warm'; 'hot'; 'roasting'; 'boiling'];
atmostring=['no'; 'a trace'; 'a very thin tainted'; 'a very thin'; 'a thin, tainted'; 'a thin'; 'a standard'; 'a standard but tainted'; 'a dense normal'; 'a dense tainted'; 'an exotic'; 'a corrosive'; 'an insidious'; 'a very dense, unbreatheable'];
confedstring=['a frontier'; 'an observer'; 'a member'; 'an advisory'];
present=['-'; 'Y'];
rescode=['-'; 'A'; 'R'];
confed=['None'; 'Front'; ' Obs '; 'Memb '; 'Advis'];
favored=['Avians'; 'Insectans'; 'Merfolk'; 'Reptilians'];
nm=['human';'avian';'insectan';'merfolk';'reptilian';'uplifted ape';'uplifted feline';'uplifted mongoose';'uplifted dolphin'];
mconfstring=['puny'; 'weak'; 'equal'; 'solid'; 'overwhelming'];

# assign names and capabilities to racial abilities
trt(1,:)= 'acid resistance';
trt=cellstr(trt);
desc(1,:)= 'reduces damage caused by acid 50%';
desc=cellstr(desc);

trt(2,:)= 'acid vulnerability';
desc(2,:)= 'allows acid to do 50% extra damage';
trt(3,:)= 'altitude adaptation';
desc(3,:)= 'automatically adapted to high altitude/lower oxygen conditions';
trt(4,:)= 'regeneration';
desc(4,:)= 'allows healing in hours instead of days and allows limbs to regrow';
trt(5,:)= 'bad first impression';
desc(5,:)= 'causes immediate, temporary unfriendly attitude due to appearance/odor';
trt(6,:)= 'blind-fighter';
desc(6,:)= 'allows half normal combat penalties due to lack of vision';
trt(7,:)= 'cold endurance';
desc(7,:)= 'comfortable in the cold, receives -1d6 cold damage';
trt(8,:)= 'cold resistance; fire vulnerability';
desc(8,:)= 'cold adapted.  Half damage from cold, but 50% more from fire';
trt(9,:)= 'electricity resistance';
desc(9,:)= 'reduces damage caused by electricity by 50%';
trt(10,:)= 'observant';
desc(10,:)= 'allows a +2 DM bonus on recon checks';
trt(11,:)= 'fast healing';
desc(11,:)= 'causes +1d6 additional healing per day';
trt(12,:)= 'fire resistance; cold vulnerability';
desc(12,:)= 'heat adapted.  Half damage from fire, but 50% more from cold';
trt(13,:)= 'frightful presence';
desc(13,:)= 'make a leadership skill check or be intimidated with a -1 DM';
trt(14,:)= 'good first impression';
desc(14,:)= 'causes immediate, temporary friendly attitude due to appearance/odor';
trt(15,:)= 'heat endurance';
desc(15,:)= 'comfortable in hot environments, receives -1d6 fire damage';
trt(16,:)= 'hibernation';
desc(16,:)= 'ability to voluntarily enter a deep sleep for up to End days';
trt(17,:)= 'improved grab';
desc(17,:)= 'gives a +2 melee skill in grappling attacks';
trt(18,:)= 'improved grab: constrict';
desc(18,:)= 'gives a +1 melee skill in grappling with 1d6 squeezing damage';
trt(19,:)= 'improved grab: entangle';
desc(19,:)= 'gives a +1 melee skill in grappling with continued holding';
trt(20,:)= 'improved reach';
desc(20,:)= 'gives a +1.5m reach beyond normal for their size';
trt(21,:)= 'no fine manipulators';
desc(21,:)= 'lacks ability to manipulate small items';
trt(22,:)= 'pleasant odor';
desc(22,:)= 'gives +2 DM to detect by scent, make Int check or be unwilling to harm them';
trt(23,:)= 'psionic';
desc(23,:)= 'nearly all members of the species are psionic';
trt(24,:)= 'radiation resistance';
desc(24,:)= 'reduces all radiation exposures by 100 rads';
trt(25,:)= 'anti-psionic';
desc(25,:)= 'gives immunity to psionic abilities, cannot be trained in psionics';
trt(26,:)= 'resistant to diseases';
desc(26,:)= 'gives +2 DM End checks on infections and diseases';
trt(27,:)= 'resistant to fear';
desc(27,:)= 'gives +2 DM on skill checks against fear and intimidation';
trt(28,:)= 'resistant to poisons';
desc(28,:)= 'gives +2 DM on End checks against toxins and poisons';
trt(29,:)= 'resistant to psionics';
desc(29,:)= 'gives +2 DM against all psionics, cannot be trained in psionics';
trt(30,:)= 'spitting attack';
desc(30,:)= 'gives a short range, 1d6 acid attack using athletics skill';
trt(31,:)= 'unusual hand structure';
desc(31,:)= 'gives -1 DM for using instruments designed for humans';
trt(32,:)= 'major unusual life support requirement';
desc(32,:)= 'requires a particular substance or will die from dehydration equivalent';
trt(33,:)= 'minor unusual life support requirement';
desc(33,:)= 'requires a particular substance or will die from starvation equivalent';
trt(34,:)= 'unusual sleep cycle';
desc(34,:)= 'requires sleep on an irregular cycle- unable to adjust physiologically';
trt(35,:)= 'xenoempathy';
desc(35,:)= 'gives +2 DM on carouse rolls due to understanding other species';
trt(36,:)= 'alertness';
desc(36,:)= 'gives a +2 DM on perception based skill checks';
trt(37,:)= 'athletic';
desc(37,:)= 'gives a +2 DM on all athletics skill checks';
trt(38,:)= 'offensive stench';
desc(38,:)= 'causes anyone smelling to make an End check or have -1 DM until leaving the area';
trt(39,:)= 'closed book';
desc(39,:)= 'gives a -2 DM when being read or sensed by others';
trt(40,:)= 'eidetic memory';
desc(40,:)= 'gives perfect memory of previously obtained information';
trt(41,:)= 'fast talker';
desc(41,:)= 'gives +2 DM to verbal deception skill checks';
trt(42,:)= 'gearhead';
desc(42,:)= 'gives a +2 DM for mechanics repair checks';
trt(43,:)= 'bioelectric shock';
desc(43,:)= 'delivers a 1d6 electric shock by touch once per 12 hours';
trt(44,:)= 'haggler';
desc(44,:)= 'gives a +2 DM for any broker check';
trt(45,:)= 'interrogator';
desc(45,:)= 'gives a +2 DM for attempts to extract information from another being';
trt(46,:)= 'intolerant';
desc(46,:)= 'character must make an Int check or take offense at an insult';
trt(47,:)= 'natural advocate';
desc(47,:)= 'gives a +2 DM on advocate checks due to legal tendency';
trt(48,:)= 'natural born leader';
desc(48,:)= 'gives a +2 DM on leadership checks due to species charisma';
trt(49,:)= 'natural compass';
desc(49,:)= 'senses magnetic fields, giving a +2 DM on navigation checks on planets';
trt(50,:)= 'natural pilot';
desc(50,:)= 'gives a +2 DM on pilot checks due to 3D spatial perception';
trt(51,:)= 'natural survivalist';
desc(51,:)= 'gives a +2 DM on survival checks in natural settings';
trt(52,:)= 'natural thief';
desc(52,:)= 'gives a +2 DM on deception checks';
trt(53,:)= 'naturally honest';
desc(53,:)= 'gives a -4 DM when the sophont is telling a lie';
trt(54,:)= 'overly aggressive';
desc(54,:)= 'gives a +2 DM on initiative checks due to violent tendencies';
trt(55,:)= 'racial defense';
desc(55,:)= 'gives a +2 defense bonus in personal combat against a single race';
trt(56,:)= 'racial enemy';
desc(56,:)= 'gives a +1 attack bonus against a single racial enemy';
trt(57,:)= 'racial phobia';
desc(57,:)= 'forces a sophont to make an Int check to overcome their phobia';
trt(58,:)= 'racial weapon';
desc(58,:)= 'gives a +1 attack bonus when using a single historically important weapon';
trt(59,:)= 'well traveled';
desc(59,:)= 'gives a +2 DM on liason checks due to cultural familiarity';
trt(60,:)= 'trustworthy';
desc(60,:)= 'gives -2 DM to bribery, deception, and streetwise checks';
#                 
#                 
trt(63,:)= 'amphibious';
desc(63,:)= 'lives part time in land and water';
trt(64,:)= 'aquatic';
desc(64,:)= 'lives life entirely in the water- can leave for short periods';
trt(65,:)= 'burst of speed';
desc(65,:)= 'move 1.5 m/sec faster than stated speed for End minutes';
trt(66,:)= 'cold blooded';
desc(66,:)= 'gives a -2 DM initiative in cold envrionments; +2 DM vs being found by IR';
trt(67,:)= 'fast metabolism';
desc(67,:)= 'gives a +2 DM initiative, requires 2x life support costs';
trt(68,:)= 'deep diver';
desc(68,:)= 'allows air breathing sophont to dive as deep as 240m';
trt(69,:)= 'desert adaptation';
desc(69,:)= 'gives +2 DM for survival and navigation in desert environments';
trt(70,:)= 'feral';
desc(70,:)= 'uneducatable- roll 1d6 Edu only';
trt(71,:)= 'fragile';
desc(71,:)= 'suffers 1.5x more damage from blunt weapons';
trt(72,:)= 'gravity intolerance';
desc(72,:)= 'gives a -2 DM in normal gravity, -4 DM in high gravity';
trt(73,:)= 'heavy gravity adaptation';
desc(73,:)= 'automatically adapted to high gravity environments';
trt(74,:)= 'low gravity adaptation';
desc(74,:)= 'automatically adapted to low gravity environments';
trt(75,:)= 'slow metabolism';
desc(75,:)= 'gives a -2 DM to initiative, requires only 50% of life support costs';
trt(76,:)= 'stability';
desc(76,:)= 'gives +2 DM to resist forced movement when standing';
trt(77,:)= 'stalwart movement';
desc(77,:)= 'allows movement at full normal speed even when encumbered';
trt(78,:)= 'taint immunity';
desc(78,:)= 'unaffected by presence or absence of atmospheric taint';
trt(79,:)= 'taint breather';
desc(79,:)= 'requires atmospheric taint; treat stnd atmo as tainted';
trt(80,:)= 'trace breather';
desc(80,:)= 'can breathe trace atmospheres without difficulty, but cannot breathe dense atmospheres';
trt(81,:)= 'trace breather, limited';
desc(81,:)= 'allows safely breathing a trace atmosphere for up to 1 hr';
trt(82,:)= 'vacuum survival, limited';
desc(82,:)= 'allows sophont to live for 15 minutes in zero atmosphere safely';
trt(83,:)= 'water dependent';
desc(83,:)= 'sophont can only survive out of the water for 1 hr per 2 pts End';
trt(84,:)= 'atmospheric requirement';
desc(84,:)= 'sophont requires an atmosphere very similar to their own';
trt(85,:)= 'natural swimmer';
desc(85,:)= 'gives a +2 DM on all swimming related skill checks';
trt(86,:)= 'gendermorphic';
desc(86,:)= 'sophont can switch genders over 2d6 days under certain conditions';
trt(87,:)= 'no land movement';
desc(87,:)= 'species does not have an effective way to move around on land';
trt(88,:)= 'multiple limbs';
desc(88,:)= 'species gains one additional action with no penalty- racial multitasking';
trt(89,:)= 'slow speed';
desc(89,:)= 'species moves at a slower speed than humans (less than 6 m/sec)';
trt(90,:)= 'fast speed';
desc(90,:)= 'species moves at a faster speed than humans (more than 8 m/sec)';
trt(91,:)= 'armored';
desc(91,:)= 'species possesses a natural protective armor';
trt(92,:)= 'natural weapon';
desc(92,:)= 'species body has one or more 1d6 weapons as part of their body';
trt(93,:)= 'poisonous';
desc(93,:)= 'bite or stinger attack is poisonous, -1d6 End if End check is failed';
trt(94,:)= 'no vocal cords';
desc(94,:)= 'sophonts lack the physical ability to make vocal noises';
trt(95,:)= 'organic radio communication';
desc(95,:)= 'species can listen and transmit radio waves over 5km distances';
trt(96,:)= 'vibration sense';
desc(96,:)= 'species can detect shapes and locations without light using sound';
trt(97,:)= 'telepathy, limited';
desc(97,:)= 'allows 1.5m range mental communication with any creature with a language';
trt(98,:)= 'telepathy';
desc(98,:)= 'allows medium range mental communication with any creature with a language';
trt(99,:)= 'light sensitivity';
desc(99,:)= 'quick bright light causes blindness for 1 minute.  -1 DM operating in bright light';
trt(100,:)= 'color blindness';
desc(100,:)= 'sophont perceives the world in shades of gray';
trt(101,:)= 'low-light vision';
desc(101,:)= 'species can determine color and detail 2x farther than humans in low light';
trt(102,:)= 'IR vision';
desc(102,:)= 'species sees into the IR (heat) spectrum';
trt(103,:)= 'UV vision';
desc(103,:)= 'species sees into the UV spectrum- sees ionization, electric plasmas';

et1=['producer'; 'scavenger'; 'herbivore'; 'omnivore'; 'carnivore'];
etp=['passive'; 'supplementer'; 'trapper'; 'siren'; 'active'];
ets=['reducer'; 'hijacker'; 'intimidator'; 'carrion-eater'];
eth=['filter'; 'intermittent'; 'grazer'];
eto=['gatherer'; 'hunter'; 'eater'];
etc=['pouncer'; 'trapper'; 'chaser'; 'siren'; 'killer'];
breath=['do not need to breathe'; 'breathe air'; 'breathe water'; 'breathe air or water'];
siz=['tiny'; 'small'; 'average'; 'large'; 'huge']; 
gend=['asexual'; 'hermaphrodites'; 'have 2 genders'; 'have 3 genders'; 'have 4 genders'; 'have 5 genders'];
offsp=['by budding'; 'by bearing their young'; 'by laying eggs'];
symm=['radially'; 'bilaterally'; 'trilaterally'];



for j=1:cnt-1                      # cycle through all systems for accumulations

  snav=snav+trav(j).naval;
  ssco=ssco+trav(j).scout;
  said=said+trav(j).aid;
  scon=scon+trav(j).consul;
  for a=1:16
    st(a)=st(a)+trav(j).trade(a);
    endfor
  stech=stech+trav(j).tech;      #compile info about tech levels
  stl(trav(j).tech+1)=stl(trav(j).tech+1)+1;
  slaw=slaw+trav(j).law;         #compile info about law levels
  slaws(trav(j).law+1)=slaws(trav(j).law+1)+1;
  shab=shab+trav(j).habnum;

if ((syst_confederation==1)*(syst_pockets==1))  
  ctst=trav(j).influ.confed-influence(trav(j)); # compile info about confederation influence
  if (ctst>15)
      mconf(5)=mconf(5)+1;
    elseif (ctst>5)
      mconf(4)=mconf(4)+1;
    elseif (ctst>-5)
      mconf(3)=mconf(3)+1;
    elseif (ctst>-14)
      mconf(2)=mconf(2)+1;
    else
      mconf(1)=mconf(1)+1;
    endif 
endif
    
  spop=spop+ (trav(j).population==0);
  whab(trav(j).habnum+1)= whab(trav(j).habnum+1)+1;  # count how many hab worlds per system
  for a=1:trav(j).habnum      #compile info about habitable worlds
    shabe=shabe+ (trav(j).habit.good(a)==3);
    shabs=shabs+ (trav(j).habit.good(a)==2);
    shabb=shabb+ (trav(j).habit.good(a)==1);
    if (trav(j).habit.moon>0)
        f=trav(j).moon.favor(trav(j).habit.planet(a),trav(j).habit.moon(a));
      else
        f=trav(j).favor(trav(j).habit.planet(a));
      endif
    savi=savi+ (f==1);
    sins=sins+ (f==2);
    smer=smer+ (f==3);
    srep=srep+ (f==4);
    stemps(trav(j).habit.temp(a))=stemps(trav(j).habit.temp(a))+1;
    ssizes(trav(j).habit.size(a)+1)=ssizes(trav(j).habit.size(a)+1)+1;  
    endfor
  sgovs(trav(j).govern+1)=sgovs(trav(j).govern+1)+1;  
  sstars=sstars+ trav(j).starnum;  
  for a=1:trav(j).starnum     #compile info about stars in system
    sred=sred+ (trav(j).startype(a,1)=='r');
    sora=sora+ (trav(j).startype(a,1)=='o');
    syel=syel+ (trav(j).startype(a,1)=='y');
    swhi=swhi+ (trav(j).startype(a,1)=='w');
    endfor
  svegs=svegs+ ((trav(j).tech<8)*(trav(j).population<4)*(trav(j).population>0)); # count vestigial worlds  
  sgdp=sgdp+ trav(j).gdp;
  gdpcnt(ceil((trav(j).gdp+1)/10000))=gdpcnt(ceil((trav(j).gdp+1)/10000)) +1;
  smoo=smoo+ (trav(j).bestm>0);
  amb=amb+ (trav(j).restriction==1);
  red=red+ (trav(j).restriction==2);
  sa=sa+(trav(j).starport=='A');
  sb=sb+(trav(j).starport=='B');
  sc=sc+(trav(j).starport=='C');
  sd=sd+(trav(j).starport=='D');
  se=se+(trav(j).starport=='E');
  sx=sx+(trav(j).starport=='X');

if (syst_pockets==1)  
  if (trav(j).influ.independent==1)                   #compile info on pocket empires
      spoc(poccnt).loc(1)=trav(j).sector(1);
      spoc(poccnt).loc(2)=trav(j).sector(2);
      spoc(poccnt).loc(3)= j;
      spoc(poccnt).name =trav(j).name;
      spoc(poccnt).number=length(trav(j).influ.dominate)+(trav(j).influ.dominate(1)>0);
      spoc(poccnt).combined=length(trav(j).influ.dominate)+(trav(j).influ.dominate(1)>0);
      mpoc(ceil((spoc(poccnt).number)/5))=mpoc(ceil((spoc(poccnt).number)/5))+1;
      if (spoc(poccnt).number>1) # if they have an ally check to see if those have a pocket empire
          for a=1:length(trav(j).influ.dominate)
            b=trav(j).influ.ally(a,1);
            c=trav(j).influ.ally(a,2);
            d=trav(j).influ.ally(a,3);
            spoc(poccnt).combined= spoc(poccnt).combined+length(sys(b,c,d).influ.dominate)-1;
            if (sys(b,c,d).influ.dominate(1)>0)
                spoc(poccnt).combined=spoc(poccnt).combined+1;
              endif  
            endfor 
       endif
      cpoc(ceil((spoc(poccnt).combined)/5))=cpoc(ceil((spoc(poccnt).combined)/5))+1;
      poccnt=poccnt+1;
    elseif (trav(j).influ.dominate(1)>0)
      dpoc(dcnt).loc(1)=trav(j).sector(1);
      dpoc(dcnt).loc(2)=trav(j).sector(2);
      dpoc(dcnt).loc(3)= j;
      dpoc(dcnt).name =trav(j).name;
      dpoc(dcnt).number=length(trav(j).influ.dominate);
      mpoc(ceil(dpoc(dcnt).number/5))=mpoc(ceil(dpoc(dcnt).number/5))+1;
      dcnt=dcnt+1;
    endif
endif

spo=spo+ (trav(j).pop*10^trav(j).population); #compile information on populations
spops(trav(j).population+1)= spops(trav(j).population+1)+1;

if (syst_popfind==1)    
  test=vertcat(trav(j).populate.pn)(:,1);
  tpp=vertcat(trav(j).populate.pp)(:,1);
  snat=snat+ (trav(j).native>0);  
  if (test(1)<990)
      for a=1:length(test)                     #compile racial information
        demop(test(a)+1)=demop(test(a)+1)+ ceil(trav(j).pop*(10^(trav(j).population-2))*tpp(a));
        demow(test(a)+1)=demow(test(a)+1)+1;
        endfor
    endif    
endif

if (syst_confederation==1)
  vas=vas+ min(1,((trav(j).population<6)+(trav(j).tech<7)));
  obs=obs+ ((trav(j).population>5)*(trav(j).tech>6)) - ((trav(j).population>6)*(trav(j).tech>8));
  c= ((trav(j).population==10)*(trav(j).tech>12))+ ((trav(j).population==9)*(trav(j).tech==15));
  adv=adv+ c;
  mem=mem+ ((trav(j).population>6)*(trav(j).tech>8))- c;
endif
 
  endfor  

# print a subsector summary for all systems and overall subsector stats


# open the subsector file for printing
namefile= "Setting_Summary.txt";
fid= fopen(namefile, "at");
printf("printing %s.\n", namefile);
fflush(stdout);

# fid=stdout;

fprintf(fid, "    Setting Summary\n");
fprintf(fid, " #### Name        Subsector    primary UWP");
if (syst_confederation==1)
    fprintf(fid, " Nav Sco Con");
  endif
if (syst_explorer==1)
    fprintf(fid, " Aid");
  endif
fprintf(fid," Res Plan Gas Ast Habit");
if (syst_race<13)
    fprintf(fid," Native");
  endif
if (syst_hierarchy==1)
    fprintf(fid," Confed");
  endif
fprintf(fid,"  GDP(Cr) Trade\n");

for a=1:cnt-1
  if (trav(a).bestm==0)
      uwp=trav(a).uwp(trav(a).bestp,:);
    else
      for b=1:9
        uwp(b)=trav(a).moon.uwp(trav(a).bestp, trav(a).bestm,b);
        endfor
    endif  
  fprintf(fid, "%4d %12s %12s  %s", a, trav(a).name, trav(a).subsectname, uwp(:)); 
  if (syst_confederation==1)
      fprintf(fid, "   %s   %s   %s", present(trav(a).naval+1), present(trav(a).scout+1), present(trav(a).consul+1));
    endif
  if (syst_explorer==1)
      fprintf(fid,"   %s", present(trav(a).aid+1));
    endif
  fprintf(fid, "   %s   %2d   %d   %d   %2d", rescode(trav(a).restriction+1), trav(a).planets, trav(a).giants, trav(a).asteroids, trav(a).habnum);
  if (syst_race<13)
      fprintf(fid, "     %s", present((trav(a).native>0)+1));
    endif
  if (syst_hierarchy==1)
      fprintf(fid,"     %5s", confed(trav(a).confed+1,:));
    endif  
  fprintf(fid,"     %5s   ", num2str(trav(a).gdp));
      for b=1:16
    if (trav(a).trade(b)>0)
        fprintf(fid, "%s ", tradecodes(b,:));
      endif
    endfor  
  fprintf(fid, "\n");    
  endfor
if (syst_confederation==1)
    fprintf(fid, "\nNaval bases: %d    Scout bases: %d   Consulates: %d\n", snav, ssco, scon);
  endif
fprintf(fid, "\nStarports:  A-%d   B-%d   C-%d   D-%d   E-%d   X-%d",sa, sb, sc, sd, se, sx);
if (syst_explorer==1)
    fprintf(fid, "   Explorer's Hostels-%d\n", said);
  else
    fprintf(fid, "\n");
  endif  
fprintf(fid, "\navg tech:%.3d  avg law:%.3d  avg habnum:%.3d,  avg GDP:%5d,  uninhabited systems:%d\n", (stech/(cnt-1)), (slaw/(cnt-1)), (shab/(cnt-1)), (sgdp/(cnt-1)), spop);
fprintf(fid, "Total Stars:%d   red type M:%d  orange type K:%d  yellow type G:%d  white type F:%d\n", sstars, sred, sora, syel, swhi);
fprintf(fid, "\n    World and System Summaries\n");
fprintf(fid, "easily habitable:%d  semi-habitable:%d  barely habitable:%d  vestigial:%d   amber:%d  red:%d\n", shabe, shabs, shabb, svegs, amb, red);
if (syst_race<13)
    fprintf(fid, "homeworlds:%d   ", snat);
  endif
if (syst_favorable==1)
    fprintf(fid, "avian favored:%d   insectan favored:%d   merfolk favored:%d   reptilian favored:%d\n", savi, sins, smer, srep);
  else
    fprintf(fid, "\n");
  endif  
fprintf(fid, "\n    Habitable World Temperatures\n");
for a=3:9
  fprintf(fid, "%s-%d  ", strtrim(tempstring(a,:)), stemps(a-2));
  endfor
fprintf(fid, "\n\n    Habitable World Sizes\n");  
for a=1:11
  fprintf(fid, "siz%d:%d  ", (a-1), ssizes(a));
  endfor
fprintf(fid, "\n\n    Habitable Worlds per System\n");
for a=1:15
  fprintf(fid, "%d:%d   ",(a-1), whab(a));
  endfor
fprintf(fid, "\n\n    Systems with Population Sizes\n");
  for a=1:11
  fprintf(fid, "pop #%d:%d  ",(a-1),spops(a));
  endfor
fprintf(fid, "\n\n    Systems with GDP Sizes\n");
  for a=1:10
  fprintf(fid, "%d-%dK:%d  ",(a-1)*10,a*10, gdpcnt(a));
  endfor
fprintf(fid, "\n\n    Trade Codes:\n");
for a=1:16
  fprintf(fid, "%s:%d  ",tradecodes(a,:), st(a));
  endfor
fprintf(fid, "\n\n    Local Law Levels:\n")
for a=1:10
  fprintf(fid, "law%d:%d   ", (a-1), slaws(a));
  endfor
fprintf(fid, "\n\n    Local Tech Levels\n")  
for a=1:8
  fprintf(fid, "TL%d:%d   ",(a-1), stl(a));
  endfor
fprintf(fid, "\n");
for a=9:16
  fprintf(fid, "TL%d:%d  ",(a-1), stl(a));
  endfor  
fprintf(fid, "\n\nSystems have the following types of local governments:\n")
for a=1:14
  fprintf(fid, "%s:%d \n", strtrim(govstring(a,:)), sgovs(a));
  endfor
if (syst_hierarchy==1)
    fprintf(fid, "\n    Confederation Government World Types\nfrontier worlds:%d   observer worlds:%d   member worlds:%d   advisory worlds:%d\n",vas, obs, mem, adv);
  endif
if (syst_confederation==1)
    fprintf(fid, "\nConfed vs. Local influence standing is ");
    for a=1:5
      fprintf(fid, "%s:%d  ",strtrim(mconfstring(a,:)), mconf(a));
      endfor
  endif

if (syst_pockets==1)  
fprintf(fid,"\n\n    Sizes of Individual Pocket Empires\n");
for a=1:10
  fprintf(fid, "%d-%d worlds: %d\n", (5*(a-1)+1), (5*a), mpoc(a));
  endfor
fprintf(fid,"\n    Sizes of Combined Pocket Empires\n");
for a=1:length(cpoc)
  fprintf(fid, "%d-%d worlds: %d\n", (5*(a-1)+1), (5*a), cpoc(a));
  endfor

fprintf(fid,"\n\n    Pocket Empires\n");
fprintf(fid,"There are %d independent pocket empires in this subsector.\n", (poccnt-1));
for a=1:poccnt-1
  fprintf(fid, "   %s influences %d systems directly", spoc(a).name, spoc(a).number);
  if (spoc(a).combined>spoc(a).number)
      fprintf(fid, " and %d systems overall.\n", spoc(a).combined);
    else
      fprintf(fid, ".\n");
    endif  
  endfor
fprintf(fid,"\nThere are %d allied worlds with their own pocket empires in this subsector.\n", (dcnt-1));
for a=1:dcnt-1
  fprintf(fid, "   %s has a pocket empire of %d worlds.\n", dpoc(a).name, dpoc(a).number);
  endfor  
endif
  
  
  fprintf(fid,"\n     People\nA total of %.3e sophonts live in this setting.\n", spo);

if (syst_popfind==1)
for a=1:9
  if (demop(a)>0)
      fprintf(fid, "   %.2e %ss live in %d systems.\n", demop(a), strtrim(nm(a,:)), demow(a));
    endif
  endfor

if (exist("newrace.mat")==2)
  for a=11:(length(newrace)+11)
    if (demop(a)>0)
        fprintf(fid, "   %.2e %ss live in %d systems. ", demop(a), strtrim(newrace(a-11).race.name), demow(a));
        fprintf(fid, "Their homeworld is %s in the %s subsector.\n", strtrim(newrace(a-11).race.homeworld),strtrim(newrace(a-11).race.subsectname));
      endif
    endfor
  endif  
endif
  
# print out summary of all native sophont races to this subsector
if (syst_race<13)  
fprintf(fid, "\nThere are %d native races in this setting.\n", snat);  
for j=1:cnt-1
  if (trav(j).native>0)
      race=trav(j).race;
      if (race.ecotype(1)==1)
          et=etp(race.ecotype(2),:);
        elseif (race.ecotype(1)==2)
          et=ets(race.ecotype(2),:);
        elseif (race.ecotype(1)==3)
          et=eth(race.ecotype(2),:);
        elseif (race.ecotype(1)==4)
          et=eto(race.ecotype(2),:);
        elseif (race.ecotype(1)==5)
          et=etc(race.ecotype(2),:);
        endif
      et=strtrim(et);  
      fprintf(fid, "\n\nThe native sophont species of %s is derived from %s-%s stock.\n", strtrim(race.homeworld(:)), strtrim(et1(race.ecotype(1),:)),et);
      fprintf(fid, "%s is located in the %s subsector[%d %d] at location X-%d Y-%d.\n", race.homename, race.subsectname, race.sector(1), race.sector(2), race.subsector(1), race.subsector(2)); 
      fprintf(fid, "They %s and are %s in size, standing %d+%dd6 cm tall and weighing %d+%dd6 kg.\n",strtrim(breath(race.breathe+1,:)), strtrim(siz(race.size,:)), race.height(1), race.height(2),race.weight(1),race.weight(2));
      fprintf(fid, "They are %s symmetric, %s, and reproduce %s.\n", strtrim(symm(race.symmetry,:)), strtrim(gend(race.gender+1,:)), strtrim(offsp(race.reproduction,:)));
      fprintf(fid, "\nThey have %d limbs,", race.limbs);
      if (race.limbs==race.dual)
          fprintf(fid, " all");
        endif  
      if (race.dual>0)
          fprintf(fid, " %d of which can be used as arms or legs.\n", race.dual);
        else
          fprintf(fid, " %d of which are arms and %d of which are legs.\n", race.arms, race.legs);  
        endif
      fprintf(fid, "Using their limbs, they are ");
      if (race.land==0)
          fprintf(fid, "unable to effectively move on land.\n");
        else
          fprintf(fid, "able to move at %d meters per second on land.\n", race.land);
        endif  
      wing=race.limbs-race.dual-race.arms-race.legs;
      if (wing==0)
          meth='lighter than air gasses';
        else
          wing=wing/race.symmetry;
          meth=strcat(num2str(wing),' set(s) of wings');
        endif  
      if (race.flier>0)
          fprintf(fid, "The race is able to fly at %d m/sec using %s.\n", race.flys, meth);
        endif
      if (race.swimmer>0)
          fprintf(fid, "The race is at home in the water and able to swim at %d m/sec.\n", race.swims);  
        endif
      if (race.burrow>0)
          fprintf(fid, "The race is also able to burrow through the ground at %d m/min.\n", race.digs);
        endif
      if (race.climber>0)
          fprintf(fid, "The race is also able to climb remarkably well, climbing at %d m/sec.\n", race.climbs);
        endif
      fprintf(fid, "\nThe race matures at age %d, has %d years in its prime, then begins aging with a ", race.aging(1), race.aging(2));
      if (race.aging(3)>0)
          fprintf(fid, "+");
        endif
      fprintf(fid, "%d DM modifier.\n", race.aging(3));
      fprintf(fid, "Their primary characteristic scores are:\n"); 
      fprintf(fid, "Str: %dd6",race.str(1));
      if (race.str(2)>0)
          fprintf(fid, "+%d   ",race.str(2));
        elseif (race.str(2)==0)
          fprintf(fid, "      ");
        else
          fprintf(fid, "%d    ",race.str(2));
        endif
      fprintf(fid, "Dex: %dd6",race.dex(1));
      if (race.dex(2)>0)
          fprintf(fid, "+%d   ",race.dex(2));
        elseif (race.dex(2)==0)
          fprintf(fid, "      ");
        else
          fprintf(fid, "%d    ",race.dex(2));
        endif
      fprintf(fid, "End: %dd6",race.endu(1));
      if (race.endu(2)>0)
          fprintf(fid, "+%d   ",race.endu(2));
        elseif (race.endu(2)==0)
          fprintf(fid, "      ");
        else
          fprintf(fid, "%d    ",race.endu(2));
        endif
      fprintf(fid, "Edu: %dd6",race.edu(1));
      if (race.edu(2)>0)
          fprintf(fid, "+%d   ",race.edu(2));
        elseif (race.edu(2)==0)
          fprintf(fid, "      ");
        else
          fprintf(fid, "%d    ",race.edu(2));
        endif
      fprintf(fid, "Int: %dd6",race.int(1));
      if (race.int(2)>0)
          fprintf(fid, "+%d   ",race.int(2));
        elseif (race.int(2)==0)
          fprintf(fid, "      ");
        else
          fprintf(fid, "%d    ",race.int(2));
        endif
      fprintf(fid, "Soc: %dd6",race.soc(1));
      if (race.soc(2)>0)
          fprintf(fid, "+%d\n",race.soc(2));
        elseif (race.soc(2)==0)
          fprintf(fid, "\n");
        else
          fprintf(fid, "%d\n\n",race.soc(2));
        endif
 
      if (race.armor>0)
          fprintf(fid, "They possesses %d points of natural armor.\n", race.armor);
        endif
      if (length(race.weapon)>4)
          fprintf(fid, "They have %s which cause d6 extra damage points per hit plus Str modifier.\n", race.weapon);
        endif
      vis=['absent'; 'worse than human'; 'human norm'; 'better than human'];
      fprintf(fid, "In terms of senses, their vision is %s, hearing is %s, and scent is %s.\n\n",strtrim(vis(race.vision+1,:)), strtrim(vis(race.hearing+1,:)), strtrim(vis(race.scent+1,:))); 
      fprintf(fid, "These sophonts have the following special traits:\n");
      for a=1:race.traits
        t=strvcat(trt(race.trait(a),:));
        d=strvcat(desc(race.trait(a),:));
        fprintf(fid, "   %s: %s\n",t,d);
        endfor
      fprintf(fid, "\n\n");  
    endif
  endfor  
endif



fclose(fid);
