#{
New Cepheus Cluster Variant System Generator

explicator of sy structure

sy.startype(1)          red, orange, yellow, white stars, white dwarf, brown dwarf
sy.startypenum()        number of the startype above
sy.starnum              number of stars in the system
sy.name                 name of the star system
sy.sector(1)            sector location [x,y]
sy.count                entry number within a sector
sy.fullcount            entry number in full linear array
sy.subsector(1)         subsector location [x,y]
sy.subsectname          name of the planet with the largest gdp in the subsector
sy.planets              number of planets in the system
sy.orbitcount(2)        array for primary and companion for inner, middle, and outer planet numbers
sy.giants               number of gas plus ice giants in the system
sy.asteroids            number of asteroid belts in the system
sy.population           log number of the population
sy.pop                  decimal part of the population
sy.gdp                  GDP of individuals
sy.gdpmod               gdp modifier based on system resources
sy.sysgdp               total (legal) gdp of the entire system for tax purposes
sy.law                  law level of the system
sy.govern               governmental type of the system
sy.factions             number of factions in the system
sy.faction(1)           strength of a faction (governing=7, 0= almost unknown)
sy.tech                 tech level of system (>7 if no habitable worlds)
sy.starport             highest level of starport available
sy.restriction          warning level of the system
  sy.naval              true if there is a naval base in the system
  sy.consul             true if there is a consulate in the system
  sy.aid                true if there is an explorer's society base in the system
  sy.scout              true if there is a scout base in the system
sy.trade(1)             array of trade code values
sy.habnum               number of even barely habitable worlds in the system
sy.bestp                most habitable planet (always non-zero)
sy.bestm                0 if the planet, #>0 if a moon
sy.native               number of the habitable world with a native species
sy.planet(1)            size of each individual planet
sy.orbit(1)             orbital distance of each planet in millions of km
sy.gravity(1)           gravity of each planet
sy.radius(1)            diameter of each planet
sy.rings(1)             # rings found around planets
sy.grav()               stellar masses of each star
sy.period               period of variable stars  1st digit is time frame, 2nd is the frequency
sy.atm(1)               planetary atmosphere
sy.hydro(1)             planetary hydrosphere
sy.temp(1)              planetary temperature
sy.habitable(1)         >0 if planet is habitable
sy.favor(1)             1=avians, 2=insectans, 3=merfolk, 4=reptiles

sy.uwp(1)               UWP of each planet
sy.smoons(1)            number of small moons per planet
sy.lmoons(1)            number of large moons per planet
sy.confed               level of confederation status: frontier, observer, member, advisory

sy.axis                 structure regarding axial tilt and rotation
  sy.axis.tilt(1)       axial tilt of planetary rotation
  sy.axis.rotation(1)   rotational period of the planet around its axis
sy.geothermal(1)        planet or moon has geothermal area able to (barely) support life 

sy.habit                structure of livable planets independent of moon or planetary nature
  sy.habit.good(1)      how habitable is the world (3= easily, 2= semi, 1= barely)
  sy.habit.planet(1)    planet number of the habitable world
  sy.habit.moon(1)      is the habitable world a moon (0=planet itself, >0 gives moon number)
  sy.habit.size(1)      size of the habitable worlds
  sy.habit.atm(1)       atmosphere of the habitable worlds
  sy.habit.hydro(1)     habitable world hydrosphere
  sy.habit.temp(1)      habitable world temperature
  sy.habit.native(1)    is there a native race on this moon?
  sy.habit.axis.temp(1) average actual temperature in degrees C
  sy.habit.axis.chg(1)  temperature change between equator and poles
  sy.habit.axis.sea(1)  seasonal temperature difference modifier
  sy.habit.companion(1) which companion the habitable planet orbits

sy.moon                 structure of moon characteristics
  sy.moon.atm(2)        atmosphere of each moon
  sy.moon.size(2)       size of each moon
  sy.moon.hydro(2)      hydrosphere of each moon
  sy.moon.temp(2)       temperature of each moon
  sy.moon.habitable(2)  true if moon is habitable
  sy.moon.uwp(2)        UWP of the moon
  sy.moon.gravity(2)    gives the gravity of each moon in g
  sy.moon.orbit(2)      give all large moons an orbital distance in thousands of km
  sy.moon.favor(2)      1=avians, 2=insectans, 3=merfolk, 4=reptiles
  sy.moon.radius(2)     give all large moons a diameter in km
sy.race                 structure from alien.m for natives on a planet (sy.native>0)
sy.transit(a,b)         matrix giving travel times between planets in a system
sy.populate             determine the type and percentage of species living in a system
  sy.populate.pn        first 10 are races from Cepheus, 11+ are minor races of M317
  sy.populate.pp        percentage of the population that are of race pn
  sy.populate.pname     name of the race with the given population
sy.influ                political/social influences on the system
  sy.influ.confed       confederation influence
  sy.influ.independent  is the system powerful enough to stand up to its neighbors
  sy.influ.score        how influential is the world doing the influencing
  sy.influ.ndx          what world is doing the influencing
  sy.influ.ally         system being dominated
  sy.influ.dominate     how dominated is the world?
  sy.influ.self         influence of the system itself
sy.popcenter(1)         array list of the major population center sizes
sy.personality(1)       15 personality characteristics of the system (#10 order isn't used)

sy.geothermal(1)           is a world geothermally habitable?
sy.axis.tilt(1)         tilt of a planet compared to the ecliptic
sy.axis.rotation(1)     what is the rotational period of the planet?
sy.starlocation         0=1 star, 1=close binary, 2=distant binary, 3= trinary, 1 close 1 distant 
sy.closeorbit           distance between 2 close companions
sy.distantorbit         distance to a distant companion (from the center of mass
sy.companion            0= primary star system; 1= distant companion system
sy.companions           number of companion planets
sy.planetlocate(1)      1=inner planet, 2=middle planet, 3= outer planet
  #}
a=0;
  
function d=roll(a)  # roll a number of d6
  d=0;
  for b=1:a
    d=d+ceil(rand()*6);
    endfor  
  endfunction

  
function at=atmosphere(s);   #give a world an atmosphere
  a=roll(2);
  if (s<2)                 #small moons
      at=0;
    elseif (s<4)           #mid-size moons
      if (a<6)
          at=0;
        elseif (a<8)
          at=1; 
        elseif (a<10)
          at=3;
        else
          at=2;
        endif
    elseif (s<6)           #large moons, small planets
      if (a<4)
          at=1;
        elseif (a<5)
          at=2;
        elseif (a<7)
          at=3;
        elseif (a<9)
          at=5;
        elseif (a<10)
          at=4;
        elseif (a<12)
          at=6;
        else
          at=7;
        endif
    elseif (s<8)            #mid-size planets
      if (a<4);
          at=4;
        elseif (a<6)
          at=5;
        elseif (a<8)
          at=6;
        elseif (a<9)
          at=7;
        elseif (a<11)
          at=8;
        elseif (a<12)
          at=10;
        else
          at=11;
        endif
    elseif (s<10)           # large planets  
      if (a<3)
          at=4;
        elseif (a<4)
          at=5;
        elseif (a<6)
          at=7;
        elseif (a<8)
          at=6;
        elseif (a<10)
          at=8;
        elseif (a<11)
          at=9;
        elseif (a<12)
          at=10;
        else
          at=12;
        endif
    elseif (s==10)                     #largest planets
      if (a<4)
          at=7;
        elseif (a<6)
          at=6;
        elseif (a<8)
          at=8;
        elseif (a<9)
          at=13;
        else
          at=a; 
        endif
    else
      at=15;
    endif
  
  endfunction
  
        
function sy=createsys()     

full_variables  # get common variables based on the setting

do             # loop until at least 1 star in a system emits light
a=roll(2);   # get the number of stars between 1 and 3
if (a<8)
    sy.starnum=1;
    sy.starlocation=0;        #single star
    sy.closeorbit=0;
    sy.distantorbit=0;
  else
    a=roll(2);
    if (a<7)
        sy.starnum=2;
        sy.starlocation=1;    # close binary
        sy.closeorbit=roll(3)+2;
        sy.distantorbit=0;
      elseif (a<11)
        sy.starnum=2;
        sy.starlocation=2;    # distant binary
        sy.closeorbit=0;
        sy.distantorbit=ceil(rand()*4000)+1000;
      else
        sy.starnum=3;
        sy.starlocation=3;    # trinary= 1 close and 1 distant companion
        sy.closeorbit=roll(3)+2;
        sy.distantorbit=ceil(rand()*5000)+1500;
      endif
  endif  

startypes=["red dwarf type M"; "orange type K"; "yellow type G"; "white type F"; "type D white dwarf"; "type T brown dwarf"];

  lum=0;
  clear tgrav
  sy.grav=[0,0,0];
  sttynum=[7 7 7];     
  for b=1:sy.starnum     # determine the types of stars in the system and the gravitic potential
    a=roll(2);
    if (syst_morestars==1)
        if (a<5)
            sttynum(b)=2;
            gravtemp=.5;
          elseif (a<8)
            sttynum(b)=1;
            gravtemp=0.25;
          elseif (a<9)
            sttynum(b)=5;
            gravtemp= (ceil(rand()*10)+5)/10;
          elseif (a<10)
            sttynum(b)=6;
            gravtemp=(ceil(rand*31)+30)/1000;
          elseif (a<12)
            sttynum(b)=3;
            gravtemp=1;
          elseif (a<13)
            sttynum(b)=4;
            gravtemp=2;
          endif
      else
        if (a<6)                # yellow stars
            sttynum(b)=3;
            gravtemp=1;
          elseif (a<9)          # red stars
            sttynum(b)=1;
            gravtemp=.25;
          elseif (a<12)         # orange stars
            sttynum(b)=2;
            gravtemp=.5;
          elseif (a<13)         # white stars
            sttynum(b)=4;
            gravtemp=2;
          endif
      endif   
    temptype(b,:)=startypes(sttynum(b),:);
    tgrav(b)=gravtemp*(1+((ceil(rand()*21)-10)/100));  
    endfor
  for a=1:sy.starnum
    lum=lum+(sttynum(a)<5);
    endfor
  until (lum>0)    #loop back if no stars emit light


sy.period= [0,0];         # normal stars are not variables

# order stars according to gravity for ABC naming scheme
[gmax, gind]=max(tgrav);      #largest star must be listed as first primary of the system
sy.grav(1)=gmax;
sy.startypenum(1)=sttynum(gind);
sy.startype(1,:)=temptype(gind,:);
[gmin,glast]=min(tgrav);
if (sy.starnum==3)          #for trinaries, make one star the distant companion
    tgrav(gind)=0;
    [gmid,ghalf]=max(tgrav);
    if (floor(rand()*2)==1)
        sy.grav(2)=gmin;
        sy.startypenum(2)=sttynum(glast);
        sy.startype(2,:)=temptype(glast,:);
        sy.grav(3)=gmid;
        sy.startypenum(3)=sttynum(ghalf);
        sy.startype(3,:)=temptype(ghalf,:);
      else
        sy.grav(3)=gmin;
        sy.startypenum(3)=sttynum(glast);
        sy.startype(3,:)=temptype(glast,:);
        sy.grav(2)=gmid;
        sy.startypenum(2)=sttynum(ghalf);
        sy.startype(2,:)=temptype(ghalf,:);
      endif
  elseif (sy.starnum==2)
    sy.grav(2)=gmin;
    sy.startypenum(2)=sttynum(glast);
    sy.startype(2,:)=temptype(glast,:);
  endif

sy.planets=0;
sy.companions=0;  
sy.orbitcount=zeros(2,3);
sy.planet(1)=0;
sy.companion(1)=0;
if (sy.starlocation==0)
    a=(sy.startypenum(1)<5);         # 1 star, main sequence
  elseif (sy.starlocation==1)
    a=((sy.startypenum(1)<5)+(sy.startypenum(2)<5));    # close binaries, at least 1 is main sequence
  elseif (sy.starlocation==2)
    a=(sy.startypenum(1)<5);           # distant binaries, heaviest star is main sequence
  elseif (sy.starlocation==3)
    a=((sy.startypenum(1)<5) + (sy.startypenum(2)<5));  # trinary, either of close pair is main sequence
  endif
if (a)
    sy.planets= roll(2)+2;    # determine the number of planets for primary system
    sy.orbitcount(1,3)= ceil(sy.planets*(syst_outer/100));
    sy.orbitcount(1,2)= floor(sy.planets*(syst_middle/100));
    sy.orbitcount(1,1)= sy.planets-sy.orbitcount(1,3) - sy.orbitcount(1,2);
    sy.companion(sy.planets)=zeros;
    for a=1:sy.orbitcount(1,1)
      sy.planetlocate(a)=1;
      sy.companion(a)=0;
      endfor
    for a=(sy.orbitcount(1,1)+1):(sy.orbitcount(1,1)+sy.orbitcount(1,2))
      sy.planetlocate(a)=2;
      sy.companion(a)=0;
      endfor
    for a=(sy.orbitcount(1,1)+sy.orbitcount(1,2)+1):sy.planets
      sy.planetlocate(a)=3;
      sy.companion(a)=0;
      endfor
  endif
if ((sy.starlocation>1)*(sy.startypenum(sy.starnum)<5))
    sy.companions= roll(2)+2;                # number of planets for companion planetary system
    sy.orbitcount(2,3)= ceil(sy.companions*(syst_outer/100));
    sy.orbitcount(2,2)= floor(sy.companions*(syst_middle/100));
    sy.orbitcount(2,1)= sy.companions- sy.orbitcount(2,3) - sy.orbitcount(2,2);
    oldplanet=sy.planets;
    for a=(oldplanet+1):(oldplanet + sy.orbitcount(2,1))
      sy.planetlocate(a)=1;
      sy.companion(a)=1;
      endfor
    for a=(oldplanet+sy.orbitcount(2,1)+1):(oldplanet+sy.orbitcount(2,1)+sy.orbitcount(2,2))
      sy.planetlocate(a)=2;  
      sy.companion(a)=1;
      endfor
    for a=(oldplanet+sy.orbitcount(2,1)+sy.orbitcount(2,2)+1):oldplanet+sy.companions
      sy.planetlocate(a)=3;
      sy.companion(a)=1;
      endfor
    sy.planets=oldplanet+sy.companions;
  endif

lumi=0;
lumi2=0;
lumitype=[.15, .5, 1, 3, 0, 0];  # luminescence base value for different the different types of stars

if (sy.starlocation==0)
    lumi=lumitype(sy.startypenum(1));
    lumi2=0;
  elseif (sy.starlocation==1)
    lumi=lumitype(sy.startypenum(1)) + lumitype(sy.startypenum(2));
    lumi2=0;
  elseif (sy.starlocation==2)
    lumi=lumitype(sy.startypenum(1));
    lumi2=lumitype(sy.startypenum(2));
  else
    lumi=lumitype(sy.startypenum(1)) + lumitype(sy.startypenum(2));
    lumi2=lumitype(sy.startypenum(3));
  endif   
lumi= lumi+ (lumi * (1+(floor(rand()*40)-20))/100);  # randomize the luminence
lumi2= lumi2+ (lumi2 * (1+(floor(rand()*40)-20))/100); 

for b=1:sy.planets              # determine size of planet found in each orbit based on system location
  if (sy.planetlocate(b)==1)
      a=roll(2);
      if (a<4)
          sy.planet(b)=0;
        elseif (a<8)
          sy.planet(b)=1;
        elseif (a<10)
          sy.planet(b)=2;
        elseif (a<13)
          sy.planet(b)=15;
        endif   
    elseif (sy.planetlocate(b)==2)
      a=roll(2);
      if (a<5)  
          sy.planet(b)=0;
        elseif (a<8)
          sy.planet(b)=1;
        elseif (a<10)
          sy.planet(b)=2;
        elseif (a<13)
          sy.planet(b)=15;
        endif
    elseif (sy.planetlocate(b)==3)
      a=roll(2);
      if (a<5)  
          sy.planet(b)=0;
        elseif (a<7)
          sy.planet(b)=1;
        elseif (a<9)
          sy.planet(b)=2;
        elseif (a<13)
          sy.planet(b)=15 - floor(rand()*2);  # 50% gas giants, 50% ice giants
        endif
    endif
  endfor

#determine orbits for primary star system
for b=1:(sy.planets-sy.companions)
  if (sy.planetlocate(b)==1)             # inner planets
      sy.orbit(b)= ceil(12+ ((1/(sy.orbitcount(sy.companion(b)+1,1)+1))*b*80)*lumi);  #identify the orbital band
    elseif (sy.planetlocate(b)==2)
      sy.orbit(b)= floor((60+ (1/(sy.orbitcount(sy.companion(b)+1,2)+1)*(7*syst_middle))*(b-sy.orbitcount(sy.companion(b)+1,1)))*lumi);
    else
        sy.orbit(b)= sy.orbit(b-1)+ (200+ceil(rand()*65))*lumi;      
    endif
  sy.orbit(b)= sy.orbit(b)* (1+(2*(ceil(rand()*6)+ceil(rand()*6)-7))/100);
  sy.orbit(b)= round(sy.orbit(b));
  if (b>1)
      if (sy.orbit(b)<(sy.orbit(b-1)+(4*sy.planetlocate(b))))
          sy.orbit(b)=sy.orbit(b-1)+ceil(roll(1)/2)+4*sy.planetlocate(b);
        endif
    endif
  endfor

#determine orbits for companion star system
b=sum(sy.orbitcount(1,:));
for c=1:sy.companions
  if (sy.planetlocate(b+c)==1)             # inner planets
      sy.orbit(b+c)= ceil(15+ ((1/(sy.orbitcount(sy.companion(b+c)+1,1)+1))*c*80)*lumi2);  #identify the orbital band
    elseif (sy.planetlocate(b+c)==2)
      sy.orbit(b+c)= floor((65+ (1/(sy.orbitcount(sy.companion(b+c)+1,2)+1)*(7*syst_middle))*(c-sy.orbitcount(sy.companion(b+c)+1,1)))*lumi2);
    else
        sy.orbit(b+c)= sy.orbit(b+c-1)+ (200+ceil(rand()*65))*lumi2;      
    endif
  sy.orbit(b+c)= sy.orbit(b+c)* (1+(2*(ceil(rand()*6)+ceil(rand()*6)-7))/100);
  sy.orbit(b+c)= round(sy.orbit(b+c));
  if (c>1)
      if (sy.orbit(b+c)<(sy.orbit(b+c-1)+(4*sy.planetlocate(b+c))))
          sy.orbit(b+c)=sy.orbit(b+c-1)+ceil(roll(1)/2)+4*sy.planetlocate(b+c);
        endif
    endif
  endfor

# determine gravity of each solar system
primgrav=0;
compgrav=0;
if (sy.starlocation==0)     # calculate planet system gravity centers
    primgrav=sy.grav(1);
    compgrav=0;
  elseif (sy.starlocation==1)
    primgrav=sy.grav(1)+sy.grav(2);
    compgrav=0;
  elseif (sy.starlocation==2)
    primgrav=sy.grav(1);
    compgrav=sy.grav(2);
  else
    primgrav=sy.grav(1)+ sy.grav(2);
    compgrav=sy.grav(3);
  endif

# remove orbits too close to closes binaries
if ((sy.starlocation==1) + (sy.starlocation==3))
    while ((sy.orbit(1)<sy.closeorbit*4)*(sy.companion(1)==0))
      # remove the offending planet from the array
      sy.orbitcount(sy.companion(1)+1,sy.planetlocate(1))=sy.orbitcount(sy.companion(1)+1,sy.planetlocate(1))-1;
      sy.planet=sy.planet(2:end);
      sy.companion=sy.companion(2:end);
      sy.orbit=sy.orbit(2:end);
      sy.planetlocate=sy.planetlocate(2:end);
      sy.planets=sy.planets-1;
      endwhile
  endif

# romvove orbits too far from distant binaries/trinaries
if (sy.starlocation>1)
    massrat(1)=primgrav/(primgrav+compgrav);
    massrat(2)=compgrav/(primgrav+compgrav);
    massper= (.22+.24*massrat)*sy.distantorbit;
    b=1;
    compdelete=0;
    while (b<(sy.planets+1))
      if (sy.orbit(b)>massper(sy.companion(b)+1))   # orbit is larger than the defined maximum orbit
          # remove the offending planet from the array
          sy.orbitcount(sy.companion(b)+1,sy.planetlocate(b))=sy.orbitcount(sy.companion(b)+1,sy.planetlocate(b))-1;
          t1=sy.planet(1:b-1);          
          t2=sy.planet(b+1:end);
          sy.planet=[t1 t2];
          compdelete=compdelete+sy.companion(b);
          t1=sy.companion(1:b-1);
          t2=sy.companion(b+1:end);
          sy.companion=[t1 t2];
          t1=sy.orbit(1:b-1);
          t2=sy.orbit(b+1:end);
          sy.orbit=[t1 t2];
          t1=sy.planetlocate(1:b-1);
          t2=sy.planetlocate(b+1:end);
          sy.planetlocate=[t1 t2];
          sy.planets=sy.planets-1;
        else
          b=b+1;
        endif
      endwhile
  sy.companions=sy.companions-compdelete;
  endif
 
sy.asteroids=0;
sy.giants=0;
sy.smoons(1)=0;
sy.lmoons(1)=0;
for b=1:sy.planets
  sy.rings(b)=(sy.planet(b)>12)*(roll(1)+1)*(ceil(rand()*12)==7);  # 1/12 of giant planets have rings
  if (sy.planet(b)==0)                      # asteroids have no moons or gravity
      sy.smoons(b)=0;
      sy.lmoons(b)=0;
      sy.gravity(b)=0;
      sy.asteroids=sy.asteroids+1;
    elseif (sy.planet(b)>13)               # giants have lots of moons and more g's than earth
      sy.giants=sy.giants+1;
      a=roll(2);
      a=a-4*(sy.planetlocate(b)==1);               # planets close to the star have fewer moons
      c=floor(rand()*120)/100;
      sy.gravity(b)= 1.6 + c;
      sy.radius(b)= ceil(40000+c*80000);
      if (a<5)
          sy.smoons(b)=roll(2);
          sy.lmoons(b)=1;
        elseif (a<7)
          sy.smoons(b)=roll(3);
          sy.lmoons(b)=ceil(roll(1)/2);
        elseif (a<9)
          sy.smoons(b)=roll(4);
          sy.lmoons(b)=roll(1);
        elseif (a<11)
          sy.smoons(b)=roll(5);
          sy.lmoons(b)=roll(1)+2;
        elseif (a<13)
          sy.smoons(b)=roll(6);
          sy.lmoons(b)=roll(1)+4;
        endif
      d=max(1,b-1);
      e=min(b+1,sy.planets);              # giant planets near asteroid belts have more small moons
      if (sy.planet(d)==0)
          sy.smoons(b)=sy.smoons(b)+roll(3);
        endif
      if (sy.planet(e)==0)
          sy.smoons(b)=sy.smoons(b)+roll(3);
        endif    
    elseif (sy.planet(b)==1)                # small planets have few small moons
      a=roll(2);
      a=a-4*(sy.planetlocate(b)==1);               # planets close to the star have fewer moons
      sy.lmoons(b)=0;
      if (a<8)
          sy.smoons(b)=0;
        elseif (a<12)
          sy.smoons(b)=ceil(roll(1)/3);
        else
          sy.smoons(b)=roll(1);
        endif
    else                                    # medium planets have more larger moons
      a=roll(2);
      a=a-4*(sy.planetlocate(b)==1);               # planets close to the star have fewer moons
      if (a<5)
          sy.smoons(b)=0;
          sy.lmoons(b)=0;
        elseif (a<8)
          sy.smoons(b)=ceil(roll(1)/2);
          sy.lmoons(b)=0;
        elseif (a<10)
          sy.smoons(b)=roll(1);
          sy.lmoons(b)=0;
        else
          sy.smoons(b)=roll(1)+2;
          sy.lmoons(b)=ceil(roll(1)/5);
        endif
    endif    
          
  endfor
  
 
# give dimensions to moon arrays
 sy.moon.size= zeros(sy.planets, max(1,max(sy.lmoons)));
 sy.moon.hydro= zeros(sy.planets, max(1,max(sy.lmoons)));
 sy.moon.atm= zeros(sy.planets, max(1,max(sy.lmoons)));
 sy.moon.temp= zeros(sy.planets, max(1,max(sy.lmoons)));
 sy.moon.habitable= zeros(2, 2);
 sy.moon.uwp= zeros(sy.planets, max(1,max(sy.lmoons)), 9);
 sy.moon.gravity=zeros(sy.planets, max(1,max(sy.lmoons)));
 sy.moon.orbit=zeros(sy.planets, max(1,max(sy.lmoons)));
 sy.moon.favor=zeros(sy.planets, max(1,max(sy.lmoons)));
 sy.moon.radius=zeros(sy.planets, max(1,max(sy.lmoons)));
 
# give small and medium planets and large moons their actual sizes and gravities

for b=1:sy.planets
  if (sy.planet(b)==1)     #small planets
      a=roll(2);
      if (a<5)
          sy.planet(b)=4;
          c= floor(rand()*16)/100;
          sy.gravity(b)= .28 + c;
          sy.radius(b)= 5600+ c*10000; 
        elseif (a<7)
          sy.planet(b)=5;
          c= floor(rand()*15)/100;
          sy.gravity(b)= .37 +c;
          sy.radius(b)= 7200+ c*10000;
        elseif (a<9)
          sy.planet(b)=6;
          c= floor(rand()*34)/100;
          sy.gravity(b)= .54 + c;
          sy.radius(b)= 8700+ floor((c/2)*100)*100;
        elseif (a<11)
          sy.planet(b)=7;
          c=floor(rand()*34)/100;
          sy.gravity(b)= .72 + c;
          sy.radius(b)= 10400+ floor((c/2)*100)*100;
        else
          sy.planet(b)=4;
          c= floor(rand()*16)/100;
          sy.gravity(b)= .28 + c;
          sy.radius(b)= 5600+ c*10000; 
          
        endif
    elseif (sy.planet(b)==2) # medium planets
      a=roll(2);
      if (a<4)
          sy.planet(b)=6;
          c= floor(rand()*34)/100;
          sy.gravity(b)= .54 + c;
          sy.radius(b)= 8700+ floor((c/2)*100)*100;
        elseif (a<6)
          sy.planet(b)=7;
          c=floor(rand()*35)/100;
          sy.gravity(b)= .72 + c;
          sy.radius(b)= 10400+ floor((c/2)*100)*100;
        elseif (a<8)
          sy.planet(b)=8;
          c=floor(rand()*43)/100;
          sy.gravity(b)= .83 + c;
          sy.radius(b)= 12200+ floor((c/3)*100)*100;
        elseif (a<10)
          sy.planet(b)=9;
          c=floor(rand()*52)/100;
          sy.gravity(b)= 1 + c;
          sy.radius(b)= 13700+ floor((c/3)*100)*100;
        else
          sy.planet(b)=10;
           c=floor(rand()*52)/100;
          sy.gravity(b)= 1.14 + c;
          sy.radius(b)= 15500+ floor((c/3)*100)*100;
       endif
    endif
  if (sy.planet(b)==0)     #astroids need a gravity and radius too or all asteroid systems crash
      sy.gravity(b)=0;
      sy.radius(b)=0;
    endif
  
  
  for c=1:sy.lmoons(b)     #large moons
    a=roll(1);
    if (a<3)
        sy.moon.size(b,c)=1;
        d=floor(rand()*4)/100;
        sy.moon.gravity(b,c)= .04+ d;
        sy.moon.radius(b,c)= 1200+ 30000*d;
      elseif (a<5)
        sy.moon.size(b,c)=2;
        d= (floor(rand()*8)/100);
        sy.moon.gravity(b,c)= .12 + d;
        sy.moon.radius(b,c)= 2400+ 20000*d;
      elseif (a==5)
        sy.moon.size(b,c)=3;
        d= floor(rand()*12)/100;
        sy.moon.gravity(b,c)= .20 + d;
        sy.moon.radius(b,c)=4300+ d*10000;
      else
        sy.moon.size(b,c)=4;
        d= floor(rand()*16)/100;
        sy.moon.gravity(b,c)= .28 + d;
        sy.moon.radius(b,c)= 5600 +d*10000;       
      endif
      
    sy.moon.orbit(b,c)=ceil(sy.gravity(b)*(160+ 600*(c/(1+sy.lmoons(b)))));
    # moons on inner planets need to be closer to their primary
    moontemp=[.5,.6,.8];
    if (b<4)  # only affect inner planets
        sy.moon.orbit(b,c)=sy.moon.orbit(b,c)*moontemp(b);
      endif
    sy.moon.orbit(b,c)= ceil(sy.moon.orbit(b,c)*(1+(roll(2)-7)/100));  #randomize moon orbits  
    endfor
      
  endfor

sy.atm(1)=0;
for b=1:sy.planets                       # give planets and moons an atmosphere
  sy.atm(b)=atmosphere(sy.planet(b));
  sy.habitable(b)=0;                     # not habitable or favored initially
  sy.favor(b)=0;
  for c=1:sy.lmoons(b)
    sy.moon.atm(b,c)=atmosphere(sy.moon.size(b,c));  
    endfor
  endfor

 
 # give planets a temperature and a hydrology
for b=1:sy.planets                      # inner planets too hot and dry for life
  if (sy.planetlocate(b)==1)
      if (sy.atm(b)>1)
          sy.temp(b)=8;
        else
          sy.temp(b)=-1;
        endif  
      sy.hydro(b)=0;
      for c=1: sy.lmoons(b)
        sy.moon.hydro(b,c)=0;
        if (sy.moon.atm(b,c)>1)
            sy.moon.temp(b,c)=8;
          else
            sy.moon.temp(b,c)=-1;
          endif
        endfor
    elseif (sy.planetlocate(b)==2)
      if (syst_orbit_temp==0)                     # if the orbital location does not primarily determine temperature
          m=0;
          m=m -2*((sy.atm(b)==2)+(sy.atm(b)==3));
          m=m -1*((sy.atm(b)==4)+(sy.atm(b)==5));    #modify planet temp based on atmosphere
          m=m +1*((sy.atm(b)==8)+(sy.atm(b)==9));
          m=m +2*((sy.atm(b)>9)*(sy.atm(b)<14));
          m=m +3*(b==(sy.orbitcount(sy.companion(b),1)+1));                   #modify planet temps based on location
          m=m -3*(b==(sy.orbitcount(sy.companion(b),1)+sy.orbitcount(sy.companion(b),2)-1));
          a=roll(2)+m;
          if (a<4)
              sy.temp(b)=1;
              sy.hydro(b)=max(0,roll(2)-2);
            elseif (a<5)
              sy.temp(b)=2;
              sy.hydro(b)=max(0,roll(2)-2);
            elseif (a<7)
              sy.temp(b)=3;
              sy.hydro(b)=max(0,roll(2)-2);
            elseif (a<8)
              sy.temp(b)=4;
              sy.hydro(b)=max(0,roll(2)-2);
            elseif (a<9)
              sy.temp(b)=5;
              sy.hydro(b)=max(0,roll(2)-2);
            elseif (a<11)
              sy.temp(b)=6;
              sy.hydro(b)=max(0,roll(2)-4);
            else
              sy.temp(b)=7;
              sy.hydro(b)=max(0,roll(2)-6);
            endif
          sy.hydro(b)=sy.hydro(b)*(sy.atm(b)>1);                    # no or trace atmosphere, no hydrosphere and temp=-1
          sy.temp(b)= sy.temp(b)*(sy.atm(b)>1) -1*(sy.atm(b)<2);
          sy.hydro(b)=sy.hydro(b)*(sy.atm(b)<15);                   # giants have no accessible water
          for c=1:sy.lmoons(b)  
            m=0;
            m=m -2*((sy.moon.atm(b,c)==2)+(sy.moon.atm(b,c)==3));
            m=m -1*((sy.moon.atm(b,c)==4)+(sy.moon.atm(b,c)==5));    # modify large moons based on temps and location
            m=m +3*(b==(sy.orbitcount(sy.companion(b),1)+1));
            m=m -3*(b==(sy.orbitcount(sy.companion(b),1)+sy.orbitcount(sy.companion(b),2)-1));
            if (sy.moon.size(b,c)>1)
                a=roll(2)+m;
                if (a<4)
                    sy.moon.temp(b,c)=1;
                    sy.moon.hydro(b,c)=max(0,roll(2)-2);
                  elseif (a<5)
                    sy.moon.temp(b,c)=2;
                    sy.moon.hydro(b,c)=max(0,roll(2)-2);
                  elseif (a<7)
                    sy.moon.temp(b,c)=3;
                    sy.moon.hydro(b,c)=max(0,roll(2)-2);
                  elseif (a<8)
                    sy.moon.temp(b,c)=4;
                    sy.moon.hydro(b,c)=max(0,roll(2)-2);
                  elseif (a<9)
                    sy.moon.temp(b,c)=5;
                    sy.moon.hydro(b,c)=max(0,roll(2)-2);
                  elseif (a<11)
                    sy.moon.temp(b,c)=6;
                    sy.moon.hydro(b,c)=max(0,roll(2)-4);
                  else
                    sy.moon.temp(b,c)=7;
                    sy.moon.hydro(b,c)=max(0,roll(2)-6);
                  endif
              else
                sy.moon.hydro(b,c)=0;
              endif    
            sy.moon.hydro(b,c)=sy.moon.hydro(b,c)*(sy.moon.atm(b,c)>1);                          # no or trace atmo, no hydro and temp= -1
            sy.moon.temp(b,c)= sy.moon.temp(b,c)*(sy.moon.atm(b,c)>1) -1*(sy.moon.atm(b)==0);  
            endfor
        else           # orbital position primarily determines temperature
          base=b- ((sy.planets-sy.companions)*(b>(sy.planets-sy.companions)));
          curmid=base- sy.orbitcount(sy.companion(b)+1,1);
          sy.temp(b)=8-floor(curmid*(7/sy.orbitcount(sy.companion(b)+1,2)));  # give a temperature based on that position
          sy.temp(b)=sy.temp(b) + (sy.temp(b)==1)* floor(rand()*2);  # half of very cold planets are only cold
          sy.temp(b)=sy.temp(b)- (sy.atm(b)<6);                      # thin atmo or below have lower temperature
          sy.temp(b)=sy.temp(b)- (sy.atm(b)>8)*(sy.atm(b)<15);       # dense atmo (not gas giants) have higher temp
          sy.hydro(b)=max(0,(roll(2)-2*max(1,sy.temp(b)-4)));       # hotter planets have less surface water
          sy.hydro(b)=sy.hydro(b)*(sy.atm(b)>1);                    # no or trace atmosphere, no hydrosphere and temp=-1
          sy.temp(b)= sy.temp(b)*(sy.atm(b)>1) -1*(sy.atm(b)<2);
          sy.temp(b)= max(-1,sy.temp(b));
          for c=1:sy.lmoons(b)                                       # give large moons temp and hydro
            sy.moon.temp(b,c)=sy.temp(b);                            # give the moon the planet's temp
            sy.moon.temp(b,c)=sy.moon.temp(b,c)- (sy.moon.atm(b,c)<4); # very thin atmo or below have lower temperature
            sy.moon.hydro(b,c)=max(0,(roll(2)-2*max(1,sy.moon.temp(b,c)-4))); # hotter worlds have less surface water
            sy.moon.hydro(b,c)=sy.moon.hydro(b,c)*(sy.moon.atm(b,c)>1); # no or trace atmosphere, no hydrosphere and temp=-1
            sy.moon.temp(b,c)= sy.moon.temp(b,c)*(sy.moon.atm(b,c)>1) -1*(sy.moon.atm(b,c)<2);
            sy.moon.temp(b,c)= max(sy.moon.temp(b,c), -1);
            endfor
        endif
    elseif (sy.planetlocate(b)==3)     # outer planets are freezing cold
      sy.temp(b)=0;
      sy.hydro(b)= max(0,(roll(2)-2));
      sy.hydro(b)= sy.hydro(b)*(sy.atm(b)>1)*(sy.atm(b)<14);
      for c=1:sy.lmoons(b)
        sy.moon.temp(b,c)=0;
        sy.moon.hydro(b,c)= max(0,(roll(2)-2));
        sy.moon.hydro(b,c)= sy.moon.hydro(b,c)*(sy.moon.atm(b,c)>1);
        endfor
    endif
  endfor

count=1;
      sy.habit.good(count)=0;                         # initialize the habit structure so it exists even without a habitable world
      sy.habit.planet(count)=0;
      sy.habit.moon(count)=0;
      sy.habit.size(count)=0;
      sy.habit.atm(count)=0;
      sy.habit.hydro(count)=0;
      sy.habit.temp(count)=0;
      sy.habit.native(count)=0;
      sy.habit.companion(count)=0;
# identify habitable worlds and copy the data to separate structure

for b=1:sy.planets
  score=3;
  score= score- 3*((sy.atm(b)<3)+(sy.atm(b)>9));
  score= score- 2*(sy.atm(b)==3);
  score= score- 1*((sy.atm(b)==4)+(sy.atm(b)==7)+(sy.atm(b)==9));
  score= score- 2*(sy.hydro(b)==0);
  score= score- 3*((sy.temp(b)<1)+(sy.temp(b)==8));
  score= score- 2*((sy.temp(b)==1)+(sy.temp(b)==7));
  score= score- 1*((sy.temp(b)==2)+(sy.temp(b)==6));
  if (score>0)                              # deal with habitable planets
      sy.habitable(b)=score;
      sy.habit.good(count)=score;
      sy.habit.planet(count)=b;
      sy.habit.moon(count)=0;
      sy.habit.size(count)=sy.planet(b);
      sy.habit.atm(count)=sy.atm(b);
      sy.habit.hydro(count)=sy.hydro(b);
      sy.habit.temp(count)=sy.temp(b);
      if (b>(sy.planets-sy.companions))
          sy.habit.companion(count)=1;
        else
          sy.habit.companion(count)=0;
        endif
      count=count+1;
    endif
  for c= 1:sy.lmoons(b)                    # deal with habitable moons
    score=3;
    score= score- 3*((sy.moon.atm(b,c)<3)+(sy.moon.atm(b,c)>9));
    score= score- 2*(sy.moon.atm(b,c)==3);
    score= score- 1*((sy.moon.atm(b,c)==4)+(sy.moon.atm(b,c)==7)+(sy.moon.atm(b,c)==9));
    score= score- 3*(sy.moon.hydro(b,c)==0);
    score= score- 1*((sy.moon.hydro(b,c)<2)+(sy.moon.hydro(b,c)==10));
    score= score- 3*((sy.moon.temp(b,c)<1)+(sy.moon.temp(b,c)==8));
    score= score- 2*((sy.moon.temp(b,c)==1)+(sy.moon.temp(b,c)==7));
    score= score- 1*((sy.moon.temp(b,c)==2)+(sy.moon.temp(b,c)==6));
    score=max(score,0);
    sy.moon.habitable(b,c)=score;
    if (score>0)
      sy.habit.good(count)=score;
      sy.habit.planet(count)=b;
      sy.habit.moon(count)=c;
      sy.habit.size(count)=sy.moon.size(b,c);
      sy.habit.atm(count)=sy.moon.atm(b,c);
      sy.habit.hydro(count)=sy.moon.hydro(b,c);
      sy.habit.temp(count)=sy.moon.temp(b,c);
      if (b>(sy.planets-sy.companions))
          sy.habit.companion(count)=1;
        else
          sy.habit.companion(count)=0;
        endif
      count=count+1;
      endif
    endfor  
  endfor

sy.habnum=count-1;      # store how many habitable worlds there are
# determine rotational period and axial tilt
axisfind

# identify geothermally active outer planets where life can exist
geofinder

# how do habitable planet temperatures vary by season and latitude?
for pl=1:sy.habnum
  tempvary
  endfor

sy.bestp=0;
#identify worlds best for major races
# 1=avians, 2=insectans, 3=merfolk, 4=reptiles
for a=1:sy.habnum
  fav=0;
  if (syst_favorable==1)    # should it matter at all?
      if (sy.habit.moon(a)>0)
          tmp=sy.moon.temp(sy.habit.planet(a),sy.habit.moon(a));
          grav=sy.moon.gravity(sy.habit.planet(a),sy.habit.moon(a));  
          atmo=sy.moon.atm(sy.habit.planet(a),sy.habit.moon(a));
          hydro=sy.moon.hydro(sy.habit.planet(a),sy.habit.moon(a));
        else
          tmp=sy.temp(sy.habit.planet(a));
          grav=sy.gravity(sy.habit.planet(a));
          atmo=sy.atm(sy.habit.planet(a));
          hydro=sy.hydro(sy.habit.planet(a));
        endif
      if ((grav<0.6)*((atmo==6)+(atmo==7))*((tmp>1)*(tmp<7)))
          fav=1;
        elseif ((grav<0.9)*((atmo==8)+(atmo==9))*((tmp>1)*(tmp<7)))
          fav=1;
        endif  
      if ((hydro>7)*(tmp>1))
          fav=3;    
        elseif (((hydro>3)*(hydro<8))*((tmp>4)*(tmp<7)))
          fav=4;
        elseif ((hydro<4)*((atmo==4)+(atmo==7)+(atmo==9)))
          fav=2;
        endif
    endif    
  if (sy.habit.moon(a)>0)
      sy.moon.favor(sy.habit.planet(a), sy.habit.moon(a))=fav;
    else
      sy.favor(sy.habit.planet(a))=fav;
    endif  
    
  endfor
  
if (sy.habnum==0)  #if there are no habitable worlds...
    sy.bestm=0;           # figure out the 'best' planet no matter the situation
    clear tst;
    for a=1:sy.planets
      tst(a)= (sy.planet(a)==0)*((sy.planetlocate(a)==2)*2+ (sy.planetlocate(a)==3) + 1);
      endfor
    if (sy.asteroids>0)        # choose an asteroid if available
        [b,sy.bestp]=max(tst);
      else
        clear tst;
        for a=1:sy.planets  # middle planet, not gas giant
          tst(a)=(sy.planetlocate(a)==2)*(sy.planet(a)<13);
          endfor
          [b,c]=max(tst(a));
          if (c>0)
              sy.bestp=b;
            endif
      endif  
    if ((sy.bestp==0)*(max(sy.lmoons>0)))           # choose a moon, any moon
        clear tstnum
        for b=1:max(sy.lmoons)
          for a=1:sy.planets
            tstnum(a,b)= (3*(sy.planetlocate(a)==2)* sy.moon.size(a,b))+ sy.moon.size(a,b);
            endfor
          endfor
        [b,tst]=max(tstnum);
        [b,sy.bestm]=max(b);
        sy.bestp=tst(sy.bestm);
      endif  
    if (sy.bestp==0)        # choose a rocky planet and be done with it!!!
        a=1;
        while (a<sy.planets)
          if (sy.planet(a)<13)
              sy.bestp=a;
              sy.bestm=0;
              a=45;
            else
              a=a+1;
            endif
          endwhile  
      endif
    if (sy.bestp==0)
        sy.bestp=1;
        sy.bestm=0;
      endif
  else                    # find the best habitable planet with gravity near 1.00g
    clear tst;
    count=1;
    for a=1:sy.habnum
      if (sy.habit.good(a)==max(sy.habit.good))
        tst(count)=a;
        if (sy.habit.moon(a)>0)
            gr(count)= sy.moon.gravity(sy.habit.planet(a), sy.habit.moon(a));
          else
            gr(count)= sy.gravity(sy.habit.planet(a));
          endif  
        count=count+1;
        endif  
      endfor
    [a,b]=min(abs(gr(:)-1));
    sy.bestp=sy.habit.planet(tst(b));
    sy.bestm=sy.habit.moon(tst(b));  
  endif


sy.population=roll(2)-syst_population + floor((sum(sy.habit.good)*50/syst_middle)/3);  #assign a population to the system
                               # more habitable planets give a higher population
sy.population= sy.population- ((sy.habnum==0)*syst_nohab);  # penalty for no habitable worlds
sy.population= sy.population + (sy.population>0)*syst_pop_boost;
sy.population=min (sy.population,10);
sy.population=max(sy.population,0);
sy.pop= (((floor(rand()*88)+10)/10)*(sy.population>0));
  
count=ceil(sy.population/3);                          # assign a government type and factions based on population
a=roll(2);
b=roll(2);
if (count==0)
    sy.govern=0;
    sy.factions=0;
  elseif (count==1)             # low population
    if (a<5)
        sy.govern=0;
      elseif (a<7)
        sy.govern=1;
      elseif (a<8)
        sy.govern=2;
      elseif (a<9)
        sy.govern=10;
      elseif (a<10)
        sy.govern=6;
      elseif (a<11)
        sy.govern=11;
      else
        sy.govern=12;  
      endif
    sy.factions=floor((b-1)/5);  
  elseif (count==2)           # mid-population
    if (a<4)
        sy.govern=1;
      elseif (a<5)
        sy.govern=2;
      elseif (a<6)
        sy.govern=5;
      elseif (a<7)
        sy.govern=3;
      elseif (a<8)
        sy.govern=4;
      elseif (a<9)
        sy.govern=8;
      elseif (a<10)
        sy.govern=9;
      elseif (a<11)
        sy.govern=10;
      elseif (a<12)
        sy.govern=6;
      else
        sy.govern=10+ceil(roll(1)/2);
      endif
    sy.factions=ceil((b-3)/2);
    sy.factions=min(sy.factions, 4);  
  elseif (count==3)                   #high population
    if (a<3)
        sy.govern=6;
      elseif (a<5)
        sy.govern=5;
      elseif (a<6)
        sy.govern=9;
      elseif (a<7)
        sy.govern=8;
      elseif (a<8)
        sy.govern=4;
      elseif (a<9)
        sy.govern=3;
      elseif (a<10)
        sy.govern=11;
      elseif (a<11)
        sy.govern=12;
      elseif (a<12)
        sy.govern=7;
      else
        sy.govern=10+ 3*floor(roll(1)/4);
      endif
    sy.factions= floor(b/2);
  else                              #highest population
    if (a<5)
        sy.govern=5;
      elseif (a<7)
        sy.govern=3;
      elseif (a<8)
        sy.govern=4;
      elseif (a<9)
        sy.govern=8;
      elseif (a<11)
        sy.govern=9;
      elseif (a<12)
        sy.govern=10;
      else
        sy.govern= 10+floor(roll(1)/2);  
      endif
    sy.factions=floor(b/2)+1;
    sy.factions=max(sy.factions, 5);
  endif  
 
sy.faction(1)=5* (sy.population>0);                           #give each faction a strength

if (syst_factions==0)        # only worry about factions if desired
    sy.factions=0;
  endif  

for a=1:sy.factions
  sy.faction(a+1)=floor((roll(2)+1)/3);
  endfor

if ((sy.govern==7)*(syst_factions==1))                          #balkanized faction is very strong
  sy.faction(2)=5;
  endif  
  
sy.law=roll(1)-1;                         # determine the law level in the system
sy.law=sy.law+ ((sy.govern==5)+(sy.govern==11))*1;
sy.law=sy.law+ ((sy.govern==1)+(sy.govern==13))*2;
sy.law=sy.law+ ((sy.govern==6)+(sy.govern==7))*3;
sy.law=sy.law * (sy.govern>0);
sy.law=sy.law+ 1*(sy.factions>3);

a= roll(2)+ (sy.population-5)+ (2+syst_portbooster)*(sy.population>8);            # determine starport type modified by population
if (sy.atm(sy.bestp)<2)
    a=min(a,7);
  endif
a=a* (sy.population>0);
if (a<4)
    sy.starport='X';
  elseif (a<6)
    sy.starport='E';
  elseif (a<7)
    sy.starport='D';
  elseif (a<9)
    sy.starport='C';
  elseif (a<12)
    sy.starport='B';
  else
    sy.starport='A';  
  endif
 
a=roll(1)-1 + syst_tech;                               # determine tech level
a=a+ceil(sum(sy.habit.good)/2);
a=a+ 1*(sy.population<5) +1*(sy.population>8); 
a=a+ 1* ((sy.govern==0)+ (sy.govern==5)+ (sy.govern==8));
a=a- 2*((sy.govern==7)+(sy.govern==11)+(sy.govern==13));
a=a+ (1+(min(2,syst_tech)))* (sy.starport=='C');
a=a+ (2+(min(2,syst_tech)))* (sy.starport=='B');
a=a+ (3+(min(2,syst_tech)))* (sy.starport=='A');
 

                   # make sure tech levels are at minimums and maximums
if (sy.bestm==0)                       # atmosphere tech checks for planets
    if (sy.atm(sy.bestp)<2)
        a=max(a,8);
      elseif (sy.atm(sy.bestp)<4)
        a=max(a,6);
      elseif (sy.atm(sy.bestp)>9)
        a=max(a,9);  
      endif
  else
    if (sy.moon.atm(sy.bestp,sy.bestm)<2)           # atmosphere tech checks for moons
        a=max(a,8);
      elseif (sy.moon.atm(sy.bestp,sy.bestm)<4)
        a=max(a,6);
      elseif (sy.moon.atm(sy.bestp,sy.bestm)>9)
        a=max(a,9);  
      endif
  endif      
if (sy.bestm==0)                                    # tainted atmospheres require TL5 or better
    if ((sy.atm(sy.bestp)==4)+ (sy.atm(sy.bestp)==7)+ (sy.atm(sy.bestp)==9))
        a=max(a,5);
      endif
    if ((sy.temp(sy.bestp)<1)+(sy.temp(sy.bestp)>6))  # extreme temps require TL8 or better
        a=max(a,8);
      endif  
  elseif ((sy.moon.atm(sy.bestp,sy.bestm)==4)+ (sy.moon.atm(sy.bestp,sy.bestm)==7)+ (sy.moon.atm(sy.bestp, sy.bestm)==9))
    a=max(a,5);
  endif  
sy.tech=a;
if (sy.bestm>0)
    if ((sy.moon.temp(sy.bestp,sy.bestm)>7)+(sy.moon.temp(sy.bestp,sy.bestm)<2))
        sy.tech=min(9,sy.tech)*(sy.population>0);               # if moon temp is extreme, need jump level tech
      endif  
  elseif ((sy.temp(sy.bestp)>7)+(sy.temp(sy.bestp)<2))
    sy.tech=min(9,sy.tech)*(sy.population>0);               # if planet temp is extreme, need jump level tech
  endif  
# minimum starport populations and technologies
if (sy.starport=='A')
    sy.tech=max(sy.tech,10);
    sy.population=max(sy.population,6);
  endif
if (sy.starport=='B')
    sy.tech=max(sy.tech,9);
    sy.population=max(sy.population,4);
  endif
if (sy.starport=='C')
    sy.tech=max(sy.tech, 8);
    sy.population=max(sy.population,2);
  endif  
if (sy.habnum==0)
    sy.tech=max(sy.tech,8)*(sy.population>0);  # no habitable worlds need at least nearly stellar tech
    if ((sy.population>0)*((sy.starport=='D')+(sy.starport=='E')+(sy.starport=='X')))
        sy.starport='C';                       # and must be able to build at least small craft
      endif    
  endif
if (sy.geothermal(sy.bestp)==1)    #geothermal planets/moons need at least tech level 6
    sy.tech=max(sy.tech,6);
  endif


if ((syst_lowpop==1)*(sy.population>0)*(sy.tech<9))                      # give small low tech systems a population boost
    sy.population= sy.population + (sy.population<syst_min_low_pop)*syst_lowpop*(syst_min_low_pop-1);
  endif  


#adjust populations of lowest tech worlds so that they fit on the best planet or moon
if (sy.bestm>0)
    b=sy.moon.size(sy.bestp,sy.bestm);
  else
    b=sy.planet(sy.bestp);
  endif  
if (sy.tech<8)
    sy.population= min(sy.population, b+2);
  endif

sy.tech= sy.tech * (sy.population>0);     # no population, no tech
sy.tech= min(sy.tech,syst_techmax);         # assign a tech level
  
# determine amber and red worlds
sy.restriction= 0*(sy.population<1);
sy.restriction= sy.restriction + 1*((sy.govern==6)+ (sy.govern==7)+ (sy.govern==13));
sy.restriction= sy.restriction + 1*(sy.law>6);
sy.restriction= sy.restriction + 1*(sy.tech<5);
sy.restriction= min(sy.restriction,2);

if (syst_confederation==0)    # is there a setting-wide government?
    sy.naval=0;
    sy.scout=0;
    sy.consul=0;
  else  
    # is there a naval base?
    a=roll(2)+ 2*(sy.starport=='A') + 1*(sy.starport=='B');
    a=a- 1*(sy.starport=='D') - 3*((sy.starport=='E')+ (sy.starport=='X'));
    a=a+ (sy.population-6) -2*(sy.habnum==0) + ceil(sy.giants/2);
    a=a- 2*(sy.govern>9) -2*(sy.govern<2);
    sy.naval= 1*(a>12)*(sy.population>6);

    # is there a scout base
    a=roll(2)+ 2*(sy.starport=='D') + 2*(sy.starport=='C');
    a=a+ (sy.population-3)*(sy.population<8);
    a=a* (sy.population<9);
    a=a+ floor(sy.giants/2);
    a=a*(sy.population>2);
    sy.scout= 1*(a>10);

    # is there an imperial consulate 
    a=roll(2)+ 4*(sy.starport=='A') + 2*(sy.starport=='B');
    a=a+ 3*sy.naval + ceil(sy.tech-9);
    a=a- 2*(sy.starport=='C') - 6*((sy.starport=='D')+ (sy.starport=='E')+ (sy.starport=='X'));
    a=a+ (sy.population-6);
    a=a* (sy.population>7);
    sy.consul= 1*(a>11);
  endif

if (syst_explorer==1)       # do exlorer aid societies exist at all?
    # is there an explorer's aid society
    a=roll(2)+1*(sy.population-7);
    a=a+ 5*(sy.starport=='A')+ 2*(sy.starport=='B')- 4*((sy.starport=='D')+ (sy.starport=='E')+ (sy.starport=='X'));
    a=a+ floor(sy.tech-9);
    a=a* (sy.population>5);
    sy.aid= 1*(a>9);
  else
    sy.aid=0;
  endif  

# calculate the personal gdp
sy.gdp= 2000*sy.tech;
b=1;
for a=1:sy.habnum
  b=b+ (.05*sy.habit.good(sy.habnum));
  endfor
b=b+ (((.05*sy.asteroids)+ (.05*sy.giants))*(sy.tech>7));
b=b+ (.15*sy.naval)+ (.1*sy.consul) + (.1*sy.aid)+ (.05*sy.scout);
b=b+ (.2*(sy.starport=='A'))+ (.1*(sy.starport=='B'))- (.2*(sy.starport=='D'))- (.3*(sy.starport=='E'))- (.4*(sy.starport=='X'));
b=b- (.2*sy.restriction);
sy.gdpmod=b;
sy.gdp= sy.gdp*b;
sy.sysgdp=sy.gdp*(sy.pop*10^sy.population);

#determine trade codes
sy.trade= zeros(16,1);

b=0;                                   #1= agricultural system- temperate worlds, lower pop
for a=1:sy.habnum
  b=b+ (sy.habit.size(a)*(sy.habit.good(a)>1));
  endfor
sy.trade(1)=1*((b/(4.5-(2*syst_middle/50)))>sy.population)*(sy.population>2); 

if (sy.tech>7)                         #2= desert world, either 1 or 2 on only world, 100% on any habitable world
    for a=1:sy.habnum
      sy.trade(2)=sy.trade(2)+ (sy.habit.hydro(a)<2);
      endfor
    sy.trade(2)=min(sy.trade(2),1);
  else
    if (sy.bestm>0)  
        sy.trade(2)= 1*(sy.moon.hydro(sy.bestp,sy.bestm)<2);
      else
        sy.trade(2)= 1*(sy.hydro(sy.bestp)<2);
      endif
  endif
if (sy.tech>7)                         #3= fluid ocean world, atm>9, hydro 5+, temp<2, not gas or ice giant, spacefaring tech
    for a=1:sy.planets
      sy.trade(3)=sy.trade(3)+ 1*((sy.hydro(a)>4)*(sy.temp(a)==0)*(sy.atm(a)>9)*(sy.planet(a)<14));
      endfor
    sy.trade(3)=min(sy.trade(3),1);
  endif
b=0;                                   #4=  garden world (ie. most habitable and temperate) and not too populated
for a=1:sy.habnum
  b=b+ sy.habit.size(a)*(sy.habit.good(a)==3)*(sy.habit.temp(a)==4);
  endfor
sy.trade(4)= 1*(b>sy.population);
sy.trade(5)=1*(sy.population>8);       #5=  hi population system 9 or better
sy.trade(6)=1*(sy.tech>(syst_techmax-2));            #6=  hi tech system at or near max tech level 
if (sy.tech>7)                         #7=  ice capped world, hydro 5+ and cold or worse habitable world
    for a=1:sy.habnum
      sy.trade(7)=sy.trade(7)+ ((sy.habit.hydro(a)>5)*(sy.habit.temp(a)<3));
      endfor
    sy.trade(7)=min(sy.trade(7),1);
  else
    if (sy.bestm>0)  
        sy.trade(7)= 1*((sy.moon.hydro(sy.bestp,sy.bestm)>4)*(sy.moon.temp(sy.bestp,sy.bestm)<3));
      else
        sy.trade(7)= 1*((sy.hydro(sy.bestp)>4)*(sy.temp(sy.bestp)<3));
      endif
  endif
if (sy.tech>7)                         #8=  industrial world, populous and poor atm
    for a=1:sy.habnum
      sy.trade(8)=sy.trade(8)+ ((sy.population>6)*((sy.habit.atm(a)==4)+(sy.habit.atm(a)==7)+(sy.habit.atm(a)==9)));
      endfor
    sy.trade(8)=min(sy.trade(8),1);
  endif
if (sy.habnum==0)
  if (sy.bestm>0)  
        sy.trade(8)= 1*(sy.population>6)*((sy.moon.atm(sy.bestp,sy.bestm)==4)+(sy.moon.atm(sy.bestp,sy.bestm)==7)+(sy.moon.atm(sy.bestp,sy.bestm)==9));
      else
         sy.trade(8)= 1*(sy.population>6)*((sy.atm(sy.bestp)==4)+(sy.atm(sy.bestp)==7)+(sy.atm(sy.bestp)==9));
      endif
  endif
sy.trade(9)=1*(sy.population<4);       #9=  low population system less than 4
sy.trade(10)=1*(sy.tech<6);            #10= low tech world without any spaceflight                                 
    b=0;                               #11= non-agricultural, meaning no hab 2 or 3 worlds
    for a=1:sy.habnum
      b=b+ (sy.habit.good(a)>1);
      endfor
    sy.trade(11)=min(1,((sy.habnum==0)+(b==0))); 
b=0;                                   #12= non-industrial, low pop, at least 1 untainted atmosphere, no asteroids
c=0;
b=sy.asteroids+ 1*(sy.population>5);
for a=1:sy.habnum
  c=c+ 1*((sy.habit.atm(a)==5)+ (sy.habit.atm(a)==6)+ (sy.habit.atm(a)==8));
  endfor
sy.trade(12)=((b==0)*(c>0));     
sy.trade(13)=1*(sy.gdpmod<.8);         #13= poor world with gdp modifier less than .8
sy.trade(14)=1*(sy.gdpmod>1.9);        #14= rich system with gdp modifier greater than 1.9

if (sy.tech>7)                         #15= water world, either 90%+ on only world, 100% on any world
    for a=1:sy.habnum
      sy.trade(15)=sy.trade(15)+ (sy.habit.hydro(a)>9);
      endfor
    sy.trade(15)=min(sy.trade(15),1);
  else
    if (sy.bestm>0)  
        sy.trade(15)= 1*(sy.moon.hydro(sy.bestp,sy.bestm)>8);
      else
        sy.trade(15)= 1*(sy.hydro(sy.bestp)>8);
      endif
  endif
sy.trade(16)=1*(sy.atm(sy.bestp)<3);   #16= vacuum worlds

save ("tempplanet.m", "sy");

#determine UWP codes
for a=1:sy.planets
  sy.uwp(a,:)=[sy.starport, dec2hex(sy.planet(a)), dec2hex(sy.atm(a)), dec2hex(sy.hydro(a)), dec2hex(sy.population), dec2hex(sy.govern), dec2hex(sy.law), '-', dec2hex(sy.tech)];
  for b=1:max(1,sy.lmoons(a))
    sy.moon.uwp(a,b,:)=[sy.starport, dec2hex(sy.moon.size(a,b)), dec2hex(sy.moon.atm(a,b)), dec2hex(sy.moon.hydro(a,b)), dec2hex(sy.population), dec2hex(sy.govern), dec2hex(sy.law), '-', dec2hex(sy.tech)]; 
    endfor
  endfor

if (sy.population==0)
    sy.trade=zeros(16,1);
  endif

if (syst_hierarchy==1)   # does a setting wide government have a hierarchy?
    # determine position in the confederation hierarchy
  
    if (min(1,((sy.population<6)+(sy.tech<7)))==1)
        sy.confed=1;
      endif
  
    if (((sy.population>5)*(sy.tech>6)) - ((sy.population>6)*(sy.tech>8))==1)
        sy.confed=2;
      endif
  
    c= ((sy.population==10)*(sy.tech>12))+ ((sy.population==9)*(sy.tech==15));
    if (c==1)
        sy.confed=4;
      endif
  
    if ((((sy.population>6)*(sy.tech>8))- c)==1);
        sy.confed=3;
      endif
  else
    sy.confed=0;
  endif
  
sy.name=namegen();
sy.period=[0,0];                   # used with variable stars only- 0's otherwise

sy.subsectname='None yet';           #give variables for future use a placeholder value
sy.subsector=[0 0];
sy.sector=[0 0];

if ((sy.habnum>0)*(sy.population>syst_racemin))
    a=(roll(2)>syst_race);
  else
    a=0;
  endif
  
sy.native= a*(ceil(rand()*sy.habnum*syst_racemod));  #more natives if there are more habitable world

endfunction

function sy=oddsys()
# sy.startype(1)          red, orange, yellow, or white stars
sy.starnum=1;
sy.name=namegen();
a=roll(1);
sy.period=[0,0];
if (a==1)           # supergiant table
    b=ceil(rand()*1000);
    if (b<601)
        sy.startype(1,:)='type A blue-white subgiant';
        sy.grav(1)= 3+ floor(rand()*30)/10;
        sy.period=[0,0];
      elseif (b<695)
        sy.startype(1,:)='type B blue giant';
        sy.grav(1)= 7+ floor(rand()*90)/10;
        sy.period=[0,0];
      elseif (b<990)
        sy.startype(1,:)='type S red giant';
        sy.grav(1)= 1.5+ floor(rand()*35)/10;  
        sy.period=[0,0];
      elseif (b<999)
        sy.startype(1,:)='type O blue supergiant';
        sy.grav(1)= 15+ ceil(rand()*85);
        sy.period=[0,0];
      elseif (b==999)
        sy.startype(1,:)='type W Wolf-Rayet supergiant';
        sy.grav(1)= 15+ ceil(rand()*85);
        sy.period=[0,0];
      elseif (b==1000)
        sy.startype(1,:)='type N neutron';
        sy.grav(1)= 1.5 + floor(rand()*150)/100;
        sy.period=[0,0];
      endif
  elseif (a==2)  # variable star table
    b=ceil(rand()*100);
    if (b<3)
        sy.startype(1,:)='Cepheid Variable';
        sy.grav(1)= 4+ floor(rand()*160)/10;
        sy.period= [3, roll(3)];
      elseif (b<8)
        sy.startype(1,:)='MIRA variable';
        sy.grav(1)= 1.5+ floor(rand()*35)/10;
        sy.period=[4, roll(4)];
      elseif (b<23)
        sy.startype(1,:)='RR Lyrae variable';
        sy.grav(1)= 0.4 + ceil(rand()*10)/10;  
        sy.period=[2,roll(1)];
      elseif (b<58)
        sy.startype(1,:)='flaring';
        sy.grav(1)= 0.2 + ceil(rand()*5)/10;  
        sy.period=[0,1];
      else
        sy.startype(1,:)='T Tauri forming';
        sy.grav(1)= 0.4 + ceil(rand()*15)/10;  
        sy.period=[0,2];  
      endif
  else           # old/young stars
    b=ceil(rand()*6);
    if (b==1)
        sy.startype(1,:)='protostar system beginning to form a';
        sy.grav(1)= 0.4+ ceil(rand()*15)/10;
        sy.period=[0,0];
      elseif (b<4)
        sy.startype(1,:)='type T brown dwarf';
        sy.grav(1)= (ceil(rand()*30)+31)/1000;
        sy.period=[0,0];
      else
        sy.startype(1,:)='type D white dwarf';
        sy.grav(1)= 0.3+ ceil(rand()*11)/10;
        syi.period=[0,0];
      endif  
  endif
sy.sector=[0,0];   #  assigned elsewhere
sy.subsector=[0,0];   #  assigned elsewhere
sy.subsectname='Temp'; #  assigned elsewhere
sy.planets=0;           
sy.giants=0;              
sy.asteroids=0;
sy.population=0; 
sy.pop=0; 
sy.gdp=0;                  
sy.gdpmod=0;              
sy.sysgdp=0;             
sy.law=0;                 
sy.govern=0;         
sy.factions=0;       
sy.faction(1)=0;        
sy.tech=0;           
sy.starport='X';    
sy.restriction=1;
  sy.naval=0;          
  sy.consul=0;     
  sy.aid=0;          
  sy.scout=0;        
sy.trade=zeros(1,16);
sy.habnum=0;  
sy.bestp=1;     
sy.bestm=0;      
sy.native=0;
sy.planet(1)=0;  #            size of each individual planet
sy.orbit(1)=0;   #          orbital distance of each planet in millions of km
sy.gravity(1)=0; #          gravity of each planet
sy.radius(1)=0;  #          radius of each planet
sy.rings(1)=0;   #           rings found around planets
sy.atm(1)=0;     #          planetary atmosphere
sy.hydro(1)=0;   #          planetary hydrosphere
sy.temp(1)=0;    #          planetary temperature
sy.habitable(1)=0; #         >0 if planet is habitable
sy.favor(1)=0;             
sy.orbitcount(1,:)=[0 0 0];
sy.orbitcount(2,:)=[0 0 0];
sy.startypenum=7;
sy.starlocation=0;
sy.closeorbit=0;
sy.distantorbit=0;
sy.companions=0;
sy.companion(1)=0;
sy.planetlocate(1)=0;
sy.uwp(1,:)='X000000-0';     #              UWP of each planet
sy.smoons(1)=0;  #          number of small moons per planet
sy.lmoons(1)=0;  #          number of large moons per planet
sy.confed=1;               

sy.axis.tilt(1)=0;
sy.axis.rotation(1)=0;
sy.geothermal(1)=0;
#sy.habit                
  sy.habit.good(1)=0;      
  sy.habit.planet(1)=0;   
  sy.habit.moon(1)=0;      
  sy.habit.size(1)=0;     
  sy.habit.atm(1)=0;       
  sy.habit.hydro(1)=0; 
  sy.habit.temp(1)=0;
  sy.habit.native(1)=0;  
  sy.habit.axis.chg(1)=0;
  sy.habit.axis.temp(1)=0;
  sy.habit.axis.sea(1)=0;
  sy.habit.companion(1)=0; 
#sy.moon                 
  sy.moon.atm(1,1)=0;       
  sy.moon.size(1,1)=0;       
  sy.moon.hydro(1,1)=0;      
  sy.moon.temp(1,1)=0;       
  sy.moon.habitable(1,1)=0;
  sy.moon.uwp(1,1,:)=[0 0 0 0 0 0 0 0 0];       
  sy.moon.gravity(1,1)=0;   
  sy.moon.orbit(1,1)=0;     
  sy.moon.favor(1,1)=0;    
  sy.moon.radius(1,1)=0;     

# sy.race                assigned in alien()           
# sy.transit(a,b)        assigned in full_builder
# sy.populate             assigned in full_populate or racial_empires
# sy.influ                calculated in newconfed
# sy.popcenter(1)         assigned in full_builder 


endfunction

function trav=make_subsector(Xsec, Ysec, tar, syst_oddsystems);

sa=0;
sb=0;
sc=0;
sd=0;
se=0;
sx=0;
snav=0;
ssco=0;
said=0;
scon=0;
st=zeros(16,1);
stech=0;
slaw=0;
shab=0;
spop=0;
sgdp=0;
smoo=0;
vas=0;
obs=0;
mem=0;
adv=0;
amb=0;
red=0;

cnt=1;
# tar=4;   # density of planets in the subsector   1=sparse, 2= scattered, 3= standard, 4=dense  5=very dense   6=packed
           # passed to the make_subsector function now
for x=1:8
  for y=1:10
    if (ceil(rand()*100)>syst_oddsystems)  # if it is not an odd system
        if (ceil(rand()*6)<tar+1)          #if successful, make up a system and give it the sector information
            trav(cnt)=createsys();
            trav(cnt).subsector=[x y];
            trey(cnt)=trav(cnt).sysgdp;
            cnt=cnt+1;
          endif
      else                              # if it is an odd system
        trav(cnt)=oddsys();
        trav(cnt).subsector=[x,y];
        trey(cnt)=trav(cnt).sysgdp;
        cnt=cnt+1;
      endif    
    endfor
  endfor
  
[a,nm]=max(trey);               #find the largest system gdp and name the subsector
for a=1:cnt-1
  trav(a).subsectname=trav(nm).name;
  nat(a)=(trav(a).native>0);     #does this system have a native species?
  trav(a).sector=[Xsec Ysec];    #give each system a sector number to go with the subsector
  endfor
  
endfunction


trav= make_subsector(Xsec, Ysec, M3(Xsec,Ysec), syst_oddsystems);






