# file for writing up a setting description



sa=0;                #count of type A starports
sb=0;                #count of type B starports
sc=0;                #count of type C starports
sd=0;                #count of type D starports
se=0;                #count of type E starports
sx=0;                #count of type X starports
snav=0;              #count of naval bases
ssco=0;              #count of scout bases
said=0;              #count of explorer's aid society hostels
scon=0;              #count of consulates
st=zeros(16,1);      #counts of trade arrays
stech=0;             #for calculating average tech levels
slaw=0;              #for calculating average law level 
shab=0;              #for calculating average number of habitable worlds per system
  shabe=0;                 # easily habitable worlds
  shabs=0;                 # semi-habitable worlds
  shabb=0;                 # barely habitable worlds
  sgeo=0;                  # geothermally habitable worlds
  whab=zeros(15,1);        # count the number of systems with x habitable worlds
spop=0;               #number of uninhabited systems
snat=0;               #number of homeworlds in subsector
sgdp=0;               #GDP sum for averaging across worlds
smoo=0;               #best moons count
vas=0;                #frontier system counts
obs=0;                #observer system count
mem=0;                #member system count
adv=0;                #advisory system counts
amb=0;                #amber system counts
red=0;                #red system counts
sgovs=zeros(15,1);    #count of government types
stl=zeros(16,1);      #count of tech levels
slaws=zeros(10,1);    #count of each law level
demop=zeros(300,1);   #demographics of all races
demow=zeros(300,1);   #count of worlds with each race
spo=0;                #total population
spops=zeros(11,1);    #count of worlds with different population sizes
svegs=0;              #count of vestigial worlds
savi=0;               #count of avian favored worlds
sins=0;               #count of insectan favored worlds
smer=0;               #count of merfolk favored worlds
srep=0;               #count of reptilian favored worlds
stemps=zeros(10,1);   #count of temperatures of habitable worlds
sstars=0;             #total number of stars in star systems
sred=0;               #number of red stars
sora=0;               #number of orange stars
syel=0;               #number of yellow stars
swhi=0;               #number of white stars
sbro=0;               #number of brown dwarfs
sdwf=0;               #number of white dwarfs
sgia=0;               #number of giant stars
svar=0;               #number of variable stars
sfor=0;               #number of forming stars
mpoc=zeros(30,1);     #number of all pocket empires of 1-5, 6-10,... 46-50 in cluster
clear spoc;           #structure for independent pocket empires
spoc(1).name="";      #name of the pocket empire
spoc(1).loc=[0 0 0];  #location of the pocket empire in cluster
spoc(1).number=0;     #number of worlds in the pocket empires
spoc(1).combined=0;   #number of worlds in the combined pocket empires
poccnt=1;             #count of independent pocket empires
clear dpoc;           #structure for dependent pocket empires
dpoc(1).name="";
dpoc(1).loc=[0 0 0];
dpoc(1).number=0;
dcnt=1;               #count of dependent pocket empires
cpoc=zeros(30,1);     #number of combined empires if bins of 5, like mpoc
ssizes=zeros(11,1);   #count of sizes of habitable planets
mconf=zeros(5,1);     #degree of indpendence from Confederation strength
gdpcnt=zeros(10,1);   #array for counting how many of a gdp bin there are
personal=zeros(15,2); #array for counting high and low system personalities
stype=[0 0 0 0];      #array counting singletons, close binaries, distant binaries, and trinary systems  

maxgdp(1)=0;          #array for storing gdp values
maxvotes(1)=0;        #array for storing number of votes in pansophantic assembly
maxpersongdp(1)=0;    #array for storing top individual gdps
maxhabit(1)=0;        #array for storing top #'s of habitable worlds
maxempire(1)=0;       #array for storing largest empires
maxhabscore(1)=0;     #array for storing best uninhabited systems
planetinfluence(1)=0; #array for storing most independent planetary scores
maxlaw(1)=0;          #array for storing highest law systems
maxplanets(1)=0;      #array for storing #planets in a complex system
maxstarship(1)=0;     #array for storing systems building least regulated starships
openports(1)=0;       #array for storing the most open ports with high trade, low law
maxpop(1)=0;          #array for storing maximum populations
maxpsion(1)=0;        #array for most/least favorable worlds for psionics
bestrobots(1)=0;      #array for storing where good robots are most likely
bestchrome(1)=0;      #array for storing where cybernetics are most likely
maxpious(1)=0;        #array for identifying key centers of worship
maxtrade(1)=0;        #array for identifying ports with best trade opportunities
minregs(1)=0;         #array for larger, less regulated systems
maxcaptive(1)=0;      #array for storing the largest captive systems
maxgeneers(1)=0;      #array for finding best gengineering system
maxracist(1)=0;       #array for storing most racist systems
maxisolation(1)=0;    #array for storing most isolationist systems
cbases(1)=0;          #array for storing # of confederation bases to contact weekly
psystems(1)=0;        #array for storing # of pop 6+ systems nearby
jumpsys(1)=0;         #array for storing # of systems which can reach it in 1 jump
sys_ten(1)=0;         #array for storing # of systems nearby with influ 10+
  
trav=tr;
cnt=length(tr)+1;

 # variables used for printing out key concepts 
restrict=['Green'; 'Amber'; 'Red'];
tradecodes=['Ag'; 'Ds'; 'Fl'; 'Ga'; 'Hi'; 'Ht'; 'Ic'; 'In'; 'Lo'; 'Lt'; 'Na'; 'Ni'; 'Po'; 'Ri'; 'Wa'; 'Va'];
habstring=['barely habitable'; 'semi- habitable'; 'easily habitable'];
govstring=['no effective government'; 'a corporation'; 'a participatory democracy'; 'an oligarchy'; 'a republic'; 'a feudal technocracy'; 'a captive government'; 'several balkanized states'; 'a civil service bureaucracy'; 'an impersonal bureaucracy'; 'a charismatic leader'; 'a non-charismatic dictator'; 'a charismatic oligarchy'; 'a religious dictatorship'];
facstring=['minimal'; 'weak'; 'notable'; 'significant'; 'powerful'];
tradestring=['agricultural'; 'desert'; 'fluid ocean'; 'garden'; 'high population'; 'high tech'; 'ice capped'; 'industrial'; 'low population'; 'low tech'; 'non-agricultural'; 'non-industrial'; 'poor'; 'rich'; 'water'; 'vacuum'];
tempstring=['alternating frozen and boiling'; 'frozen ice'; 'very cold'; 'cold'; 'cool'; 'temperate'; 'warm'; 'hot'; 'roasting'; 'boiling'];
atmostring=['no'; 'a trace'; 'a very thin tainted'; 'a very thin'; 'a thin, tainted'; 'a thin'; 'a standard'; 'a standard but tainted'; 'a dense normal'; 'a dense tainted'; 'an exotic'; 'a corrosive'; 'an insidious'; 'a very dense, unbreatheable'];
confedstring=['a frontier'; 'an observer'; 'a member'; 'an advisory'];
present=['-'; 'Y'];
rescode=['-'; 'A'; 'R'];
confed=['None'; 'Front'; ' Obs '; 'Memb '; 'Advis'];
favored=['Avians'; 'Insectans'; 'Merfolk'; 'Reptilians'];
nm=['human';'avian';'insectan';'merfolk';'reptilian';'uplifted ape';'uplifted feline';'uplifted mongoose';'uplifted dolphin'];
mconfstring=['puny'; 'weak'; 'equal'; 'solid'; 'overwhelming'];
ptypes=['cybernetics'; 'enthusiasm'; 'generosity'; 'gengineering'; 'honesty'; 'isolationism'; 'materialism'; 'openmindedness'; 'optimism'; 'order'; 'pacifism'; 'piety'; 'psionics'; 'racism'; 'robots'];
stypesize=['single'; 'close binaries'; 'distant binaries'; 'trinaries'];

# assign names and capabilities to racial abilities
trt(1,:)= 'acid resistance';
trt=cellstr(trt);
desc(1,:)= 'reduces damage caused by acid 50%';
desc=cellstr(desc);

trt(2,:)= 'acid vulnerability';
desc(2,:)= 'allows acid to do 50% extra damage';
trt(3,:)= 'altitude adaptation';
desc(3,:)= 'automatically adapted to high altitude/lower oxygen conditions';
trt(4,:)= 'regeneration';
desc(4,:)= 'allows healing in hours instead of days and allows limbs to regrow';
trt(5,:)= 'bad first impression';
desc(5,:)= 'causes immediate, temporary unfriendly attitude due to appearance/odor';
trt(6,:)= 'blind-fighter';
desc(6,:)= 'allows half normal combat penalties due to lack of vision';
trt(7,:)= 'cold endurance';
desc(7,:)= 'comfortable in the cold, receives -1d6 cold damage';
trt(8,:)= 'cold resistance; fire vulnerability';
desc(8,:)= 'cold adapted.  Half damage from cold, but 50% more from fire';
trt(9,:)= 'electricity resistance';
desc(9,:)= 'reduces damage caused by electricity by 50%';
trt(10,:)= 'observant';
desc(10,:)= 'allows a +2 DM bonus on recon checks';
trt(11,:)= 'fast healing';
desc(11,:)= 'causes +1d6 additional healing per day';
trt(12,:)= 'fire resistance; cold vulnerability';
desc(12,:)= 'heat adapted.  Half damage from fire, but 50% more from cold';
trt(13,:)= 'frightful presence';
desc(13,:)= 'make a leadership skill check or be intimidated with a -1 DM';
trt(14,:)= 'good first impression';
desc(14,:)= 'causes immediate, temporary friendly attitude due to appearance/odor';
trt(15,:)= 'heat endurance';
desc(15,:)= 'comfortable in hot environments, receives -1d6 fire damage';
trt(16,:)= 'hibernation';
desc(16,:)= 'ability to voluntarily enter a deep sleep for up to End days';
trt(17,:)= 'improved grab';
desc(17,:)= 'gives a +2 melee skill in grappling attacks';
trt(18,:)= 'improved grab: constrict';
desc(18,:)= 'gives a +1 melee skill in grappling with 1d6 squeezing damage';
trt(19,:)= 'improved grab: entangle';
desc(19,:)= 'gives a +1 melee skill in grappling with continued holding';
trt(20,:)= 'improved reach';
desc(20,:)= 'gives a +1.5m reach beyond normal for their size';
trt(21,:)= 'no fine manipulators';
desc(21,:)= 'lacks ability to manipulate small items';
trt(22,:)= 'pleasant odor';
desc(22,:)= 'gives +2 DM to detect by scent, make Int check or be unwilling to harm them';
trt(23,:)= 'psionic';
desc(23,:)= 'nearly all members of the species are psionic';
trt(24,:)= 'radiation resistance';
desc(24,:)= 'reduces all radiation exposures by 100 rads';
trt(25,:)= 'anti-psionic';
desc(25,:)= 'gives immunity to psionic abilities, cannot be trained in psionics';
trt(26,:)= 'resistant to diseases';
desc(26,:)= 'gives +2 DM End checks on infections and diseases';
trt(27,:)= 'resistant to fear';
desc(27,:)= 'gives +2 DM on skill checks against fear and intimidation';
trt(28,:)= 'resistant to poisons';
desc(28,:)= 'gives +2 DM on End checks against toxins and poisons';
trt(29,:)= 'resistant to psionics';
desc(29,:)= 'gives +2 DM against all psionics, cannot be trained in psionics';
trt(30,:)= 'spitting attack';
desc(30,:)= 'gives a short range, 1d6 acid attack using athletics skill';
trt(31,:)= 'unusual hand structure';
desc(31,:)= 'gives -1 DM for using instruments designed for humans';
trt(32,:)= 'major unusual life support requirement';
desc(32,:)= 'requires a particular substance or will die from dehydration equivalent';
trt(33,:)= 'minor unusual life support requirement';
desc(33,:)= 'requires a particular substance or will die from starvation equivalent';
trt(34,:)= 'unusual sleep cycle';
desc(34,:)= 'requires sleep on an irregular cycle- unable to adjust physiologically';
trt(35,:)= 'xenoempathy';
desc(35,:)= 'gives +2 DM on carouse rolls due to understanding other species';
trt(36,:)= 'alertness';
desc(36,:)= 'gives a +2 DM on perception based skill checks';
trt(37,:)= 'athletic';
desc(37,:)= 'gives a +2 DM on all athletics skill checks';
trt(38,:)= 'offensive stench';
desc(38,:)= 'causes anyone smelling to make an End check or have -1 DM until leaving the area';
trt(39,:)= 'closed book';
desc(39,:)= 'gives a -2 DM when being read or sensed by others';
trt(40,:)= 'eidetic memory';
desc(40,:)= 'gives perfect memory of previously obtained information';
trt(41,:)= 'fast talker';
desc(41,:)= 'gives +2 DM to verbal deception skill checks';
trt(42,:)= 'gearhead';
desc(42,:)= 'gives a +2 DM for mechanics repair checks';
trt(43,:)= 'bioelectric shock';
desc(43,:)= 'delivers a 1d6 electric shock by touch once per 12 hours';
trt(44,:)= 'haggler';
desc(44,:)= 'gives a +2 DM for any broker check';
trt(45,:)= 'interrogator';
desc(45,:)= 'gives a +2 DM for attempts to extract information from another being';
trt(46,:)= 'intolerant';
desc(46,:)= 'character must make an Int check or take offense at an insult';
trt(47,:)= 'natural advocate';
desc(47,:)= 'gives a +2 DM on advocate checks due to legal tendency';
trt(48,:)= 'natural born leader';
desc(48,:)= 'gives a +2 DM on leadership checks due to species charisma';
trt(49,:)= 'natural compass';
desc(49,:)= 'senses magnetic fields, giving a +2 DM on navigation checks on planets';
trt(50,:)= 'natural pilot';
desc(50,:)= 'gives a +2 DM on pilot checks due to 3D spatial perception';
trt(51,:)= 'natural survivalist';
desc(51,:)= 'gives a +2 DM on survival checks in natural settings';
trt(52,:)= 'natural thief';
desc(52,:)= 'gives a +2 DM on deception checks';
trt(53,:)= 'naturally honest';
desc(53,:)= 'gives a -4 DM when the sophont is telling a lie';
trt(54,:)= 'overly aggressive';
desc(54,:)= 'gives a +2 DM on initiative checks due to violent tendencies';
trt(55,:)= 'racial defense';
desc(55,:)= 'gives a +2 defense bonus in personal combat against a single race';
trt(56,:)= 'racial enemy';
desc(56,:)= 'gives a +1 attack bonus against a single racial enemy';
trt(57,:)= 'racial phobia';
desc(57,:)= 'forces a sophont to make an Int check to overcome their phobia';
trt(58,:)= 'racial weapon';
desc(58,:)= 'gives a +1 attack bonus when using a single historically important weapon';
trt(59,:)= 'well traveled';
desc(59,:)= 'gives a +2 DM on liason checks due to cultural familiarity';
trt(60,:)= 'trustworthy';
desc(60,:)= 'gives -2 DM to bribery, deception, and streetwise checks';
#                 
#                 
trt(63,:)= 'amphibious';
desc(63,:)= 'lives part time in land and water';
trt(64,:)= 'aquatic';
desc(64,:)= 'lives life entirely in the water- can leave for short periods';
trt(65,:)= 'burst of speed';
desc(65,:)= 'move 1.5 m/sec faster than stated speed for End minutes';
trt(66,:)= 'cold blooded';
desc(66,:)= 'gives a -2 DM initiative in cold envrionments; +2 DM vs being found by IR';
trt(67,:)= 'fast metabolism';
desc(67,:)= 'gives a +2 DM initiative, requires 2x life support costs';
trt(68,:)= 'deep diver';
desc(68,:)= 'allows air breathing sophont to dive as deep as 240m';
trt(69,:)= 'desert adaptation';
desc(69,:)= 'gives +2 DM for survival and navigation in desert environments';
trt(70,:)= 'feral';
desc(70,:)= 'uneducatable- roll 1d6 Edu only';
trt(71,:)= 'fragile';
desc(71,:)= 'suffers 1.5x more damage from blunt weapons';
trt(72,:)= 'gravity intolerance';
desc(72,:)= 'gives a -2 DM in normal gravity, -4 DM in high gravity';
trt(73,:)= 'heavy gravity adaptation';
desc(73,:)= 'automatically adapted to high gravity environments';
trt(74,:)= 'low gravity adaptation';
desc(74,:)= 'automatically adapted to low gravity environments';
trt(75,:)= 'slow metabolism';
desc(75,:)= 'gives a -2 DM to initiative, requires only 50% of life support costs';
trt(76,:)= 'stability';
desc(76,:)= 'gives +2 DM to resist forced movement when standing';
trt(77,:)= 'stalwart movement';
desc(77,:)= 'allows movement at full normal speed even when encumbered';
trt(78,:)= 'taint immunity';
desc(78,:)= 'unaffected by presence or absence of atmospheric taint';
trt(79,:)= 'taint breather';
desc(79,:)= 'requires atmospheric taint; treat stnd atmo as tainted';
trt(80,:)= 'trace breather';
desc(80,:)= 'can breathe trace atmospheres without difficulty, but cannot breathe dense atmospheres';
trt(81,:)= 'trace breather, limited';
desc(81,:)= 'allows safely breathing a trace atmosphere for up to 1 hr';
trt(82,:)= 'vacuum survival, limited';
desc(82,:)= 'allows sophont to live for 15 minutes in zero atmosphere safely';
trt(83,:)= 'water dependent';
desc(83,:)= 'sophont can only survive out of the water for 1 hr per 2 pts End';
trt(84,:)= 'atmospheric requirement';
desc(84,:)= 'sophont requires an atmosphere very similar to their own';
trt(85,:)= 'natural swimmer';
desc(85,:)= 'gives a +2 DM on all swimming related skill checks';
trt(86,:)= 'gendermorphic';
desc(86,:)= 'sophont can switch genders over 2d6 days under certain conditions';
trt(87,:)= 'no land movement';
desc(87,:)= 'species does not have an effective way to move around on land';
trt(88,:)= 'multiple limbs';
desc(88,:)= 'species gains one additional action with no penalty- racial multitasking';
trt(89,:)= 'slow speed';
desc(89,:)= 'species moves at a slower speed than humans (less than 6 m/sec)';
trt(90,:)= 'fast speed';
desc(90,:)= 'species moves at a faster speed than humans (more than 8 m/sec)';
trt(91,:)= 'armored';
desc(91,:)= 'species possesses a natural protective armor';
trt(92,:)= 'natural weapon';
desc(92,:)= 'species body has one or more 1d6 weapons as part of their body';
trt(93,:)= 'poisonous';
desc(93,:)= 'bite or stinger attack is poisonous, -1d6 End if End check is failed';
trt(94,:)= 'no vocal cords';
desc(94,:)= 'sophonts lack the physical ability to make vocal noises';
trt(95,:)= 'organic radio communication';
desc(95,:)= 'species can listen and transmit radio waves over 5km distances';
trt(96,:)= 'vibration sense';
desc(96,:)= 'species can detect shapes and locations without light using sound';
trt(97,:)= 'telepathy, limited';
desc(97,:)= 'allows 1.5m range mental communication with any creature with a language';
trt(98,:)= 'telepathy';
desc(98,:)= 'allows medium range mental communication with any creature with a language';
trt(99,:)= 'light sensitivity';
desc(99,:)= 'quick bright light causes blindness for 1 minute.  -1 DM operating in bright light';
trt(100,:)= 'color blindness';
desc(100,:)= 'sophont perceives the world in shades of gray';
trt(101,:)= 'low-light vision';
desc(101,:)= 'species can determine color and detail 2x farther than humans in low light';
trt(102,:)= 'IR vision';
desc(102,:)= 'species sees into the IR (heat) spectrum';
trt(103,:)= 'UV vision';
desc(103,:)= 'species sees into the UV spectrum- sees ionization, electric plasmas';

et1=['producer'; 'scavenger'; 'herbivore'; 'omnivore'; 'carnivore'];
etp=['passive'; 'supplementer'; 'trapper'; 'siren'; 'active'];
ets=['reducer'; 'hijacker'; 'intimidator'; 'carrion-eater'];
eth=['filter'; 'intermittent'; 'grazer'];
eto=['gatherer'; 'hunter'; 'eater'];
etc=['pouncer'; 'trapper'; 'chaser'; 'siren'; 'killer'];
breath=['do not need to breathe'; 'breathe air'; 'breathe water'; 'breathe air or water'];
siz=['tiny'; 'small'; 'average'; 'large'; 'huge']; 
gend=['asexual'; 'hermaphrodites'; 'have 2 genders'; 'have 3 genders'; 'have 4 genders'; 'have 5 genders'];
offsp=['by budding'; 'by bearing their young'; 'by laying eggs'];
symm=['radially'; 'bilaterally'; 'trilaterally'];



for j=1:cnt-1                      # cycle through all systems for accumulations

  stype(trav(j).starlocation+1)=stype(trav(j).starlocation+1)+1;
  snav=snav+trav(j).naval;
  ssco=ssco+trav(j).scout;
  said=said+trav(j).aid;
  scon=scon+trav(j).consul;
  for a=1:16
    st(a)=st(a)+trav(j).trade(a);
    endfor
  stech=stech+trav(j).tech;      #compile info about tech levels
  stl(trav(j).tech+1)=stl(trav(j).tech+1)+1;
  slaw=slaw+trav(j).law;         #compile info about law levels
  slaws(trav(j).law+1)=slaws(trav(j).law+1)+1;
  shab=shab+trav(j).habnum;

cbases(j)=-1*(((tr(j).scout==1)+(tr(j).naval==1)+(tr(j).consul==1))>0);
psystems(j)=-1*(tr(j).population>5);
jumpsys(j)=-1;
sys_ten(j)=-1*(tr(j).influ.self>9);
for a=1:length(tr)
  d=distance_array(j,a);
  if (d<7)
      psystems(j)=psystems(j)+((tr(a).population>5)*(d<(syst_weeklyreport-1))); # nearby million+ systems
      if (syst_pockets==1)   # nearby 10+ influence systems
          sys_ten(j)=sys_ten(j)+((d<syst_weeklyreport-1)*(tr(a).influ.self>9));
        endif
      b=max(0,((tr(a).tech-8)-(tr(a).tech>9)));
      jumpsys(j)=jumpsys(j)+(d<=b); # systems within jump range
      if (syst_confederation==1)
          b=((tr(a).scout==1)+(tr(a).naval==1)+(tr(a).consul==1))>0;
          cbases(j)=cbases(j)+(b*(d<syst_weeklyreport)); # bases reported to every week
        endif
    endif
  endfor
cbases(j)=cbases(j)*(((tr(j).scout==1)+(tr(j).naval==1)+(tr(j).consul==1))>0);  # must have a base 

if ((syst_confederation==1)*(syst_pockets==1))  
  ctst=trav(j).influ.confed-influence(trav(j)); # compile info about confederation influence
  if (ctst>15)
      mconf(5)=mconf(5)+1;
    elseif (ctst>5)
      mconf(4)=mconf(4)+1;
    elseif (ctst>-5)
      mconf(3)=mconf(3)+1;
    elseif (ctst>-14)
      mconf(2)=mconf(2)+1;
    else
      mconf(1)=mconf(1)+1;
    endif 
endif
    
  spop=spop+ (trav(j).population==0);
  whab(trav(j).habnum+1)= whab(trav(j).habnum+1)+1;  # count how many hab worlds per system
  for a=1:trav(j).habnum      #compile info about habitable worlds
    shabe=shabe+ (trav(j).habit.good(a)==3);
    shabs=shabs+ (trav(j).habit.good(a)==2);
    shabb=shabb+ (trav(j).habit.good(a)==1);
    sgeo=sgeo+ trav(j).geothermal(trav(j).habit.planet(a));
    if (trav(j).habit.moon>0)
        f=trav(j).moon.favor(trav(j).habit.planet(a),trav(j).habit.moon(a));
      else
        f=trav(j).favor(trav(j).habit.planet(a));
      endif
    savi=savi+ (f==1);
    sins=sins+ (f==2);
    smer=smer+ (f==3);
    srep=srep+ (f==4);
    stemps(trav(j).habit.temp(a))=stemps(trav(j).habit.temp(a))+1;
    ssizes(trav(j).habit.size(a)+1)=ssizes(trav(j).habit.size(a)+1)+1;  
    endfor
  sgovs(trav(j).govern+1)=sgovs(trav(j).govern+1)+1;  
  sstars=sstars+ trav(j).starnum;  
  for a=1:trav(j).starnum     #compile info about stars in system
    sred=sred+ (trav(j).startype(a,1)=='r');
    sora=sora+ (trav(j).startype(a,1)=='o');
    syel=syel+ (trav(j).startype(a,1)=='y');
    swhi=swhi+ (trav(j).startype(a,1)=='w');
    sbro=sbro+ (trav(j).startype(a,6)=='T');
    sdwf=sdwf+ (trav(j).startype(a,6)=='D');
    svar=svar+ (trav(j).period(2)>0);
    sgia=sgia+ ((trav(j).startype(a,6)=='A')+(trav(j).startype(a,6)=='B')+(trav(j).startype(a,6)=='S')+(trav(j).startype(a,6)=='O')+(trav(j).startype(a,6)=='W'));
    sfor=sfor+ ((trav(j).startype(a,1)=='T')+(trav(j).startype(a,1)=='p'));
    endfor
  svegs=svegs+ ((trav(j).tech<8)*(trav(j).population<4)*(trav(j).population>0)); # count vestigial worlds  
  sgdp=sgdp+ trav(j).gdp;
  gdpcnt(ceil((trav(j).gdp+1)/10000))=gdpcnt(ceil((trav(j).gdp+1)/10000)) +1;
  smoo=smoo+ (trav(j).bestm>0);
  amb=amb+ (trav(j).restriction==1);
  red=red+ (trav(j).restriction==2);
  sa=sa+(trav(j).starport=='A');
  sb=sb+(trav(j).starport=='B');
  sc=sc+(trav(j).starport=='C');
  sd=sd+(trav(j).starport=='D');
  se=se+(trav(j).starport=='E');
  sx=sx+(trav(j).starport=='X');

if (syst_pockets==1)  
  if (trav(j).influ.independent==1)                   #compile info on pocket empires
      spoc(poccnt).loc(1)=trav(j).sector(1);
      spoc(poccnt).loc(2)=trav(j).sector(2);
      spoc(poccnt).loc(3)= j;
      spoc(poccnt).name =trav(j).name;
      spoc(poccnt).number=length(trav(j).influ.dominate)+(trav(j).influ.dominate(1)>0);
      spoc(poccnt).combined=length(trav(j).influ.dominate)+(trav(j).influ.dominate(1)>0);
      mpoc(ceil((spoc(poccnt).number+1)/5))=mpoc(ceil((spoc(poccnt).number+1)/5))+1;
      if (spoc(poccnt).number>1) # if they have an ally check to see if those have a pocket empire
          for a=1:length(trav(j).influ.dominate)
            b=trav(j).influ.ally(a,1);
            c=trav(j).influ.ally(a,2);
            d=trav(j).influ.ally(a,3);
            spoc(poccnt).combined= spoc(poccnt).combined+length(sys(b,c,d).influ.dominate)-1;
            if (sys(b,c,d).influ.dominate(1)>0)
                spoc(poccnt).combined=spoc(poccnt).combined+1;
              endif  
            endfor 
       endif
      cpoc(ceil((spoc(poccnt).combined+1)/5))=cpoc(ceil((spoc(poccnt).combined+1)/5))+1;
      poccnt=poccnt+1;
    elseif (trav(j).influ.dominate(1)>0)
      dpoc(dcnt).loc(1)=trav(j).sector(1);
      dpoc(dcnt).loc(2)=trav(j).sector(2);
      dpoc(dcnt).loc(3)= j;
      dpoc(dcnt).name =trav(j).name;
      dpoc(dcnt).number=length(trav(j).influ.dominate);
      mpoc(ceil(dpoc(dcnt).number/5))=mpoc(ceil(dpoc(dcnt).number/5))+1;
      dcnt=dcnt+1;
    endif
endif

spo=spo+ (trav(j).pop*10^trav(j).population); #compile information on populations
spops(trav(j).population+1)= spops(trav(j).population+1)+1;
snat=snat+ (trav(j).native>0);  

if (syst_popfind==1)    
  test=vertcat(trav(j).populate.pn)(:,1);
  tpp=vertcat(trav(j).populate.pp)(:,1);
  if (test(1)<990)
      for a=1:length(test)                     #compile racial information
        demop(test(a)+1)=demop(test(a)+1)+ ceil(trav(j).pop*(10^(trav(j).population-2))*tpp(a));
        demow(test(a)+1)=demow(test(a)+1)+1;
        endfor
    endif    
endif

if (syst_confederation==1)
  vas=vas+ min(1,((trav(j).population<6)+(trav(j).tech<7)))*(trav(j).planets>0);
  obs=obs+ ((trav(j).population>5)*(trav(j).tech>6)) - ((trav(j).population>6)*(trav(j).tech>8));
  c= ((trav(j).population==10)*(trav(j).tech>12))+ ((trav(j).population==9)*(trav(j).tech==15));
  adv=adv+ c;
  mem=mem+ ((trav(j).population>6)*(trav(j).tech>8))- c;
endif
 
if (syst_personalities==1)  # count through personality array and find those with stronger opinions
    for a=1:15
      personal(a,1)=personal(a,1)+ (trav(j).personality(a)<6);
      personal(a,2)=personal(a,2)+ ((trav(j).personality(a)>9)*(trav(j).personality(a)<16));
    endfor
endif

# count voting delegates in Pansophantic Assembly for later maximizing
if ((syst_confederation==1)*(syst_pockets==1))
    tempcount=1;
    for b=1:length(trav(j).influ.ally(:,1,1));
      if (trav(j).influ.ally(1,1)>0)
          t=sys(trav(j).influ.ally(b,1), trav(j).influ.ally(b,2), trav(j).influ.ally(b,3)).confed;
          tempcount=tempcount+(t>1);
          for c=1:length(sys(tr(j).influ.ally(b,1), tr(j).influ.ally(b,2), tr(j).influ.ally(b,3)).influ.ally(:,1))
            if (sys(tr(j).influ.ally(b,1), tr(j).influ.ally(b,2), tr(j).influ.ally(b,3)).influ.ally(1,1)>0)
                a1=sys(trav(j).influ.ally(b,1), trav(j).influ.ally(b,2), trav(j).influ.ally(b,3)).influ.ally(c,1);
                a2=sys(trav(j).influ.ally(b,1), trav(j).influ.ally(b,2), trav(j).influ.ally(b,3)).influ.ally(c,2);
                a3=sys(trav(j).influ.ally(b,1), trav(j).influ.ally(b,2), trav(j).influ.ally(b,3)).influ.ally(c,3);
                if (a1>0)
                    tempcount=tempcount+(sys(a1,a2,a3).confed>1);
                  endif
              endif
            endfor      
        endif
      endfor
    maxvotes(j)=tempcount;
  endif

# store sysgdp values for later maximizing
maxgdp(j)=trav(j).sysgdp;

# store gdp values for later maximizing
maxpersongdp(j)=trav(j).gdp;

# store number of habitable worlds for later maximizing
maxhabit(j)=trav(j).habnum;

# store largest pocket empires for later maximizing
if (syst_pockets>0)
    maxempire(j)=length(trav(j).influ.ally(:,1));
    maxempire(j)=maxempire(j)-(trav(j).influ.ally(1,1)==0);
  endif

# store the best uninhabited systems for future colonization
maxhabscore(j)=0;
if (trav(j).population==0)
    for a=1:trav(j).habnum
      maxhabscore(j)=maxhabscore(j)+ 4*trav(j).habit.good(a);
      endfor
    maxhabscore(j)=maxhabscore(j)+ trav(j).giants + 2*trav(j).asteroids;
  endif

# store planetary influences
if (syst_pockets==1)
    planetinfluence(j)=trav(j).influ.self- trav(j).influ.confed;
  endif

# store most planets in system
maxplanets(j)=trav(j).planets;

# most influential high law systems
maxlaw(j)=trav(j).law + trav(j).population;

# best system for buying illegal starships
maxstarship(j)=(trav(j).starport=='A')*(trav(j).population- 2*trav(j).law);
if (syst_pockets==1)
    maxstarship(j)=maxstarship(j)+ floor((trav(j).starport=='A')*(trav(j).influ.self-trav(j).influ.confed)/3);
  endif
# large systems, least regulations
minregs(j)=trav(j).population- 2*trav(j).law;
# least regulated ports with good trade options
openports(j)=trav(j).population+ sum(trav(j).trade)- 3*trav(j).law;
if (syst_pockets==1)
    openports(j)=openports(j)+ ceil((trav(j).influ.self-trav(j).influ.confed)/3);
  endif
# maximum profitable trade options
maxtrade(j)=trav(j).population + sum(trav(j).trade);
# largest divided systems
maxcaptive(j)= ((trav(j).govern==6)+(trav(j).govern==7))*trav(j).population;
# highest population worlds
maxpop(j)=trav(j).pop *10^(trav(j).population);

if (syst_personalities==1)
    #max and min psionic worlds
    minpsion(j)=(trav(j).personality(13)<6)*(15-trav(j).personality(13)+ trav(j).population);
    maxpsion(j)= ((trav(j).personality(13)>9)*(trav(j).personality(13)<16))*(trav(j).personality(13)+ 2*trav(j).population);
    #most and least aggressive worlds
    maxagg(j)=(trav(j).personality(11)<6)*(15-trav(j).personality(11)+ trav(j).population);
    minagg(j)= ((trav(j).personality(11)>9)*(trav(j).personality(11)<16))*(trav(j).personality(11)+ 2*trav(j).population);
    #best robots
    bestrobots(j)=((trav(j).personality(15)>9)*(trav(j).personality(15)<16))*(trav(j).personality(15)+ trav(j).tech + 2*trav(j).population);
    #best cybernetics
    bestchrome(j)=((trav(j).personality(1)>9)*(trav(j).personality(1)<16))*(trav(j).personality(1)+ trav(j).tech + 2*trav(j).population);
    #best gengineering systems
    bestgeneers(j)=((trav(j).personality(4)>9)*(trav(j).personality(4)<16))*(trav(j).personality(4)+ trav(j).tech + 2*trav(j).population);
    #most influential racist worlds
    maxracist(j)= ((trav(j).personality(14)>9)*(trav(j).personality(14)<16))*(trav(j).personality(14)+ 2*trav(j).population);
    #most influential pious worlds
    maxpious(j)= ((trav(j).personality(12)>9)*(trav(j).personality(12)<16))*(trav(j).personality(12)+ 2*trav(j).population);
    #most influential isolationist worlds
    maxisolation(j)=((trav(j).personality(6)>9)*(trav(j).personality(6)<16))*(trav(j).personality(6)+ 2*trav(j).population);
  endif
printf("indexed world %d.\n", j);
fflush(stdout);
  endfor    # ends sector counting loop

# print a subsector summary for all systems and overall subsector stats

copyfile("template.css",[newdir "/" newdir ".css"]);
copyfile("masterjava.js", [newdir "/java" newdir ".js"]);
# open the setting file for printing
chdir(newdir);
namefile= [newdir, "_summary.html"];
fid= fopen(namefile, "at");
printf("printing %s.\n", namefile);
fflush(stdout);

# fid=stdout;
fprintf(fid, "<!DOCTYPE html>");
fprintf(fid, "<html>\n");
fprintf(fid, "<head>\n");
fprintf(fid, "<title>%s</title>\n", newdir);
fprintf(fid, "<link href=\"%s.css\" type=\"text/css\" rel=\"stylesheet\" />\n",newdir);
fprintf(fid, "<script src=\"java%s.js\"></script>",newdir);
fprintf(fid, "</head>\n");
fprintf(fid, "<body>\n");
fprintf(fid, "<h1>%s Summary</h1>\n", newdir);
for mx=1:min(length(sys(:,1,1)),10)        #M317 quadrant I
  for my=1:length(sys(1,:,1))
    mn(mx,my)=1;
    mp(mx,my)=0;
    for a=1:length(sys(mx,my,:))
      if (sys(mx,my,a).starnum>0)   #cycle through all systems that have stars defined
          mn(mx,my)=mn(mx,my)+1;
          mp(mx,my)=mp(mx,my)+ (sys(mx,my,a).pop * (10^sys(mx,my,a).population));
        endif
      endfor
    mn(mx,my)=mn(mx,my)-1;  
          
    endfor
  endfor

fprintf(fid, "<table border=\"1\" cellpadding=\"3\">\n <tr>");
fprintf(fid,"<td></td>");
for a=1:length(sys(:,1,1))
  fprintf(fid, "<td><h1 align=\"center\">%d</h1></td>",a);
  endfor
fprintf(fid, "</tr>\n");
for a=1:length(sys(1,:,1))
  fprintf(fid, "<td><h1>&nbsp%d&nbsp</h1></td>", length(sys(1,:,1))+1-a);   # label row 
  for b=1:length(sys(:,1,1)) 
    tref=strcat('S',num2str(b), ',', num2str(length(sys(1,:,1))+1-a), sys(b,length(sys(1,:,1))+1-a,1).subsectname, ".", syst_imagetype);
    fprintf(fid, "<td align=\"center\"><a href=\"%s\" target=\"_blank\">[%d,%d]</a><br><strong><big>%s</big></strong><br>", tref, b, length(sys(1,:,1))+1-a, sys(b,length(sys(1,:,1))+1-a,1).subsectname(:));
    tref2=strcat('S',num2str(b), ',', num2str(length(sys(1,:,1))+1-a), sys(b,length(sys(1,:,1))+1-a,1).subsectname, ".html");
    fprintf(fid, "<a href=\"%s\" target=\"_blank\">%d worlds</a><br>pop %2.2e</td>\n", tref2, mn(b,length(sys(1,:,1))+1-a), mp(b,length(sys(1,:,1))+1-a));
    endfor
  fprintf(fid, "<td><h1>&nbsp%d&nbsp</h1></td></tr>\n", length(sys(1,:,1))+1-a);   # label row
  endfor
fprintf(fid,"<td></td>");
for a=1:length(sys(:,1,1))
  fprintf(fid, "<td><h1 align=\"center\">%d</h1></td>",a);
  endfor
fprintf(fid, "</tr>");
fprintf(fid, "</table>\n");
 
fprintf(fid, "<h2>%s Overview- %d Systems</h2>\n", newdir, length(trav));
fprintf(fid, "<h3><a href=\"%s_setting.png\" target\"_blank\">See the entire setting</a></h3><br>\n", newdir);
fprintf(fid, "\n<p><strong>Starports:</strong> &nbsp;&nbsp; <strong>A:</strong> %d &nbsp;&nbsp;&nbsp; <strong> B:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>C:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>D:</strong> %d &nbsp;&nbsp;&nbsp; <strong> E:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>X:</strong> %d",sa, sb, sc, sd, se, sx);
if (syst_explorer==1)
    fprintf(fid, " &nbsp;&nbsp;&nbsp; <strong> Explorer's Hostels:</strong> %d</p>\n", said);
  else
    fprintf(fid, "</p>\n");
  endif  
fprintf(fid, "\n<p><strong>avg tech:</strong> %.3d &nbsp;&nbsp;&nbsp; <strong>avg law:</strong> %.3d &nbsp;&nbsp;&nbsp; <strong>avg number of habitable worlds:</strong> %.3d &nbsp;&nbsp;&nbsp;  <br><br><strong>avg GDP/system:</strong> %5d Cr &nbsp;&nbsp;&nbsp; <strong>uninhabited systems:</strong> %d  &nbsp;&nbsp; <strong>vestigial:</strong> %d &nbsp;&nbsp;  <strong>amber:</strong> %d &nbsp;&nbsp; <strong>red:</strong> %d</p>\n", (stech/(cnt-1)), (slaw/(cnt-1)), (shab/(cnt-1)), (sgdp/(cnt-1)), spop, svegs, amb, red);
fprintf(fid, "<p><strong>Total Stars:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>red type M:</strong> %d &nbsp;&nbsp;&nbsp; <strong>orange type K:</strong> %d &nbsp;&nbsp;&nbsp; <strong>yellow type G:</strong> %d &nbsp;&nbsp;&nbsp; <strong>white type F:</strong> %d</p>\n", sstars, sred, sora, syel, swhi);
fprintf(fid, "<p><strong>&nbsp;&nbsp;&nbsp;%s:</strong> %d &nbsp;&nbsp;&nbsp;<strong>&nbsp;&nbsp;&nbsp;%s:</strong> %d &nbsp;&nbsp;&nbsp;<strong>&nbsp;&nbsp;&nbsp;%s:</strong> %d &nbsp;&nbsp;&nbsp;", stypesize(2,:), stype(2), stypesize(3,:), stype(3), stypesize(4,:), stype(4));
fprintf(fid, "\n<p>&nbsp;&nbsp;&nbsp; <strong>type D white dwarf:</strong> %d &nbsp;&nbsp;&nbsp; <strong>type T brown dwarf:</strong> %d &nbsp;&nbsp;&nbsp;<strong>giant stars:</strong> %d &nbsp;&nbsp;&nbsp; <strong>variable stars:</strong> %d &nbsp;&nbsp;&nbsp; <strong>forming stars:</strong> %d</p>", sdwf, sbro, sgia, svar, sfor);
fprintf(fid, "\n<p><h2> World and System Summaries</h2></p>\n");
fprintf(fid, "<p><strong>easily habitable:</strong> %d &nbsp;&nbsp; <strong>semi-habitable:</strong> %d &nbsp;&nbsp; <strong>barely habitable:</strong> %d &nbsp;&nbsp; <strong>geothermally habitable:</strong> %d</p>\n", shabe, shabs, shabb, sgeo);
if (syst_race<13)
    fprintf(fid, "<p><strong>homeworlds:</strong> %d &nbsp;&nbsp;&nbsp;  ", snat);
  endif
if (syst_favorable==1)
    fprintf(fid, "<strong>avian favored:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>insectan favored:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>merfolk favored:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>reptilian favored:</strong> %d</p>\n", savi, sins, smer, srep);
  else
    fprintf(fid, "</p>\n");
  endif
a=sum(psystems(:))/length(tr);
fprintf(fid, "<p>An average system has %2.2d other systems within %d parsecs that have populations of at least 1 million.<br>\n",a, syst_weeklyreport-2);   
[a b]= max(psystems(:));
[c d]= min(psystems(:));
fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, tr(b).name(:), c, tr(d).name(:)); 
a=sum(jumpsys(:))/length(tr);
fprintf(fid, "<p>On average there are %2.2d systems which have a technology level allowing them to jump to a particular world.<br>\n",a);   
[a b]= max(jumpsys(:));
[c d]= min(jumpsys(:));
fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, tr(b).name(:), c, tr(d).name(:)); 

fprintf(fid, "\n<table border=\"1\" cellpadding=\"5\"><tr><td align=\"left\" valign=\"top\"><h2>Habitable World<br>Temperatures</h2>\n<ul>");
for a=3:9
  fprintf(fid, "<li> <strong>%s:</strong> %d </li>\n", strtrim(tempstring(a,:)), stemps(a-2));
  endfor
fprintf(fid, "</ul></td>\n<td align=\"left\" valign=\"top\"><h2>Habitable<br>World Sizes</h2>\n<ul>");  
for a=1:11
  fprintf(fid, "<li><strong>siz%d:</strong> %d</li>\n", (a-1), ssizes(a));
  endfor
fprintf(fid, "</ul></td>\n<td align=\"left\" valign=\"top\"><h2>System Population</h2>\n<ul>");
  for a=1:11
  fprintf(fid, "<li><strong>pop #%d:</strong> %d</li>\n",(a-1),spops(a));
  endfor
fprintf(fid, "</ul></td>\n<td align=\"left\" valign=\"top\"><h2>System GDP<br>per Person</h2>\n<ul>");
  for a=1:10
  fprintf(fid, "<li> <strong>%d-%dK:</strong> %d</li>\n",(a-1)*10,a*10, gdpcnt(a));
  endfor

  fprintf(fid, "</ul></td>\n</table><br>\n<table border=\"1\" cellpadding=\"5\"><tr><td align=\"left\" valign=\"top\"><h2>Habitable Worlds<br> per System</h2>\n<ul>");
while (whab(end)==0)
    whab=whab(1:end-1);
  endwhile 
for a=1:length(whab)
  fprintf(fid, "<li> <strong>%d worlds:</strong> %d </li>\n",(a-1), whab(a));
  endfor
fprintf(fid, "</ul></td>\n<td align=\"left\" valign=\"top\"><h2>Trade Codes:</h2>\n<ul>");
for a=1:16
  fprintf(fid, "<li> <strong>%s:</strong> %d </li>\n",tradecodes(a,:), st(a));
  endfor
fprintf(fid, "</ul></td>\n<td align=\"left\" valign=\"top\"><h2>Tech Levels</h2>\n<ul>")  
for a=1:16
  fprintf(fid, "<li> <strong>TL%d:</strong> %d</li>\n",(a-1), stl(a));
  endfor
fprintf(fid, "</ul></td>\n<td align=\"left\" valign=\"top\"><h2>System Law Levels:</h2>\n<ul>")
for a=1:10
  fprintf(fid, "<li> <strong>law %d:</strong> %d</li>\n", (a-1), slaws(a));
  endfor

  fprintf(fid, "</ul></td></tr></table>\n");

printnum=ceil(syst_topprint*length(tr)/100);   #how many worlds to print for lists

# start buttons here for each div options
fprintf(fid, "<h3>System Government Types &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"localgov-cb\" onclick=ToggleText(\"localgov-cb\",\"localgov\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"localgov\" style=\"display:none\">\n<ul>");
for a=1:14
  fprintf(fid, "<li><strong>%s:</strong> %d</li>\n", strtrim(govstring(a,:)), sgovs(a));
  endfor

fprintf(fid, "</ul></div>\n<br><h3>Maximum System GDPs &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"maxsysgdp-cb\" onclick=ToggleText(\"maxsysgdp-cb\",\"maxsysgdp\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"maxsysgdp\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxgdp);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> in subsector %s[%d,%d] has a system GDP of %.2e MCr.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), ((round(tr(ndx).sysgdp/100)*100)/1000000));
  maxgdp(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Highest Average GDPs &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"averagegdp-cb\" onclick=ToggleText(\"averagegdp-cb\",\"averagegdp\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"averagegdp\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxpersongdp);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "Sophonts living in <a href=\"%s\">%s</a> of subsector %s[%d,%d] earn %d Cr annually.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).gdp);
  maxpersongdp(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Systems with Most Habitable Worlds &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"habworlds-cb\" onclick=ToggleText(\"habworlds-cb\",\"habworlds\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"habworlds\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxhabit);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has %d habitable worlds.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), b);
  maxhabit(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Best Unpopulated Systems &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"unpopsys-cb\" onclick=ToggleText(\"unpopsys-cb\",\"unpopsys\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"unpopsys\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxhabscore);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has %d habitable worlds and a score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).habnum, b);
  maxhabscore(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Most Influential High Law Systems &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"highlaw-cb\" onclick=ToggleText(\"highlaw-cb\",\"highlaw\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"highlaw\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxlaw);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a law level of %d and a population score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).law, tr(ndx).population);
  maxlaw(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Least Regulated Shipyards &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"leastship-cb\" onclick=ToggleText(\"leastship-cb\",\"leastship\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"leastship\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxstarship);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a shipyard with law level %d and population score %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).law, tr(ndx).population);
  maxstarship(ndx)=-20;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Most Populous Systems &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"mostpopulous-cb\" onclick=ToggleText(\"mostpopulous-cb\",\"mostpopulous\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"mostpopulous\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxpop);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population of %.2e sophonts.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), b);
  maxpop(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Most Planets &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"mostplanet-cb\" onclick=ToggleText(\"mostplanet-cb\",\"mostplanet\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"mostplanet\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxplanets);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has %d planets overall.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).planets);
  maxplanets(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Most Open Trade Ports &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"openport-cb\" onclick=ToggleText(\"openport-cb\",\"openport\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"openport\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(openports);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a law level of %d and a population score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).law, tr(ndx).population);
  openports(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Best Trade Opportunities &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"besttrade-cb\" onclick=ToggleText(\"besttrade-cb\",\"besttrade\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"besttrade\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxtrade);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and %d trade categories.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, sum(tr(ndx).trade));
  maxtrade(ndx)=0;
  endfor

fprintf(fid, "</p></div>\n<br><h3>Largest Systems with Divided Governments &nbsp <label class=\"switch\">\n");
fprintf(fid, "<input type=\"checkbox\" id=\"dividedsys-cb\" onclick=ToggleText(\"dividedsys-cb\",\"dividedsys\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"dividedsys\" style=\"display:none\">\n<p>");
for a=1:printnum
  [b, ndx]=max(maxcaptive);
  tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
  if (trav(ndx).govern==6)
      tstring="captive";
    elseif (trav(ndx).govern==7)
      tstring="balkanized";
    else
      tstring="";
    endif
  fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a %s government and a population score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tstring, tr(ndx).population);
  maxcaptive(ndx)=0;
  endfor
fprintf(fid, "</p></div>\n");

# Confederation Section Only
if (syst_hierarchy==1)
    fprintf(fid, "<br><p><h2>Confederation Planetary System Status</h2></p>\n<p><strong>frontier worlds:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>observer worlds:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>member worlds:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>advisory worlds:</strong> %d</p>\n",vas, obs, mem, adv);
  endif
if (syst_confederation==1)  
    fprintf(fid, "\n<br><p><h2>Confederation vs. Local influence standing is: </h2></p>\n<p>");
    for a=1:5
      fprintf(fid, "<strong>%s:</strong> %d &nbsp;&nbsp;&nbsp; ",strtrim(mconfstring(a,:)), mconf(a));
      endfor
    fprintf(fid, "</p>\n");  
    fprintf(fid, "\n<p><strong>Naval bases:</strong> %d &nbsp;&nbsp;&nbsp;   <strong>Scout bases:</strong> %d &nbsp;&nbsp;&nbsp;   <strong>Consulates:</strong> %d</p>\n", snav, ssco, scon);
    b=1;
    for a=1:length(tr)
      if (cbases(a)>0)
          cbasetotal(b)=cbases(a);
          cbasetrans(b)= a;
          b=b+1;
        endif
      endfor
    a=sum(cbases(:))/length(cbasetotal);
    fprintf(fid, "<p>The Confederation has a presence in %d of %s's %d systems.</p>",length(cbasetotal), newdir, length(tr));
    fprintf(fid, "<p>On average each base contacts %2.3d other bases within %d parsecs weekly.<br>\n",a, syst_weeklyreport-1);   
    [a b]= max(cbases(:));
    [c d]= min(cbasetotal(:));
    fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, tr(b).name(:), c, trav(cbasetrans(d)).name(:)); 

    #print out distribution of confederation bases
    fprintf(fid, "<h3>Confederation Base Distribution &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"conbase-cb\" onclick=ToggleText(\"conbase-cb\",\"conbase\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"conbase\" style=\"display:none\">\n<p>");
    for aa=1:length(sys(:,1,1))
      for bb=1:length(sys(1,:,1))
        navcount=0;
        sctcount=0;
        concount=0;
        for cc=1:length(sys(1,1,:))
          if (sys(aa,bb,cc).starnum>0)
              navcount=navcount+sys(aa,bb,cc).naval;
              sctcount=sctcount+sys(aa,bb,cc).scout;
              concount=concount+sys(aa,bb,cc).consul;
            endif
          endfor
        tref=strcat('S', num2str(aa), ",", num2str(bb), sys(aa,bb,1).subsectname, ".", syst_imagetype);
        fprintf(fid, "Subsector <a href=\"%s\" target=\"_blank\"> %s [%d,%d]</a> has %d naval bases, %d scount bases, and %d consulates.<br>\n", 
          tref, sys(aa,bb,1).subsectname(:), sys(aa,bb,1).sector(1), sys(aa,bb,1).sector(2), navcount, sctcount, concount);
        endfor
      endfor
  
    #print maximum voting empires
    fprintf(fid, "</p></div>\n<br><h3>Largest Confederation Voting Blocks &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"votingblock-cb\" onclick=ToggleText(\"votingblock-cb\",\"votingblock\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"votingblock\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(maxvotes);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] controls %d votes in the assembly.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), b);
      maxvotes(ndx)=0;
      endfor

    #print most independent planets
    fprintf(fid, "</p></div>\n<br><h3>Most Independent Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"indesys-cb\" onclick=ToggleText(\"indesys-cb\",\"indesys\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"indesys\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(planetinfluence);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] influence surpasses the Confederation by %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), b);
      planetinfluence(ndx)=-10;
      endfor
    fprintf(fid, "</p></div><br>\n");
  endif

#Empires Section
  # clear unused cpoc and mpoc values
if (syst_pockets>0)  
    while (mpoc(end)==0)
      mpoc=mpoc(1:end-1);
      endwhile 
    while (cpoc(end)==0)
      cpoc=cpoc(1:end-1);
      endwhile 
  endif    
  
if (syst_pockets==1)  
    fprintf(fid,"</p>\n\n<table border=\"1\" cellpadding=\"5\"><tr><td align=\"left\" valign=\"top\"><h3>Sizes of Individual Pocket Empires</h3>\n<ul>");
    for a=1:length(mpoc)
      fprintf(fid, "<li><strong>%d-%d worlds:</strong> %d</li>\n", (5*(a-1)+1), (5*a), mpoc(a));
      endfor
    fprintf(fid,"</ul></td>\n<td align=\"left\" valign=\"top\"><h3>Sizes of Combined Pocket Empires</h3>\n<ul>");
    for a=1:length(cpoc)
      fprintf(fid, "<li><strong>%d-%d worlds:</strong> %d</li>\n", (5*(a-1)+1), (5*a), cpoc(a));
      endfor
    fprintf(fid, "</ul></td></tr></table>\n<br>");
    a=sum(sys_ten(:))/length(tr);
    fprintf(fid, "<p>On average there are %2.2d systems within %d parsecs that have an influence of 10 or more.<br>\n",a,syst_weeklyreport-2);   
    [a b]= max(sys_ten(:));
    [c d]= min(sys_ten(:));
    fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, tr(b).name(:), c, tr(d).name(:)); 
    
    fprintf(fid, "<h3>%d Independent Pocket Empires are found in %s &nbsp <label class=\"switch\">\n", (poccnt-1), newdir);
    fprintf(fid, "<input type=\"checkbox\" id=\"pocketemp-cb\" onclick=ToggleText(\"pocketemp-cb\",\"pocketemp\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"pocketemp\" style=\"display:none\">\n<p>");
    for a=1:poccnt-1
      nsec= sys(spoc(a).loc(1),spoc(a).loc(2),1).subsectname;
      tref=strcat('S',num2str(spoc(a).loc(1)), ',', num2str(spoc(a).loc(2)), nsec, ".html#", spoc(a).name);
      tref2=strcat('S',num2str(spoc(a).loc(1)), ',', num2str(spoc(a).loc(2)), nsec, ".", syst_imagetype);
      fprintf(fid, "<li><a href=\"%s\">%s</a> of subsector <a href=\"%s\" target=\"_blank\">[%d,%d] %s</a> influences %d systems directly", tref, spoc(a).name, tref2, spoc(a).loc(1), spoc(a).loc(2), nsec, spoc(a).number);
      if (spoc(a).combined>spoc(a).number)
          fprintf(fid, " and %d systems overall.</li>\n", spoc(a).combined);
        else
          fprintf(fid, ".</li>\n");
        endif  
      endfor
    fprintf(fid, "</ul><br></div>\n<br><h3>There are %d Dependent Pocket Empires in %s &nbsp <label class=\"switch\">\n", (dcnt-1), newdir);
    fprintf(fid, "<input type=\"checkbox\" id=\"dependemp-cb\" onclick=ToggleText(\"dependemp-cb\",\"dependemp\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"dependemp\" style=\"display:none\">\n<p>");
    for a=1:dcnt-1
      nsec= sys(dpoc(a).loc(1),dpoc(a).loc(2),1).subsectname;
      tref=strcat('S',num2str(dpoc(a).loc(1)), ',', num2str(dpoc(a).loc(2)), nsec, ".html#", dpoc(a).name);
      tref2=strcat('S',num2str(dpoc(a).loc(1)), ',', num2str(dpoc(a).loc(2)), nsec, ".", syst_imagetype);
      fprintf(fid, "<li><a href=\"%s\">%s</a> of subsector <a href=\"%s\" target=\"_blank\">[%d,%d] %s</a> has a pocket empire of %d worlds.</li>\n", tref, dpoc(a).name, tref2, dpoc(a).loc(1), dpoc(a).loc(2), nsec, dpoc(a).number);
      endfor  

    #Largest Empires
    fprintf(fid, "</ul></div>\n<br><h3>Largest Pocket Empires &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"largeemp-cb\" onclick=ToggleText(\"largeemp-cb\",\"largeemp\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"largeemp\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(maxempire);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] influences an empire of of %d worlds.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), b+1);
      maxempire(ndx)=0;
      endfor
    fprintf(fid, "</p></div>\n");
  endif
 
#System Personalities Section 
 if (syst_personalities==1)
    fprintf(fid,"<h1>System Personality Traits</h1>\n");
    fprintf(fid, "<table cellpadding=\"0\" cellborder=\"1\"><tr>");
    fprintf(fid, "<td><h3>Against</h3></td><td align=\"center\"><h3> Trait </h3></td><td><h3> For </h3></td></tr>\n");
    for a=1:15
      if (a!=10)
         fprintf(fid, "<tr><td align=\"center\">%d</td><td align=\"center\"><strong> %s </strong></td><td align=\"center\">%d</td></tr>\n", personal(a,1), ptypes(a,:), personal(a,2));      
        endif
      endfor
    fprintf(fid, "</table>\n");
    #best cybernetics systems
    fprintf(fid, "<br><h3>Best Cybernetics Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"bestcyber-cb\" onclick=ToggleText(\"bestcyber-cb\",\"bestcyber\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"bestcyber\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(bestchrome);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and a cybernetics score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(1));
      bestchrome(ndx)=0;
      endfor
    #best gengineering systems
    fprintf(fid, "</p></div>\n<br><h3>Best Gengineers &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"bestgengin-cb\" onclick=ToggleText(\"bestgengin-cb\",\"bestgengin\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"bestgengin\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(bestgeneers);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and a gengineering score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(4));
      bestgeneers(ndx)=0;
      endfor
    #most influential isolationist systems
    fprintf(fid, "</p></div>\n<br><h3>Most Influential Isolationist Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"influiso-cb\" onclick=ToggleText(\"influiso-cb\",\"influiso\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"influiso\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(maxisolation);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and an isolationist score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(6));
      maxisolation(ndx)=0;
      endfor
    #most Aggresssive systems
    fprintf(fid, "</p></div>\n<br><h3>Most Influential Aggressive Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"influaggress-cb\" onclick=ToggleText(\"influaggress-cb\",\"influaggress\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"influaggress\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(maxagg);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and a pacifism score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(11));
      maxagg(ndx)=0;
      endfor
    #most influential nonviolent systems
    fprintf(fid, "</p></div>\n<br><h3>Most Influential Non-Violent Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"influnon-cb\" onclick=ToggleText(\"influnon-cb\",\"influnon\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"influnon\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(minagg);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and a pacifism score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(11));
      minagg(ndx)=0;
      endfor
    #most influential pious systems
    fprintf(fid, "</p></div>\n<br><h3>Most Influential Pious Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"influpious-cb\" onclick=ToggleText(\"influpious-cb\",\"influpious\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"influpious\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(maxpious);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and an pious rating of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(12));
      maxpious(ndx)=0;
      endfor
    #most influential psionic systems
    fprintf(fid, "</p></div>\n<br><h3>Most Influential Psionic Friendly Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"psionfriendly-cb\" onclick=ToggleText(\"psionfriendly-cb\",\"psionfriendly\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"psionfriendly\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(maxpsion);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and a psionic rating of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(13));
      maxpsion(ndx)=0;
      endfor
    #last psionic systems
    fprintf(fid, "</p></div>\n<br><h3>Most Influential Anti-Psionic Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"antipsion-cb\" onclick=ToggleText(\"antipsion-cb\",\"antipsion\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"antipsion\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(minpsion);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and a psionic rating of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(13));
      minpsion(ndx)=0;
      endfor
    #most influential racist systems
    fprintf(fid, "</p></div>\n<br><h3>Most Influential Racist Systems &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"influracist-cb\" onclick=ToggleText(\"influracist-cb\",\"influracist\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"influracist\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(maxracist);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and an racism score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(14));
      maxracist(ndx)=0;
      endfor
    #most influential robotics systems
    fprintf(fid, "</p></div>\n<br><h3>Best Systems for Robotics &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"bestrobot-cb\" onclick=ToggleText(\"bestrobot-cb\",\"bestrobot\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
    fprintf(fid, "<div id=\"bestrobot\" style=\"display:none\">\n<p>");
    for a=1:printnum
      [b, ndx]=max(bestrobots);
      tref=strcat('S',num2str(tr(ndx).sector(1)), ',', num2str(tr(ndx).sector(2)), tr(ndx).subsectname, ".html#", tr(ndx).name);
      fprintf(fid, "<a href=\"%s\">%s</a> of subsector %s[%d,%d] has a population score of %d and a robotics score of %d.<br>\n", tref, tr(ndx).name, tr(ndx).subsectname, tr(ndx).sector(1), tr(ndx).sector(2), tr(ndx).population, tr(ndx).personality(15));
      bestrobots(ndx)=0;
      endfor
    fprintf(fid, "</p></div>\n");
  endif

fprintf(fid,"<br><h2>People</h2></p>\n<h3>A total of %.3e sophonts live in this setting. &nbsp <label class=\"switch\">\n", spo);
fprintf(fid, "<input type=\"checkbox\" id=\"sophontlist-cb\" onclick=ToggleText(\"sophontlist-cb\",\"sophontlist\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h3></label>\n");
fprintf(fid, "<div id=\"sophontlist\" style=\"display:none\">\n<ul>");
if (syst_popfind==1)
for a=1:9
  if (demop(a)>0)
      fprintf(fid, "<li>%.2e %ss live in %d systems.</li>\n", demop(a), strtrim(nm(a,:)), demow(a));
    endif
  endfor 
if (exist("newrace.mat")==2)
  for a=11:(length(newrace)+11)
    if (demop(a)>0)
        hometrunc=strtrunc(newrace(a-11).race.homeworld, index(newrace(a-11).race.homeworld, "-")-1);
        tref=strcat('S',num2str(newrace(a-11).race.sector(1)), ',', num2str(newrace(a-11).race.sector(2)), newrace(a-11).race.subsectname, ".html#", hometrunc);
        tref2=strcat('S',num2str(newrace(a-11).race.sector(1)), ',', num2str(newrace(a-11).race.sector(2)), newrace(a-11).race.subsectname, ".", syst_imagetype);
        fprintf(fid, "<li>%.2e <a href=\"#%s\">%ss</a> live in %d systems. ", demop(a), strtrim(newrace(a-11).race.name), strtrim(newrace(a-11).race.name), demow(a));
        fprintf(fid, "Their homeworld is <a href=\"%s\">%s</a> in the <a href=\"%s\" target=\"_blank\">%s subsector</a>.</li>\n", tref, strtrim(newrace(a-11).race.homeworld), tref2, strtrim(newrace(a-11).race.subsectname));
      endif
    endfor
  endif  
endif
fprintf(fid, "</ul><hr width=\"50%%\" align=\"left\">\n</div>");  

if (syst_race<13)
# initiate racial summary table
    fprintf(fid, "<br><h2>Minor Race Summary Table &nbsp <label class=\"switch\">\n");
    fprintf(fid, "<input type=\"checkbox\" id=\"racesum-cb\" onclick=ToggleText(\"racesum-cb\",\"racesum\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h2></label>\n");
    fprintf(fid, "<div id=\"racesum\" style=\"display:none\">\n<p>");
fprintf(fid,"<table class=\"planets\" cellpadding=\"3\"><tr>");
fprintf(fid,"<th>Name</th><th>Subsector</th><th>Tech Level</th><th>Size</th><th>Move</th><th>Grav</th>");
fprintf(fid,"<th>Breathe</th><th>Temp</th><th>Armor</th><th>Psy</th><th>Weapon</th></tr>\n");

# output racial info for M317 race summary table
rstring=["tiny"; "small"; "avg"; "large"; "huge"];
ttstring=['cycles daily'; 'frozen'; 'v cold'; 'cold'; 'cool'; 'temp'; 'warm'; 'hot'; 'roast'; 'boiling'];

for a=1:length(newrace)
  mstring= [num2str(newrace(a).race.land) " land"];
  if (newrace(a).race.flys>0)
      mstring= [mstring "<br>" num2str(newrace(a).race.flys) " fly"];
    endif
  if (newrace(a).race.climbs>0)
      mstring= [mstring "<br>" num2str(newrace(a).race.climbs) " climb"];
    endif
  if (newrace(a).race.digs>0)
      mstring= [mstring "<br>" num2str(newrace(a).race.digs) " burrow"];
    endif
  if (newrace(a).race.swims>0)
      mstring= [mstring "<br>" num2str(newrace(a).race.swims) " swim"];
    endif 
  if (newrace(a).habit.moon(newrace(a).native)>0)
      gravity= newrace(a).moon.gravity(newrace(a).habit.planet(newrace(a).native), newrace(a).habit.moon(newrace(a).native));
    else
      gravity= newrace(a).gravity(newrace(a).habit.planet(newrace(a).native));
    endif
  if (gravity<0.4)
      gstring="v low";
    elseif (gravity<0.75)
      gstring="low";
    elseif (gravity>1.2)
      gstring="high";
    else
      gstring="norm";
    endif

  psicalc="norm";
  for b=1:newrace(a).race.traits
    if (newrace(a).race.trait(b)==23)
        psicalc="psion";
      elseif (newrace(a).race.trait(b)==25)
        psicalc="anti";
      elseif (newrace(a).race.trait(b)==29)
        psicalc="resist";
      endif
    endfor

  tweapon="";
  for b=1:newrace(a).race.traits
    if (newrace(a).race.trait(b)==6)
        tweapon=[tweapon "<br>blindfight"];
      elseif ((newrace(a).race.trait(b)>16)*(newrace(a).race.trait(b)<20))
        tweapon=[tweapon "<br>imp grab"];
      elseif (newrace(a).race.trait(b)==20)
        tweapon=[tweapon "<br>imp reach"];
      elseif (newrace(a).race.trait(b)==30)
        tweapon=[tweapon "<br>acid spit"];
      elseif (newrace(a).race.trait(b)==38)
        tweapon=[tweapon "<br>stench"];
      elseif (newrace(a).race.trait(b)==43)
        tweapon=[tweapon  "<br>bio shock"];
      elseif (newrace(a).race.trait(b)==93)
        tweapon=[tweapon "<br>poison"];
      endif
    endfor
  if (newrace(a).race.weapon(1)=="n")
      if (length(tweapon)==0)
          weaponprint=[newrace(a).race.weapon];
        else
          weaponprint=tweapon(5:end);
        endif
    else
      if (length(tweapon)==0)
          weaponprint=[newrace(a).race.weapon];
        else
          weaponprint=[newrace(a).race.weapon tweapon];
        endif
    endif

  armadd=num2str(newrace(a).race.armor);
  for b=1:newrace(a).race.traits
    if (newrace(a).race.trait(b)==4)
        armadd=[armadd  "<br>regen"];
      elseif (newrace(a).race.trait(b)==11)
        armadd=[armadd "<br>heal"];
      elseif (newrace(a).race.trait(b)==71)
        armadd=[armadd "<br>fragile"];
      endif
    endfor

  if (newrace(a).race.breathe==1)
      breathe="air";
    elseif (newrace(a).race.breathe==2)
      breathe="water";
    elseif (newrace(a).race.breathe==3)
      breathe="air<br>water";
    endif
  for b=1:newrace(a).race.traits
    if (newrace(a).race.trait(b)==78)
        breathe=[breathe "<br>taint"];
      elseif (newrace(a).race.trait(b)==79)
        breathe= "taint";
        if (newrace(a).race.breathe==3)
            breathe= "taint<br>water";
          endif
      elseif ((newrace(a).race.trait(b)==80)+(newrace(a).race.trait(b)==81))
        breathe= [breathe "<br>trace"];
      endif
    endfor  
  if (newrace(a).race.ecotype(1)==1)
      breathe="none";
    endif
  if (newrace(a).tech<10)
      tl=num2str(newrace(a).tech);
    else
      tl=char('A'-10+newrace(a).tech);
    endif    
#output one row of html table
  tref2=strcat('S',num2str(newrace(a).sector(1)), ',', num2str(newrace(a).sector(2)), newrace(a).subsectname, ".", syst_imagetype);
  fprintf(fid, "<tr><td>%s</td><td><a href=\"%s\" target=\"_blank\">[%d,%d] %s</a></td><td>%s</td>",
    strtrim(newrace(a).race.name(:)), tref2, newrace(a).sector(1), newrace(a).sector(2),newrace(a).subsectname(:), tl);
  fprintf(fid, "<td>%s</td><td>%s</td><td>%s</td><td>%s</td>", rstring(newrace(a).race.size,:), mstring(:), gstring(:), breathe);
  fprintf(fid, "<td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n", ttstring(newrace(a).habit.temp(newrace(a).native)+2,:), armadd(:), psicalc(:), weaponprint(:)); 
  endfor
#terminate html table
  fprintf(fid, "</table></div>\n");

endif


# print out summary of all native sophont races to this setting
if (syst_race<13)  
    fprintf(fid, "<br><h2>%d Minor Races Live in %s &nbsp <label class=\"switch\">\n", snat, newdir);
    fprintf(fid, "<input type=\"checkbox\" id=\"allraces-cb\" onclick=ToggleText(\"allraces-cb\",\"allraces\")>\n");
    fprintf(fid, "<span class=\"slider round\"></span></h2></label>\n");
    fprintf(fid, "<div id=\"allraces\" style=\"display:none\">\n");
for j=1:cnt-1
  if (trav(j).native>0)
      race=trav(j).race;
      if (race.ecotype(1)==1)
          et=etp(race.ecotype(2),:);
        elseif (race.ecotype(1)==2)
          et=ets(race.ecotype(2),:);
        elseif (race.ecotype(1)==3)
          et=eth(race.ecotype(2),:);
        elseif (race.ecotype(1)==4)
          et=eto(race.ecotype(2),:);
        elseif (race.ecotype(1)==5)
          et=etc(race.ecotype(2),:);
        endif
      et=strtrim(et);
      tworld= trav(j).native;
      if (trav(j).habit.moon(tworld)==0)   # get homeworld info whether moon or planet
          hstring=trav(j).uwp(trav(j).habit.planet(tworld),:);
        else
          for a=1:9
            hstring(a)=trav(j).moon.uwp(trav(j).habit.planet(tworld),trav(j).habit.moon(tworld),a);
            endfor
          hstring=char(hstring);
        endif   
      fprintf(fid, "<p><h3><a name=\"%s\">%s</a></h3></p>\n", strtrim(race.name(:)), strtrim(race.name(:)));  
      hometrunc=strtrunc(race.homeworld, index(race.homeworld, "-")-1);
      tref=strcat('S',num2str(race.sector(1)), ',', num2str(race.sector(2)), race.subsectname, ".html#", hometrunc);
      tref2=strcat('S',num2str(race.sector(1)), ',', num2str(race.sector(2)), race.subsectname, ".", syst_imagetype);
      fprintf(fid, "<p>The %ss of %s (UWP %s) are derived from %s-%s stock.<br>\n", strtrim(race.name(:)), strtrim(race.homeworld(:)), hstring, strtrim(et1(race.ecotype(1),:)),et);
      fprintf(fid, "<a href=\"%s\">%s</a> is located in the <a href=\"%s\" target=\"_blank\">[%d,%d] %s subsector</a> at location X-%d Y-%d.<br>\n", tref, race.homeworld, tref2, race.sector(1), race.sector(2), race.subsectname, race.subsector(1), race.subsector(2)); 
      fprintf(fid, "They %s and are %s in size, standing %d+%dd6 cm tall and weighing %d+%dd6 kg.<br>\n",strtrim(breath(race.breathe+1,:)), strtrim(siz(race.size,:)), race.height(1), race.height(2),race.weight(1),race.weight(2));
      fprintf(fid, "They are %s symmetric, %s, and reproduce %s.</p>\n", strtrim(symm(race.symmetry,:)), strtrim(gend(race.gender+1,:)), strtrim(offsp(race.reproduction,:)));
      fprintf(fid, "<p>They have %d limbs,", race.limbs);
      if (race.limbs==race.dual)
          fprintf(fid, " all");
        endif  
      if (race.dual>0)
          fprintf(fid, " %d of which can be used as arms or legs.<br>\n", race.dual);
        else
          fprintf(fid, " %d of which are arms and %d of which are legs.<br>\n", race.arms, race.legs);  
        endif
      fprintf(fid, "Using their limbs, they are ");
      if (race.land==0)
          fprintf(fid, "unable to effectively move on land.</p>\n");
        else
          fprintf(fid, "able to move at %d meters per second on land.</p>\n", race.land);
        endif  
      wing=race.limbs-race.dual-race.arms-race.legs;
      if (wing==0)
          meth='lighter than air gasses';
        else
          wing=wing/race.symmetry;
          meth=strcat(num2str(wing),' set(s) of wings');
        endif  
      if (race.flier>0)
          fprintf(fid, "<p>The race is able to fly at %d m/sec using %s.</p>\n", race.flys, meth);
        endif
      if (race.swimmer>0)
          fprintf(fid, "<p>The race is at home in the water and able to swim at %d m/sec.</p>\n", race.swims);  
        endif
      if (race.burrow>0)
          fprintf(fid, "<p>The race is also able to burrow through the ground at %d m/min.</p>\n", race.digs);
        endif
      if (race.climber>0)
          fprintf(fid, "<p>The race is also able to climb remarkably well, climbing at %d m/sec.</p>\n", race.climbs);
        endif
      fprintf(fid, "\n<p>The race matures at age %d, has %d years in its prime, then begins aging with a ", race.aging(1), race.aging(2));
      if (race.aging(3)>0)
          fprintf(fid, "+");
        endif
      fprintf(fid, "%d DM modifier.</p>\n", race.aging(3));
      fprintf(fid, "<p>Their primary characteristic scores are:<br>\n"); 
      fprintf(fid, "<h3>Str: %dd6",race.str(1));
      if (race.str(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.str(2));
        elseif (race.str(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.str(2));
        endif
      fprintf(fid, "Dex: %dd6",race.dex(1));
      if (race.dex(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.dex(2));
        elseif (race.dex(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.dex(2));
        endif
      fprintf(fid, "End: %dd6",race.endu(1));
      if (race.endu(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.endu(2));
        elseif (race.endu(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.endu(2));
        endif
      fprintf(fid, "Int: %dd6",race.int(1));
      if (race.int(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.int(2));
        elseif (race.int(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.int(2));
        endif
      fprintf(fid, "Edu: %dd6",race.edu(1));
      if (race.edu(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.edu(2));
        elseif (race.edu(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.edu(2));
        endif
      fprintf(fid, "Soc: %dd6",race.soc(1));
      if (race.soc(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.soc(2));
        elseif (race.soc(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.soc(2));
        endif
      fprintf(fid, "Psi: %dd6",race.psy(1));
      if (race.psy(2)>0)
          fprintf(fid, "+%d</h3></p>\n",race.psy(2));
        elseif (race.psy(2)==0)
          fprintf(fid, "</h3></p>\n");
        else
          fprintf(fid, "%d</h3></p>\n",race.psy(2));
        endif
 
      if (race.armor>0)
          fprintf(fid, "<p>They possess %d points of natural armor.<br>\n", race.armor);
        endif
      if (length(race.weapon)>4)
          fprintf(fid, "They have %s which cause d6 extra damage points per hit plus Str modifier.<br>\n", race.weapon);
        endif
      vis=['absent'; 'worse than human'; 'human norm'; 'better than human'];
      fprintf(fid, "In terms of senses, their vision is %s, hearing is %s, and scent is %s.</p>\n\n",strtrim(vis(race.vision+1,:)), strtrim(vis(race.hearing+1,:)), strtrim(vis(race.scent+1,:))); 
      fprintf(fid, "<p>These sophonts have the following special traits:</p>\n<ul>");
      for a=1:race.traits
        t=strvcat(trt(race.trait(a),:));
        d=strvcat(desc(race.trait(a),:));
        fprintf(fid, "<li>   %s: %s</li>\n",t,d);
        endfor
      fprintf(fid, "</ul>\n");  
      fprintf(fid, "<hr width=\"30%%\" align=\"left\">\n");  
    endif
  endfor
  fprintf(fid, "</div>\n");  
endif

fprintf(fid, "<br><h1>%s System Summary &nbsp <label class=\"switch\">\n",newdir);
fprintf(fid, "<input type=\"checkbox\" id=\"systemlist-cb\" onclick=ToggleText(\"systemlist-cb\",\"systemlist\")>\n");
fprintf(fid, "<span class=\"slider round\"></span></h1></label>\n");
fprintf(fid, "<div id=\"systemlist\" style=\"display:none\">\n");
fprintf(fid, "<table class=\"planets\" cellpadding=\"1\"><tr>");
fprintf(fid, "<th>##</th><th>System name</th><th>Loc</th><th>prim UWP</th><th>Subsector</th>\n");
if (syst_confederation==1)
    fprintf(fid, "<th>Nav</th><th>Sco</th><th>Con</th>\n");
  endif
if (syst_explorer==1)
    fprintf(fid, "<th>Aid</th>");
  endif
fprintf(fid,"<th>Res</th><th>Plan</th><th>Gia</th><th>Ast</th><th>Habit</th>\n");
if (syst_race<13)
    fprintf(fid,"<th>Native</th>");
  endif
if (syst_hierarchy==1)
    fprintf(fid,"<th>Confed</th>");
  endif
fprintf(fid,"<th>GDP</th><th>Trade</th></tr>\n");

for a=1:cnt-1
  if (trav(a).bestm==0)
      uwp=trav(a).uwp(trav(a).bestp,:);
    else
      for b=1:9
        uwp(b)=trav(a).moon.uwp(trav(a).bestp, trav(a).bestm,b);
        endfor
    endif  
  tref=strcat('S',num2str(trav(a).sector(1)), ',', num2str(trav(a).sector(2)), trav(a).subsectname, ".html#", trav(a).name);
  tref2=strcat('S',num2str(trav(a).sector(1)), ',', num2str(trav(a).sector(2)), trav(a).subsectname, ".", syst_imagetype);
  fprintf(fid, "<tr><td>%4d</td>\n<td><a href=\"%s\">%s</a></td>\n<td>%2d,%2d</td>\n<td>%s</td><td><a href=\"%s\" target=\"_blank\">%s</a></td>\n", a, tref, trav(a).name, trav(a).subsector(1), trav(a).subsector(2), uwp(:), tref2, strtrim(trav(a).subsectname(:))); 
  if (syst_confederation==1)
      fprintf(fid, "<td>%s</td>\n<td>%s</td>\n<td>%s</td>", present(trav(a).naval+1), present(trav(a).scout+1), present(trav(a).consul+1));
    endif
  if (syst_explorer==1)
      fprintf(fid,"<td>%s</td>", present(trav(a).aid+1));
    endif
  fprintf(fid, "<td>%s</td><td>%2d</td><td>%d</td><td>%d</td><td>%2d</td>", rescode(trav(a).restriction+1), trav(a).planets, trav(a).giants, trav(a).asteroids, trav(a).habnum);
  if (syst_race<13)
      fprintf(fid, "<td>%s</td>", present((trav(a).native>0)+1));
    endif
  if (syst_hierarchy==1)
      fprintf(fid,"<td>%5s</td>\n", confed(trav(a).confed+1,:));
    endif  
  fprintf(fid,"<td align=\"right\">&nbsp; %5s &nbsp;</td><td align=\"left\">", num2str(trav(a).gdp));
  for b=1:16
    if (trav(a).trade(b)>0)
        fprintf(fid, "%s, ", tradecodes(b,:));
      endif
    endfor  
  fprintf(fid, "</td></tr>\n");    
  endfor
fprintf(fid, "</table></div><br>\n");
 
fprintf(fid, "</body>");

fclose(fid);
chdir(olddir);

