#combined functions for mapping
1;
function EWhex(h,v,a,b,c)
  
  line([h+.1 h+.1+a], [v+.1+b v+.1], "color", "k")
  line([h+.1+a h+.1+a+c], [v+.1 v+.1], "color", "k")
  line([h+.1+a+c h+.1+2*c], [v+.1 v+.1+b], "color", "k")
  line([h+.1+2*c h+.1+a+c], [v+.1+b v+.1+2*b], "color", "k")
  line([h+.1+a+c h+.1+a], [v+.1+2*b v+.1+2*b], "color", "k")
  line([h+.1+a h+.1], [v+.1+2*b v+.1+b], "color", "k")
  endfunction

#draw hex subsectors 8x10
function mapdraw(A,B)
c=1;
a=0.5*c;
b=sin(pi/3)*c;
axis ([0 A*12.5 0 B*18.5]);

for y=0:(10*B-1)
  for x=0:(8*A-1)
    # ex,ey = print numbers for map hexes
    ex=num2str(dec2hex(rem(x,8)+1,1));
    ey=num2str(dec2hex(10-rem(y,10),1));
    tx=ceil((x+1)/8);
    ty= ceil((y+1)/10);

# modifier for breaking up the large map sections
# tx=tx+5;
# ty=ty+4;

    if (tx<10)
      sx= num2str(tx);
      else
        sx= char('A'-10+tx);
      endif
    if (ty<10)
      sy= num2str(ty);
      else
        sy= char('A'-10+ty);
      endif
    loc=[sx ex sy ey];

    if (x/2== floor(x/2))
        EWhex((floor(x/2)*3*c), (y*2*b),a,b,c);
        text((floor(x/2)*3*c+b/2+.45), (y*2*b+1.7),loc,"fontsize",8);
      else
        EWhex(floor(x/2)*3*c+(a+c), y*2*b+b,a,b,c)
        text((floor(x/2)*3*c+(a+c)+b/2+.45), (y*2*b+b+1.7),loc,"fontsize",8);         
      endif
    endfor
  endfor

endfunction  

function starcircle(x,y,co,q,s,m,p) # x=Xpos  y=Ypos  co=[R G B] q= scaling oval s=restriction
  col(1,:)=[1 0 0];                 # m=Xsector   p=Ysector
  col(2,:)=[.90 .65 .35];
  col(3,:)=[1 1 0];
  col(4,:)=[1 1 1];
  col(5,:)=[.7 .7 .7];
  col(6,:)=[.4 .25 .25];
  col(7,:)=[.5 .75 1];
  col(8,:)=[0 0 1];
  red=[.75 0 0];
  amber=[.7 .7 0];
  t=(1/80:1/40:1)'*2*pi;
  sx=cos(t)/10;
  sy=sin(t)/10;
  c=1;
  a=0.5*c;
  b=sin(pi/3)*c;
  x=x-1 +8*m;
  y=y-1;
  y=9-y+ 10*p;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
  
      
  fill(1.5*sx+xm, 1.5*sy+0.2+ym, col(co(1),:));
  plot(2.5*sx*q+xm, 2.5*sy+0.2+ym, "color", col(co(1),:), "linewidth", 1)

  cx= -.5:.01:.5;
  if (s==1)  # draw restriction line
      plot(xm+cx, ym-.05, "color", amber, "linewidth",1);
    elseif(s==2)
      plot(xm+cx, ym-.05, "color", red, "linewidth",1);
    endif
    
  endfunction
 
 
function stardraw(x,y,n,ty,s,q,locate,m,p)  #x=xpos, y=ypos, n=#stars, ty=startype, s= system status q= giant scaling factor
sx= [0 -.03 -.12 -.03 0 .03 .12 .03 0];           # locate>1 for distant binaries, anything else is not relevant
sy= [.12 .03 0 -.03 -.12 -.03 0 .03 .12];    # m=Xsector  n=Ysector
col(1,:)=[1 0 0];
col(2,:)=[.90 .65 .35];
col(3,:)=[1 1 0];
col(4,:)=[1 1 1];
col(5,:)=[.75 .75 .75];
col(6,:)=[.4 .25 .25];
col(7,:)=[.5 .75 1];
col(8,:)=[0 0 1];
red=[.75 0 0];
amber=[.7 .7 0];
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1 +8*m;
y=y-1;
y=9-y +10*p;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif

if (n==1)
    fill(2*sx*q+xm, 2*sy*q+0.2+ym, col(ty(1),:));
    
  elseif (n==2)
    if (locate==2)     # distant binaries should be further apart
        wide=0.15;
      else
        wide=0;
      endif
    fill(sx*1.6-.2+xm-wide, sy*1.6+.2+ym, col(ty(1),:));
    fill(sx*1.6+.2+xm+wide, sy*1.6+.2+ym, col(ty(2),:));
  else
    fill(sx*1.4-.25+xm, sy*1.4+.1+ym, col(ty(1),:));
    fill(sx*1.4+xm-.1, sy*1.4+.3+ym, col(ty(2),:));
    fill(sx*1.4+.35+xm, sy*1.4+.1+ym, col(ty(3),:));
  endif  
cx= -.5:.01:.5;

if (s==1)
    plot(xm+cx, ym-.05, "color", amber, "linewidth",1);
  elseif(s==2)
    plot(xm+cx, ym-.05, "color", red, "linewidth",1);
  endif
endfunction  

function startext(x,y,name, uwp, code,m,p)
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1 +8*m;
y=y-1;
y=9-y +10*p;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
    text(xm-0.086*length(name), ym-.23 , name,"fontsize",12);      
    text(xm-.7, ym-.55 ,uwp,"fontsize",9);
    text(xm-.5, ym-.8, code, "fontsize",9);    

endfunction  

function basetext(x,y,n,s,e,co,m,p)
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1 +8*m;
y=y-1;
y=9-y +10*p;

    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
if (n==1)
    text(xm-.6, ym+.4, 'N');    
  endif
if (s==1)
    text(xm-.8, ym+.1, 'S');    
  endif
if (e==1)
    text(xm+.4, ym+.4, 'E');    
  endif
if (co==1)
    text(xm+.6, ym+.1, 'C');    
  endif
  
endfunction


function draw_subsector(sy,newdir);
  
hold on
A=length(sy(:,1,1));
B=length(sy(1,:,1));
printf("This is going to take a while.  Please be patient.\n");
fflush(stdout);

mapdraw(A,B);

for m=1:A
  for p=1:B
    printf("Laying out Sector [%d,%d].\n", m, p);
    fflush(stdout);
    clear trav;
    for j=1:length(sy(m,p,:))
      if (sy(m,p,j).starnum>0)
          trav(j)=sy(m,p,j);
        endif
      endfor
    for j=1:length(trav)
      sn=trav(j).starnum;
      st=[0 0 0];
      for a=1:sn    # choose color for drawing stars
        if ((trav(j).startype(a,1)=='r')+(trav(j).startype(1,6)=='S')+(trav(j).startype(1,1)=='M'))
            st(a)=1;
          elseif ((trav(j).startype(a,1)=='o')+(trav(j).startype(1,1)=='f'))
            st(a)=2;
          elseif ((trav(j).startype(a,1)=='y')+(trav(j).startype(1,1)=='R'))
            st(a)=3;
          elseif ((trav(j).startype(a,1)=='w')+(trav(j).startype(1,6)=='W'))
            st(a)=4;
          elseif ((trav(j).startype(a,6)=='D')+(trav(j).startype(1,1)=='p')+ (trav(j).startype(a,1)=='T'))
            st(a)=5;
          elseif ((trav(j).startype(a,6)=='T')+(trav(j).startype(1,6)=='N'))
            st(a)=6;
          elseif ((trav(j).startype(a,6)=='A')+(trav(j).startype(a,1)=='C'))
            st(a)=7;
          elseif ((trav(j).startype(a,6)=="B")+(trav(j).startype(a,6)=='O'))
            st(a)=8;  
          endif
        endfor
      # define scaling factor for size of star
      if ((trav(j).startype(1,6)=='S')+(trav(j).startype(1,6)=='O')+(trav(j).startype(1,6)=='W')+(trav(j).startype(1,6)=='N')+ (trav(j).startype(1,1)=='p'))
          q=2;
        elseif ((trav(j).startype(1,6)=='A')+(trav(j).startype(1,6)=='B'))
          q=1.5;
        else  
          q=1;
        endif
  
      if ((trav(j).period(2)>0)+(trav(j).startype(1,1)=='p')+(trav(j).startype(1,1)=='T'))
          starcircle(trav(j).subsector(1), trav(j).subsector(2), st, q, trav(j).restriction,m-1,p-1);
        else  
          stardraw(trav(j).subsector(1), trav(j).subsector(2), sn, st, trav(j).restriction,q,trav(j).starlocation,m-1,p-1);
        endif  
      if (trav(j).bestm>0)
          uwp=trav(j).moon.uwp(trav(j).bestp, trav(j).bestm,:);
          uwp=char(reshape(uwp,1,9));
        else
          uwp=trav(j).uwp(trav(j).bestp,:);
        endif
      code=['a' num2str(trav(j).asteroids) 'g' num2str(trav(j).giants) 'h' num2str(trav(j).habnum)];
      startext(trav(j).subsector(1), trav(j).subsector(2), trav(j).name, uwp, code,m-1,p-1);
      basetext(trav(j).subsector(1), trav(j).subsector(2), trav(j).naval, trav(j).scout, trav(j).aid, trav(j).consul,m-1,p-1);  
      endfor
    endfor
  endfor
  
orient("tall");
axis("off");
papersize = [A*8.5 B*11];
        set (gcf, "papersize", papersize)
        set (gcf, "paperposition", [0.25 0.25, papersize-.5])
        
hold off
 namefile= strcat(newdir,'_setting','.png');

 saveas(1,namefile, "png");
 fflush(1);
 close;
endfunction

chdir(newdir);
draw_subsector(trav,newdir);
chdir(olddir);
