# calculates the time to travel from one planet to another in system at 1g

function times=orbit_transit(trav,which)
times(1,1)=0;          # initialize matrix for 1 planet in a planetary system
# which specifies whether to return the primary system (0) or companion system (1)
if (which==0)
    for a=1:(trav.planets-trav.companions)
      for b=1:a
        d=abs(trav.orbit(b)-trav.orbit(a));
        times(a,b)=(2*(d*100000000)^.5)/3600;    
        endfor
      endfor
  else            # second matrix is harder as planet values do not equal orbit values
    for a=(trav.planets-trav.companions+1):trav.planets
      ai=a-(trav.planets-trav.companions);
      for b=(trav.planets-trav.companions+1):a
        bi=b-(trav.planets-trav.companions);
        d=abs(trav.orbit(b)-trav.orbit(a));
        times(ai,bi)=(2*(d*100000000)^.5)/3600;    
        endfor
      endfor
  endif    

#{
printf("Travel Time at 1g accelleration between planets in %s sector (in hours).\n", strtrim(trav.name));
printf("  for higher accelleration, divide by the square root of the ship's speed.\n\n ");

for a=1:trav.planets
  printf("     %2s",num2str(a));
  endfor
for b=1:a  
  printf("\n%2s   ",num2str(b));
  for a=1:b
    printf("%5s  ", strtrunc(num2str(times(b,a)),5));
    endfor
  endfor
printf("\n\n\n");

#}

endfunction  
 