# system personality moderator function
# includes all modifiers for a single indpendent system

function temp= personality(sys)
temp= [0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];

if (exist("newrace.mat")==2)
    load "newrace.mat"  # get all of the possible races
  endif

full_variables
 
# modify based on evolutionary history and race
mrace= [4 4 3 4 5 4 5 4 5]; # ecotypes of standard races

etype(1,:)= [0	0	1	0	0	2	-1	0	0	0	3	0	0	0	0]; # producer
etype(2,:)= [0	1	-2	0	-1	2	0	0	0	-1	-2	0	0	0	0]; # scavenger
etype(3,:)= [0	0	0	0	0	1	0	0	0	0	2	0	0	0	0]; # herbivore
etype(4,:)= zeros(1,15); # omnivore
etype(5,:)= [0	0	0	0	0	0	0	0	0	0	-3	0	0	0	0]; # carnivore

mtrait(1,:)= [0	0	0	-1	0	0	1	0	0	0	0	1	-2	0	0]; # humans
mtrait(2,:)= [0	0	0	0	0	0	0	0	0	0	0	0	0	0	0]; # avians
mtrait(3,:)= [0	0	0	0	0	-5	-3	0	0	4	0	0	0	0	0]; # insectans
mtrait(4,:)= [0	0	0	0	0	1	0	0	0	0	0	0	0	0	0]; # merfolk
mtrait(5,:)= [0	-1	0	0	0	0	0	0	-1	0	-1	0	-4	1	0]; # reptilians
mtrait(6,:)= [0	0	0	2	0	0	0	0	0	0	0	0	0	0	0]; # uplifted apes
mtrait(7,:)= [0	0	0	2	0	2	0	0	0	-1	0	0	0	0	0]; # uplifted felines
mtrait(8,:)= [0	2	-2	2	0	0	0	-2	-1	0	-2	0	0	0	0]; # uplifted mongoose
mtrait(9,:)= [0	2	1	2	0	0	0	0	2	0	0	0	0	0	0]; # uplifted dolphin

#racial trait modifiers
rtrait= zeros(104,15);  # assume a trait has no modifiers
rtrait(4,:)= [-1	0	0	-1	0	0	0	0	0	0	0	0	0	0	0]; # regeneration
rtrait(5,:)= [0	-1	0	0	0	2	0	-2	-1	0	0	0	0	2	0]; # bad first impression
rtrait(6,:)= [0	0	0	0	0	0	0	0	0	0	-2	0	0	0	0]; # blindfighter
rtrait(11,:)= [-1	0	0	0	0	0	0	0	1	0	0	0	0	0	0]; # fast healing
rtrait(13,:)= [0	1	0	0	0	2	0	0	-1	0	0	0	0	1	0]; # frightful presence
rtrait(14,:)= [0	0	0	0	0	-2	0	2	0	0	0	0	0	-2	0]; # good first impression
rtrait(16,:)= [0	-2	0	0	0	2	0	0	0	0	0	0	0	0	0]; # hibernation
rtrait(17,:)= [0	0	0	0	0	0	0	0	0	0	-1	0	0	0	0]; # improved grab
rtrait(18,:)= [0	0	0	0	0	0	0	0	0	0	-1	0	0	0	0]; # improved grab- constrict
rtrait(19,:)= [0	0	0	0	0	0	0	0	0	0	-1	0	0	0	0]; # improved grab- entangle
rtrait(21,:)= [1	0	0	0	0	-2	0	0	0	0	0	0	0	0	1]; # no fine manipulators
rtrait(23,:)= [0	0	0	0	2	0	0	1	0	0	0	0	4	0	0]; # psionic
rtrait(25,:)= [0	0	0	0	0	0	0	0	0	0	0	0	-5	2	0]; # anti-psionic
rtrait(26,:)= [-1	0	0	-1	0	1	0	0	0	0	0	0	0	0	0]; # resistant to disease
rtrait(27,:)= [0	0	1	0	0	0	0	1	2	0	0	0	0	0	0]; # resistant to fear
rtrait(29,:)= [0	0	0	0	0	0	0	0	0	0	0	0	-3	0	0]; # resistant to psionics
rtrait(30,:)= [0	0	0	0	0	0	0	0	0	0	-1	0	0	0	0]; # spitting attack
rtrait(31,:)= [2	0	0	0	0	0	0	0	0	0	0	0	0	0	1]; # unusual hand structure
rtrait(32,:)= [0	0	-1	0	0	0	2	0	-1	0	0	0	0	0	0]; # major life requirement
rtrait(33,:)= [0	0	0	0	0	0	1	0	0	0	0	0	0	0	0]; # minor life requirement
rtrait(34,:)= [0	1	0	0	0	1	0	0	0	0	0	0	0	0	0]; # unusual sleep cycle
rtrait(35,:)= [0	1	0	0	0	0	0	4	1	0	0	0	0	-3	0]; # xenoempathy
rtrait(38,:)= [0	0	0	0	0	2	0	0	0	0	0	0	0	0	0]; # offensive stench
rtrait(39,:)= [0	0	0	0	-3	1	0	-1	0	1	0	0	0	0	0]; # closed book
rtrait(40,:)= [0	0	0	0	1	0	0	1	0	0	0	0	0	0	0]; # eidetic memory
rtrait(41,:)= [0	2	0	0	-2	0	0	1	1	-2	0	0	0	0	0]; # fast talker
rtrait(42,:)= [4	0	0	2	0	0	1	0	0	0	0	0	0	0	4]; # gearhead
rtrait(44,:)= [0	0	-1	0	1	-1	4	0	1	2	0	0	0	0	0]; # haggler
rtrait(45,:)= [0	0	0	0	2	0	0	0	0	2	0	0	0	0	0]; # interrogator
rtrait(46,:)= [0	2	-2	0	0	0	0	0	-1	0	0	0	0	0	0]; # intolerant
rtrait(47,:)= [0	2	0	0	1	0	0	0	0	2	0	0	0	0	0]; # natural advocate
rtrait(48,:)= [0	0	1	0	1	-2	0	0	1	2	0	0	0	-1	0]; # natural born leader
rtrait(51,:)= [0	0	0	0	0	3	0	0	1	-2	0	0	0	0	0]; # natural survivalist
rtrait(52,:)= [0	0	0	0	-4	0	2	0	0	-3	0	0	0	0	0]; # natural thief
rtrait(53,:)= [0	0	0	0	5	0	0	1	0	2	0	0	0	0	0]; # naturally honest
rtrait(54,:)= [0	2	-1	0	-2	1	0	-2	0	-1	-4	0	0	2	0]; # overly aggressive
rtrait(55,:)= [0	0	0	0	0	-1	0	-1	0	2	0	0	0	2	0]; # racial defense
rtrait(56,:)= [0	0	0	0	0	3	0	-1	0	0	0	0	0	5	0]; # racial enemy
rtrait(57,:)= [0	1	0	0	-2	2	0	0	-1	0	0	0	0	1	0]; # racial phobia
rtrait(58,:)= [0	0	0	0	0	0	0	0	0	0	-1	0	0	1	0]; # racial weapon
rtrait(59,:)= [0	1	0	0	0	-4	0	3	1	0	0	0	0	-3	0]; # well traveled
rtrait(60,:)= [0	0	1	0	4	0	0	0	0	2	0	0	0	0	0]; # trustworthy
rtrait(66,:)= [0	-3	0	0	0	0	0	0	0	0	0	0	0	0	0]; # cold- blooded
rtrait(67,:)= [0	0	-1	0	0	0	1	0	0	0	0	0	0	0	0]; # fast metabolism
rtrait(69,:)= [0	0	1	0	0	0	0	0	0	0	0	0	0	0	0]; # desert adaptation
rtrait(70,:)= [-2	0	-2	-2	0	0	0	-2	0	0	0	0	0	0	-3]; # feral
rtrait(71,:)= [0	-1	0	1	0	0	0	0	-1	0	3	0	0	0	1]; # fragile
rtrait(72,:)= [0	0	0	0	0	2	0	0	0	0	0	0	0	0	0]; # gravity intolerant
rtrait(73,:)= [0	-1	0	0	0	0	0	0	0	0	0	0	0	0	0]; # heavy gravity adaptation
rtrait(74,:)= [0	0	0	0	0	1	0	0	0	0	0	0	0	0	0]; # low gravity adaptation
rtrait(75,:)= [0	-3	0	0	0	0	-1	0	0	0	0	0	0	0	0]; # slow metabolism
rtrait(76,:)= [0	0	0	0	0	0	0	0	0	1	0	0	0	0	0]; # stability
rtrait(83,:)= [0	0	0	0	0	2	0	0	0	0	0	0	0	0	0]; # water dependent
rtrait(84,:)= [0	0	0	0	0	2	1	0	0	0	0	0	0	0	0]; # atmospheric requirement
rtrait(86,:)= [0	0	0	0	0	1	0	2	0	0	0	0	0	0	0]; # gendermorphic
rtrait(87,:)= [1	0	0	0	0	1	0	0	0	0	0	0	0	0	1]; # no land movement
rtrait(91,:)= [0	0	0	0	0	0	0	0	0	0	-2	0	0	0	0]; # armored
rtrait(92,:)= [0	0	0	0	0	0	0	0	0	0	-3	0	0	0	0]; # natural weapon
rtrait(94,:)= [1	0	0	0	0	2	0	0	0	0	0	0	1	0	0]; # no vocal cords
rtrait(95,:)= [2	0	0	0	0	-1	0	0	0	0	0	0	0	0	0]; # organic radio communication
rtrait(97,:)= [0	0	1	0	2	-2	0	2	0	1	0	0	2	-1	0]; # telepathy, limited
rtrait(98,:)= [0	0	1	0	3	-3	0	3	0	1	0	0	4	-1	0]; # telepathy

for a=1:length(sys.populate)
  new=sys.populate;
  if (new(a).pn<10)
      echoose= mrace(new(a).pn +1);
      temp= temp + mtrait(new(a).pn +1);
    else
      echoose= newrace(new(a).pn-10).race.ecotype(1);
      for b=1:length(newrace(new(a).pn-10).race.trait)
        temp= temp+ rtrait(newrace(new(a).pn-10).race.trait(b),:);
        endfor  
    endif
  temp= temp + etype(echoose);
  endfor
 
# double race modifications if a homeworld
if (sys.native>0)
  for a=1:length(newrace)
    if (min(sys.sector==newrace(a).sector)* min(sys.subsector==newrace(a).subsector))
        for b=1:newrace(a).race.traits
          temp=temp+rtrait(newrace(a).race.trait(b));
          endfor
      endif
    endfor
  endif  

# modify by bases
if (sys.naval==1)
    temp=temp + [0	0	0	0	0	0	0	1	0	2	-2	0	-2	0	0];
  endif
if (sys.scout==1)
    temp=temp + [0	0	0	0	0	0	0	1	0	1	0	0	-1	0	0];
  endif
if (sys.consul==1)
    temp=temp + [0	0	0	0	1	0	0	0	0	2	0	0	0	0	0];
  endif
if (sys.aid==1)
    temp=temp + [0	0	0	0	0	-1	0	0	0	0	0	0	0	0	0];
  endif

if (sys.starport=='A')
    temp=temp + [2	0	0	0	0	0	0	1	0	0	0	0	0	-1	1];
  elseif (sys.starport=='B')
    temp=temp + [1	0	0	0	0	0	0	1	0	0	0	0	0	0	0];
  elseif (sys.starport=='E')
    temp=temp + [0	0	0	0	0	1	-1	0	0	0	0	0	0	2	0];
  elseif (sys.starport=='X')
    temp=temp + [0	0	0	0	0	2	-2	-1	0	0	0	0	0	3	0];
  endif  

temp(14)=temp(14)+ 4*(syst_racebypocket==1);
  
# modify by government and law
if (sys.govern==7)
    temp=temp + [0	0	-4	0	0	2	0	0	-2	-2	0	0	0	0	0];
  elseif (sys.govern==8)
    temp=temp + [0	0	0	0	0	3	0	0	0	-5	0	0	0	0	0];
  elseif (sys.govern==14)
    temp=temp + [0	0	0	0	0	0	0	-3	0	2	0	5	0	0	0];
  endif  
if (sys.law<2)
    temp=temp + [0	0	0	0	0	0	0	-2	0	0	0	0	0	0	0];
  elseif (sys.law>6)
    temp=temp + [0	0	0	0	0	0	0	+2	0	0	0	0	0	0	0];
  endif
temp(10)=temp(10)-4+sys.law;  
 
# modify by diversity
temp(14)=temp(14) - (length(sys.populate)+3);

# modify by trade characteristics  
trademod(1,:)= [-1	0	0	1	0	0	-1	0	0	0	-1	0	0	0	0];
trademod(2,:)= [0	0	2	0	0	0	0	0	0	0	0	0	0	0	0];
trademod(3,:)= [0	0	0	0	0	0	0	0	-1	0	0	0	0	0	0];
trademod(4,:)= [0	0	0	0	0	0	0	0	1	0	0	0	0	0	0];
trademod(5,:)= [0 0 -1 0 0 -2 1 0 0 1 0 0 0 0 0];
trademod(6,:)= [2	0	0	2	0	0	0	0	0	0	0	0	0	0	2];
trademod(7,:)= [0	0	0	0	0	0	0	0	0	0	0	0	0	0	0];
trademod(8,:)= [1	0	0	0	0	0	2	0	0	0	0	0	0	0	1];
trademod(9,:)= [0	0	2	-1	1	1	0	-2	0	0	0	0	0	1	0];
trademod(10,:)= [-4	0	0	-4	0	0	0	0	0	0	0	0	0	0	-4];
trademod(11,:)= [0	0	0	0	0	0	0	0	0	0	0	0	0	0	0];
trademod(12,:)= [-1	0	0	0	0	0	-1	0	0	0	0	0	0	0	-2];
trademod(13,:)= [0	0	-2	0	0	0	-2	0	-1	-1	0	0	0	0	0];
trademod(14,:)= [0	0	-1	0	0	0	2	0	1	1	0	0	0	0	0];
trademod(15,:)= [0	0	0	1	0	1	0	0	0	0	0	0	0	0	0];
trademod(16,:)= [1	0	1	0	0	-2	0	0	0	1	0	0	0	0	1];

for a=1:16
  temp=temp + (sys.trade(a)==1)*trademod(a,:);
  endfor

# account for general distaste of psionics by most, excluding psionic/telepathic races
#{
cnt=0;
for d=1:length(sys.populate)
  if (sys.populate(d).pn>10)
      traitnum=newrace(sys.populate(d).pn-10).race.traits;
      for e=1:traitnum
        cnt=cnt+(newrace(sys.populate(d).pn-10).race.trait(e)==23)+(newrace(sys.populate(d).pn-10).race.trait(e)>96);
        endfor
    endif
  endfor
temp(13)=temp(13)- 2*(cnt==0);
#}

# add in my personal biases to make numbers for different worlds come out 'better'
mymod=[-2 0 +1 -1 -1 0 -2 -2 0 0 1 0 0 4 -1];
temp=temp + mymod;

endfunction
