#determine the population distribution of systems

function pmix=populate2(sy)
if (exist("newrace.mat")==2)
    load "newrace.mat"  # get all of the possible races
  endif
cur=1;
ndx=1;
pos(1)=0;

full_variables    #make sure variables are loaded properly into the function

pick(cur)=0;
pick(cur+1)=0;   #humans have a standard 6 spots because traveller is humanocentric
pick(cur+2)=0;
pick(cur+3)=0;
pick(cur+4)=0;
pick(cur+5)=0;
cur=cur+6;

if (exist("newrace.mat")==2)   #only run if newrace file exists
  for a=1:length(newrace)
    d=distance(sy,newrace(a));
    c=syst_spread *(newrace(a).population-5);  #base number of hexes distant from their homeworld
    for e=1:newrace(a).race.traits
      c=c-4*(newrace(a).race.trait(e)==32);
      c=c-2*(newrace(a).race.trait(e)==33);
      c=c+4*(newrace(a).race.trait(e)==35);
      c=c-c*(.5*(newrace(a).race.trait(e)==46));
      c=c+c*.5*(newrace(a).race.trait(e)==59);
      endfor
    if (d==0)
        cur=cur-5;                  #humans only get 2 spots on alien homeworlds
        for e=cur:(cur+6)
          pick(e)=a+10;
          endfor
        cur=cur+6;  
      elseif ((d<c)*(newrace(a).tech>8))    # is it close enough to the system and have jump technology?
          pos(ndx)=a;
          ndx=ndx+1;
        endif
  
    endfor  
  endif
  

#set up minor races
for b=5:7
  if ((ceil(rand()*syst_uplifts)==1)*(syst_uplifts>0))
      pick(cur)=b;     #5= uplifted apes, #6=uplifted felines, #7=uplifted mongoose
      cur=cur+1;
    endif
  endfor
  
if (sy.tech>7)   # look at all habitable planets for where races can live
    newhydro=zeros(ndx-1);     #must be 1+ for swimmers
    newfly=zeros(ndx-1);       #must be 1+ for fliers
    newcold=zeros(ndx-1);      #must be 1+ for cold adapted
    newhot=zeros(ndx-1);       #must be 1+ for heat adapted
    newdesert=zeros(ndx-1);    #must be 1+ for desert adapted
    newlowgrav=zeros(ndx-1);   #must be 1+ for low grav adapted
    newhighgrav=zeros(ndx-1);  #must be 1+ for high grav adapted
    newtaint=zeros(ndx-1);     #must be 1+ for taint adapted
    newnondense=zeros(ndx-1);  #must be 1+ for not dense atmo
    newtrace=zeros(ndx-1);     #must be 1+ for trace/thin atmo
    
    fit=pos;
    for a=1:sy.habnum     # +1 per favored habitable world
      if (sy.habit.moon(a)>0)
          fav=sy.moon.favor(sy.habit.planet(a), sy.habit.moon(a));
        else
          fav=sy.favor(sy.habit.planet(a));
        endif  
      if (fav>0)
         pick(cur)=fav;   #1=avians, #2=insectans, #3=merfolk, #4=reptilians
         cur=cur+1;
       endif

      #grab relevant stats for planetary living 
      if (sy.habit.moon(a)>0)
          tmp=sy.moon.temp(sy.habit.planet(a),sy.habit.moon(a));
          grav=sy.moon.gravity(sy.habit.planet(a),sy.habit.moon(a));  
          atmo=sy.moon.atm(sy.habit.planet(a),sy.habit.moon(a));
          hydro=sy.moon.hydro(sy.habit.planet(a),sy.habit.moon(a));
        else
          tmp=sy.temp(sy.habit.planet(a));
          grav=sy.gravity(sy.habit.planet(a));
          atmo=sy.atm(sy.habit.planet(a));
          hydro=sy.hydro(sy.habit.planet(a));
        endif

      if ((ceil(rand()*syst_uplifts)<2)*(hydro>5))
          pick(cur)=8;     #8= uplifted dolphins
          cur=cur+1;
        endif
 
    # check current planet for good conditions for all alien limitations
      for b=1:(ndx-1)
        newhydro(b)=newhydro(b)+(hydro>4); 
        newfly(b)=newfly(b)+(((grav<0.6)*((atmo==6)+(atmo==7))) + ((grav<0.9)*((atmo==8)+(atmo==9))));
        newcold(b)=newcold(b)+(tmp<4);
        newhot(b)=newhot(b)+(tmp>4);
        newdesert(b)=newdesert(b)+(hydro<2);
        newlowgrav(b)=newlowgrav(b)+(grav<0.4);
        newhighgrav(b)=newhighgrav(b)+(grav>1.2);
        newtaint(b)=newtaint(b)+((atmo==4)+(atmo==7)+(atmo==9));
        newnondense(b)=newnondense(b)+(atmo<8);
        newtrace(b)=newtrace(b)+((atmo>1)*(atmo<6));
        endfor          
      for b=1:(ndx-1)
        if (newrace(pos(b)).race.swimmer>0)   
            fit(b)=fit(b)*(newhydro(b)>0);
          endif
        if (newrace(pos(b)).race.flier>0)  
            fit(b)=fit(b)*(newfly(b)>0); 
          endif  
        for c=1:newrace(pos(b)).race.traits
          if ((newrace(pos(b)).race.trait(c)==7)+(newrace(pos(b)).race.trait(c)==8))
              fit(b)=fit(b)*(newcold(b)>0);
            endif
          if ((newrace(pos(b)).race.trait(c)==12)+(newrace(pos(b)).race.trait(c)==15))
              fit(b)=fit(b)+(newhot(b)>0);
            endif
          if (newrace(pos(b)).race.trait(c)==69)
              fit(b)=fit(b)*(newdesert(b)>0);
            endif
          if (newrace(pos(b)).race.trait(c)==72)
              fit(b)=fit(b)*(newlowgrav(b)<0);
            endif
          if (newrace(pos(b)).race.trait(c)==73)
              fit(b)=fit(b)*(newhighgrav(b)>0);
            endif
          if (newrace(pos(b)).race.trait(c)==79)
              fit(b)=fit(b)*(newtaint(b)>0);
            endif
          if (newrace(pos(b)).race.trait(c)==80)
              fit(b)=fit(b)*(newnondense(b)>0);
            endif
          if ((newrace(pos(b)).race.trait(c)==81)+(newrace(pos(b)).race.trait(c)==82))
              fit(b)=fit(b)*(newtrace(b)>0);
            endif
          endfor
        endfor
      endfor
    for a=1:(ndx-1)
      if (fit(a)>0)
          pick(cur)=pos(a)+10;
          cur=cur+1;
        endif
      endfor
  else
    fit=pos;
    if (sy.bestm>0)
        fav=sy.moon.favor(sy.bestp,sy.bestm);
      else
        fav=sy.favor(sy.bestp);
      endif  
    if (fav>0)
       pick(cur)=fav;   #1=avians, #2=insectans, #3=merfolk, #4=reptilians
       cur=cur+1;
       endif

    #grab relevant stats for planetary living 
    if (sy.bestm>0)
        tmp=sy.moon.temp(sy.bestp,sy.bestm);
        grav=sy.moon.gravity(sy.bestp,sy.bestm);  
        atmo=sy.moon.atm(sy.bestp,sy.bestm);
        hydro=sy.moon.hydro(sy.bestp,sy.bestm);
      else
        tmp=sy.temp(sy.bestp);
        grav=sy.gravity(sy.bestp);
        atmo=sy.atm(sy.bestp);
        hydro=sy.hydro(sy.bestp);
      endif
      if ((ceil(rand()*syst_uplifts)<2)*(hydro>5))
          pick(cur)=8;     #8= uplifted dolphins
          cur=cur+1;
        endif
    
    for b=1:(ndx-1)
      if (newrace(pos(b)).race.swimmer>0)   
          fit(b)=fit(b)*(hydro>4);
        endif
      if (newrace(pos(b)).race.flier>0)  
          fit(b)=fit(b)*(((grav<0.6)*((atmo==6)+(atmo==7))) + ((grav<0.9)*((atmo==8)+(atmo==9)))); 
        endif  
      for c=1:newrace(pos(b)).race.traits
        if ((newrace(pos(b)).race.trait(c)==7)+(newrace(pos(b)).race.trait(c)==8))
            fit(b)=fit(b)*(tmp<4);
          endif
        if ((newrace(pos(b)).race.trait(c)==12)+(newrace(pos(b)).race.trait(c)==15))
            fit(b)=fit(b)+(tmp>4);
          endif
        if (newrace(pos(b)).race.trait(c)==69)
            fit(b)=fit(b)*(hydro<2);
          endif
        if (newrace(pos(b)).race.trait(c)==72)
            fit(b)=fit(b)*(grav<0.4);
          endif
        if (newrace(pos(b)).race.trait(c)==73)
            fit(b)=fit(b)*(grav>1.2);
          endif
        if (newrace(pos(b)).race.trait(c)==79)
            fit(b)=fit(b)*((atmo==4)+(atmo==7)+(atmo==9));
          endif
        if (newrace(pos(b)).race.trait(c)==80)
            fit(b)=fit(b)*(atmo<8);
          endif
        if ((newrace(pos(b)).race.trait(c)==81)+(newrace(pos(b)).race.trait(c)==82))
            fit(b)=fit(b)*((atmo>1)*(atmo<6));
          endif
        endfor  
      endfor
  for a=1:(ndx-1)
    if (fit(a)>0)
        pick(cur)=pos(a)+10;
        cur=cur+1;
      endif
    endfor 
  endif

# pick a mix based on the population size
nm=['human';'avian';'insectan';'merfolk';'reptilian';'uplifted ape';'uplifted feline';'uplifted mongoose';'uplifted dolphin'];

if (sy.population==0)
    pmix(1).pname="";
    pmix(1).pp=0;
    pmix(1).pn=999;
  elseif (sy.population<4)               #small populations get one race
    pl(1)=pick(ceil(rand()*length(pick)));
    pmix(1).pn=pl(1);
    pmix(1).pp=94+ceil(rand()*6);
    if (pl>10)
        pmix(1).pname=newrace(pl(1)-10).race.name;
      else  
        pmix(1).pname=nm(pl(1)+1,:);
      endif  
  elseif (sy.population<6)         # less than a million gets 2 races
    pl(1)=pick(ceil(rand()*length(pick)));
    pl(2)=pick(ceil(rand()*length(pick)));
    pmix(1).pn=pl(1);
    if (pl(1)==pl(2))
        pmix(1).pp=96+ceil(rand()*3);
        if (pl(1)>10)
            pmix(1).pname=newrace(pl(1)-10).race.name;
          else  
            pmix(1).pname=nm(pl(1)+1,:);
          endif
      else
        pmix(1).pp=52+ceil(rand()*25);
        pmix(2).pp=99-pmix.pp(1);
        pmix(2).pn=pl(2);
        if (pl(1)>10)
            pmix(1).pname=newrace(pl(1)-10).race.name;
          else  
            pmix(1).pname=nm(pl(1)+1,:);
          endif
        if (pl(2)>10)
            pmix(2).pname=newrace(pl(2)-10).race.name;
          else  
            pmix(2).pname=nm(pl(2)+1,:);
          endif       
      endif 
      
  else                            # more than a million get all races
    pl(1)=pick(1);
    cur=2;
    pcnt(1)=1;
    for a=2:length(pick)
      c=1;
      for b=1:(cur-1)
        if (pl(b)==pick(a))         # if the race had been chosen before
            c=0;
            d=b;
            pick(a)=-1;
          endif 
        endfor
      if (c==0)
          pcnt(d)=pcnt(d)+1;
        else
          pl(cur)=pick(a);
          pcnt(cur)=1;
          cur=cur+1;
        endif
      endfor  
    for a=1:(cur-1)                   # give a percentage of population based on number of 'picks'
      pmix(a).pn=pl(a);
      pmix(a).pp=pcnt(a)*(ceil(rand()*(4*syst_race_numbers))+ syst_race_numbers*2);
      if (pl(a)<10)
          pmix(a).pname=nm(pl(a)+1,:);
        else
          pmix(a).pname=newrace(pl(a)-10).race.name;
        endif
      endfor

    ins=0;  
    for a=1:length(pmix)
      if (pmix(a).pn==0)
          hum=a;
        elseif (pmix(a).pn==2)
          ins=a;
        endif
      endfor
    if (ins>0)
        if ((ceil(rand()*2)==1)*(sy.native==0))
            pmix(hum).pp= pmix(hum).pp+ pmix(ins).pp;      # add back the old insectan population
            pmix(ins).pp= 18+ ceil(rand()*(4*syst_race_numbers)) + syst_race_numbers;   # give them an insectan population greater than 20
            pmix(hum).pp= pmix(hum).pp - pmix(ins).pp;     # subtract the new insectan population
          else
            pmix(hum).pp= pmix(hum).pp+ pmix(ins).pp;
            for a=ins:length(pmix)-1
              pmix(a)=pmix(a+1);
              endfor
            pmix(length(pmix))="";
          endif
      endif
     
  endif
if (sy.tech>8)
    if (sy.population>5)
        cur=0;
#        for a=1:length(pmix)                   # randomize percentages on larger worlds
#          pmix(a).pp= max(3,pmix(a).pp+ceil(rand()*6)+ceil(rand()*6)-7);
#          cur=cur+pmix(a).pp;
#          if (pmix(a).pn==2)
#              cur=cur-pmix(a).pp;
#              pmix(a).pp= max(pmix(a).pp, 19+ ceil(rand()*6));
#              cur=cur+pmix(a).pp;
#            endif
#          endfor
        clear tot
        v=0;  
        for a=1:length(pmix)                # add up population for high determination  
          tot(a)=pmix(a).pp;
          v=v+pmix(a).pp;
          endfor
        if (sy.native>0)                   # if there is a native population, use the largest pp number
            [r i]=max(tot);
            v=v-pmix(i).pp;
            pmix(i).pp=100-v;
          else
            b=0;
            for a=1:length(pmix)
              if (pmix(a).pn==0)            # otherwise human is the largest so use it
                  b=a;
                endif
              endfor
            v=v-pmix(b).pp;
            pmix(b).pp=100-v;
          endif  
      endif    
  else
    tmp=pmix;                        # prestellar tech worlds have only 1 race
    clear pmix;
    pmix(1).pp=100;
    if (sy.native>0)                      # if it happens to be a native race
        for a=1:length(newrace)
          if ((newrace(a).sector(1)==sy.sector(1))*(newrace(a).subsector(1)==sy.subsector(1))*(newrace(a).sector(2)==sy.sector(2))*(newrace(a).subsector(2)==sy.subsector(2)))
              pmix(1).pn= a+10;       
              pmix(1).pname=sy.race.name;
            endif
          endfor  
      else
        u=length(tmp);
        pmix(1).pn=tmp(u).pn;
        pmix(1).pname=tmp(u).pname;
      endif
  endif
  

 
if (pmix(1).pn<999)
    for a=1:length(pmix)
      printf("  %ss make up %d percent of the population.\n", strtrim(pmix(a).pname), pmix(a).pp);
      endfor
  else
    printf("Nobody lives here.\n");
  endif  
printf("\n");      

  
endfunction  
    
  
