# scattered population algorithm designed to have larger spaces between many homeworlds
# syst_scattered=1, syst_pockets=0, syst_pocket_tech_max=0, syst_race_by_pocket=0,
# intended for a pocket empire setting where pocket empires are based on homeworld population and tech


# homeworld   local variable for scattered empire world
# tbonus      local variable for the empire size tech bonus
# empsize     local variable for the radius of the pocket empire
# mainrace    local variable for the race homeworld pocket empire
# raccnt(1)   local array for counting favorabilty of habitable worlds for race determination
# hwarray(x,3)local variable for homeworld coordinates
# cnt         local variable counting the number of homeworlds
# hwdist(x)   local temporary array for calculating distance to all homeworlds
# raccnt      local variable counting number of races

# define arrays for setting up pocket empires
homeworld=zeros(length(sys(:,1,1)), length(sys(1,:,1)), length(sys(1,1,:)));
empsize=zeros(length(sys(:,1,1)), length(sys(1,:,1)), length(sys(1,1,:)));
mainrace=zeros(length(sys(:,1,1)), length(sys(1,:,1)), length(sys(1,1,:)));

# racial preferences for habitable world types
# values are [ temperature hydro atmo-taint atmo-density gravity]
racepref(1,:)=[4 0 0 2 0]; # humans
racepref(2,:)=[4 0 0 2 -1]; # avians
racepref(3,:)=[3 -1 1 2 0]; # insectans
racepref(4,:)=[4 1 0 2 0]; # merfolk
racepref(5,:)=[5 0 0 2 0]; # reptilians
racepref(6,:)=[4 0 0 2 0]; # uplifted ape
racepref(7,:)=[4 0 0 2 0]; # uplifted feline
racepref(8,:)=[4 0 0 2 0]; # uplifted mongoose
racepref(9,:)=[4 1 0 2 0]; # uplifted dolphin

clear newrace;
raccnt=0;

cnt=1;
for a=1:length(sys(:,1,1))
  for b=1:length(sys(1,:,1))
    for c=1:length(sys(a,b,:)) 
      if (sys(a,b,c).starnum>0)
          sys(a,b,c).native=0; # remove all native species
          sys(a,b,c).race=[];
          sys(a,b,c).influ.ally(1,:)=[0 0 0];
          sys(a,b,c).influ.ndx(1,:)=[0 0 0];
          sys(a,b,c).influ.score(1)=0;
          sys(a,b,c).influ.dominate(1)=0;
          homeworld(a,b,c)=(sys(a,b,c).habnum>0)*(ceil(rand()*100)<syst_percent_scatter);  # % habitable systems are homeworlds, 1= true, 0= false
          if homeworld(a,b,c)>0    # give homeworlds key data
              sys(a,b,c).starport='A';    # homeworlds make starships
              d=ceil(rand()*6);
              sys(a,b,c).population= 7*(d==1) + 8*((d==2)+(d==3)) + 9*((d==4)+(d==5)) + 10*(d==6); # homeworld population
              d=floor(rand()*16);
              if (d<4)                    #assign tech levels and size bonus
                  tbonus=0;
                  sys(a,b,c).tech=9;
                elseif (d<7)
                  tbonus=1;
                  sys(a,b,c).tech=10;
                elseif (d<10)  
                  tbonus=1;
                  sys(a,b,c).tech=11;
                elseif (d<12)
                  tbonus=2;
                  sys(a,b,c).tech=12;
                elseif (d<14)
                  tbonus=2;
                  sys(a,b,c).tech=13;
                elseif (d<15)
                  tbonus=3;
                  sys(a,b,c).tech=14;
                else
                  tbonus=3;
                  sys(a,b,c).tech=15;
                endif  
              empsize(a,b,c)=(sys(a,b,c).population-7)+tbonus; # define radius of pocket empire based on tech and population
              # choose homeworld governments, never balkanized or captive
              d=roll(2);
              if (d<3)
                  sys(a,b,c).govern=11;
                elseif (d<4)
                  sys(a,b,c).govern=10;
                elseif (d<6)
                  sys(a,b,c).govern=8;
                elseif (d<7)
                  sys(a,b,c).govern=9;
                elseif (d<8)
                  sys(a,b,c).govern=4;
                elseif (d<9)
                  sys(a,b,c).govern=5;
                elseif (d<10)
                  sys(a,b,c).govern=3;
                elseif (d<12)
                  sys(a,b,c).govern=12;
                else
                  sys(a,b,c).govern=13;
                endif
              if (syst_factions==0)        # only worry about factions if desired
                  sy.factions=0;
                else
                  sys(a,b,c).factions=3+ floor(rand()*4);  # homeworlds have 3-6 factions
                  sys(a,b,c).faction(1)=5;                 # ruling faction is strongest
                  for d=2:(sys(a,b,c).factions+1)
                    sys(a,b,c).faction(d)=floor((roll(2)+1)/3);  # choose faction strengths
                    endfor
                endif  
              sys(a,b,c).law=ceil(rand()*6);                         # determine the law level in the system
              sys(a,b,c).law=sys(a,b,c).law+ ((sys(a,b,c).govern==5)+(sys(a,b,c).govern==10)+(sys(a,b,c).govern==9))*1;
              sys(a,b,c).law=sys(a,b,c).law+ ((sys(a,b,c).govern==11)+(sys(a,b,c).govern==13))*2;
              # determine homeworld race
              if (roll(2)>syst_race);
                  sys(a,b,c).native=ceil(rand()*sys(a,b,c).habnum);
                endif    
              sys(a,b,c).influ.independent=1;
              sys(a,b,c).influ.self= (max(0,(sys(a,b,c).population-4)*3) + max(0,(sys(a,b,c).tech-8))-5*(sys(a,b,c).govern==6)-5*(sys(a,b,c).govern==7))*(sys(a,b,c).tech>8);
              hwarray(cnt,:)=[a b c];
              cnt=cnt+1;
            else
              empsize(a,b,c)=0;
              sys(a,b,c).influ.independent=0;
              sys(a,b,c).native=(roll(2)>syst_race)*(syst_racemod<floor(rand()*(syst_racemod+1)));  # is there a native race on a random system?
            endif
        endif
      endfor
    endfor
  endfor
cnt=cnt-1;  
#now cycle through all the dependent worlds and determine their characteristics  
for a=1:length(sys(:,1,1))
  for b=1:length(sys(1,:,1))
    for c=1:length(sys(a,b,:)) 
      if (sys(a,b,c).starnum>0)
      if (sys(a,b,c).influ.independent==0)
          clear hwdist
          for d=1:cnt
            tmpdist=distance(sys(a,b,c),sys(hwarray(d,1), hwarray(d,2), hwarray(d,3)));
            hwdist(d)=max((empsize(hwarray(d,1), hwarray(d,2), hwarray(d,3))-tmpdist),0);
            endfor
          [e f]=max(hwdist);
          if (e>0)
              # assign dependent world to its homeworld
              for d=1:5
                sys(a,b,c).influ.ndx(d,:)=hwarray(f,:);
                sys(a,b,c).influ.score(d)=e;
                endfor
              # determine subject world population size
              if (sys(a,b,c).native==0)
                  sys(a,b,c).population= sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).population- distance(sys(a,b,c),sys(hwarray(d,1), hwarray(d,2), hwarray(d,3)));
                else  
                  sys(a,b,c).population= syst_racemin+ceil(rand()*3);
                endif
              sys(a,b,c).population= min(sys(a,b,c).population, 10);
              sys(a,b,c).population= max(sys(a,b,c).population, 0);
              
              sys(a,b,c).influ.self= (max(0,(sys(a,b,c).population-4)*3) + max(0,(sys(a,b,c).tech-8))-5*(sys(a,b,c).govern==6)-5*(sys(a,b,c).govern==7))*(sys(a,b,c).tech>8);
              # determine subject world tech level
              sys(a,b,c).tech= sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).tech-min((e-1), floor(rand()*4));
              # add this world as an ally of the homeworld
              g=length(sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).influ.ally)+ (sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).influ.ally(1,1)>0);
              sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).influ.ally(g,:)=[a b c];
              # put after calculating a system's own influence
              sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).influ.dominate(g)=sys(a,b,c).influ.self;
              # assign score to the dependence
              sys(a,b,c).influ.dominate= influence(sys(a,b,c))-distance(sys(a,b,c),sys(hwarray(f,1), hwarray(f,2), hwarray(f,3)));
              #factions for a dominated planet
              if (syst_factions==0)        # only worry about factions if desired
                  sys(a,b,c).factions=0;
                else
                  sys(a,b,c).factions=ceil(rand()*4);  # natives have 1-4 factions
                  sys(a,b,c).faction(1)=5;                 # ruling faction is strongest
                  for d=2:sys(a,b,c).factions+1
                    sys(a,b,c).faction(d)=floor((roll(2)+1)/3);  # choose faction strengths
                    endfor
                endif
              #government type is same as homeworld or a captive government
              sys(a,b,c).govern= sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).govern;  
              if (ceil(rand()*(3+(sys(a,b,c).govern>9)*2))==1)
                  sys(a,b,c).govern=6;
                endif
              # dependent law level
              sys(a,b,c).law=max(sys(hwarray(f,1),hwarray(f,2), hwarray(f,3)).law, floor(rand()*6));
              sys(a,b,c).law= sys(a,b,c).law + 3*(sys(a,b,c).govern==6);  
              # starport for a dominated planet
              if ((sys(a,b,c).population<6)+(sys(a,b,c).habnum>0))
                  sys(a,b,c).starport="D";
                endif
              if ((sys(a,b,c).habnum==0)+(sys(a,b,c).population>5)) 
                  sys(a,b,c).starport="C";
                endif
              if ((sys(a,b,c).population>6)*(sys(a,b,c).tech>7))
                  sys(a,b,c).starport="B";
                endif
              if ((sys(a,b,c).population>7)*(sys(a,b,c).tech>10))
                  sys(a,b,c).starport="A";
                endif
              if (sys(a,b,c).population<4)
                  sys(a,b,c).starport=="C";
                endif  
            elseif (sys(a,b,c).native==0)
              # system is uninhabited
              sys(a,b,c).population=0;
              sys(a,b,c).law=0;
              sys(a,b,c).govern=0;
              sys(a,b,c).tech=0;
              for d=1:sys(a,b,c).factions
                sys(a,b,c).faction(d)=0;
                endfor
              sys(a,b,c).factions=0;
              sys(a,b,c).starport="X";
              sys(a,b,c).restriction=1;  # amber designation if unclaimed
              sys(a,b,c).gdp=0;
              sys(a,b,c).trade= zeros(16,1);
              sys(a,b,c).gdpmod=0;
              sys(a,b,c).sysgdp=0;
            else
              # primitive native sophont (TL<8)
              sys(a,b,c).tech=ceil(rand()*7);
              sys(a,b,c).restriction=2;  # low tech aliens have strong warnings against contact!
              sys(a,b,c).law=floor(rand()*7);
              sys(a,b,c).starport="X";
              if (syst_factions==0)        # only worry about factions if desired
                  sy.factions=0;
                else
                  sys(a,b,c).factions=ceil(rand()*4);  # natives have 1-4 factions
                  sys(a,b,c).faction(1)=5;                 # ruling faction is strongest
                  for d=2:sy.factions+1
                    sys(a,b,c).faction(d)=floor((roll(2)+1)/3);  # choose faction strengths
                    endfor
                endif  
              d=roll(2);
              if (d<3)
                  sy.govern=13;
                elseif (a<4)
                  sy.govern=10;  
                elseif (a<5)
                  sy.govern=12;
                elseif (a<6)
                  sy.govern=5;
                elseif (a<7)
                  sy.govern=3;
                elseif (a<8)
                  sy.govern=7;
                elseif (a<9)
                  sy.govern=4;
                elseif (a<10)
                  sy.govern=8;
                elseif (a<11)
                  sy.govern=9;
                elseif (a<12)
                  sy.govern=11;
                else
                  sy.govern=13;
                endif
            endif  
        endif
      # changes to be made to all worlds, independent or not
      sys(a,b,c).pop= (sys(a,b,c).population>0)*(ceil(rand()*89)+10)/10;  # give them a pop number
      #determine new UWP codes
      for d=1:sys(a,b,c).planets
        sys(a,b,c).uwp(d,:)=[sys(a,b,c).starport, dec2hex(sys(a,b,c).planet(d)), dec2hex(sys(a,b,c).atm(d)), dec2hex(sys(a,b,c).hydro(d)), dec2hex(sys(a,b,c).population), dec2hex(sys(a,b,c).govern), dec2hex(sys(a,b,c).law), '-', dec2hex(sys(a,b,c).tech)];
        for e=1:sys(a,b,c).lmoons(d)
          sys(a,b,c).moon.uwp(d,e,:)=[sys(a,b,c).starport, dec2hex(sys(a,b,c).moon.size(d,e)), dec2hex(sys(a,b,c).moon.atm(d,e)), dec2hex(sys(a,b,c).moon.hydro(d,e)), dec2hex(sys(a,b,c).population), dec2hex(sys(a,b,c).govern), dec2hex(sys(a,b,c).law), '-', dec2hex(sys(a,b,c).tech)]; 
          endfor
        endfor

      # calculate the personal gdp
      sys(a,b,c).gdp= 2000*sys(a,b,c).tech;
      d=1;
      for e=1:sys(a,b,c).habnum
        d=d+ (.05*sys(a,b,c).habit.good(e));
        endfor
      d=d+ (((.05*sys(a,b,c).asteroids)+ (.05*sys(a,b,c).giants))*(sys(a,b,c).tech>7));
      d=d+ (.15*sys(a,b,c).naval)+ (.1*sys(a,b,c).consul) + (.1*sys(a,b,c).aid)+ (.05*sys(a,b,c).scout);
      d=d+ (.2*(sys(a,b,c).starport=='A'))+ (.1*(sys(a,b,c).starport=='B'))- (.2*(sys(a,b,c).starport=='D'))- (.3*(sys(a,b,c).starport=='E'))- (.4*(sys(a,b,c).starport=='X'));
      sys(a,b,c).gdpmod=d;
      sys(a,b,c).gdp= sys(a,b,c).gdp*d;
      sys(a,b,c).sysgdp=sys(a,b,c).gdp*(sys(a,b,c).pop*10^sys(a,b,c).population);

      #determine trade codes
      sys(a,b,c).trade= zeros(16,1);

      d=0;                                   #1= agricultural system- temperate worlds, lower pop
      for e=1:sys(a,b,c).habnum
        d=d+ (sys(a,b,c).habit.size(e)*(sys(a,b,c).habit.good(e)>1));
        endfor
      sys(a,b,c).trade(1)=1*((d/(4.5-(2*syst_middle/50)))>sys(a,b,c).population)*(sys(a,b,c).population>2); 

      if (sys(a,b,c).tech>7)                         #2= desert world, either 1 or 2 on only world, 100% on any habitable world
          for e=1:sys(a,b,c).habnum
            sys(a,b,c).trade(2)=sys(a,b,c).trade(2)+ (sys(a,b,c).habit.hydro(e)<2);
            endfor
          sys(a,b,c).trade(2)=min(sys(a,b,c).trade(2),1);
        else
          if (sys(a,b,c).bestm>0)  
              sys(a,b,c).trade(2)= 1*(sys(a,b,c).moon.hydro(sys(a,b,c).bestp,sys(a,b,c).bestm)<3);
            else
              sys(a,b,c).trade(2)= 1*(sys(a,b,c).hydro(sys(a,b,c).bestp)<2);
            endif
        endif
      if (sys(a,b,c).tech>7)                         #3= fluid ocean world, atm>9, hydro 5+, temp<2
          for e=1:sys(a,b,c).planets
            sys(a,b,c).trade(3)=sys(a,b,c).trade(3)+ 1*((sys(a,b,c).hydro(e)>4)*(sys(a,b,c).temp(e)<2)*(sys(a,b,c).atm(e)>9));
            endfor
          sys(a,b,c).trade(3)=min(sys(a,b,c).trade(3),1);
        endif
      d=0;                                   #4=  garden world (ie. most habitable and temperate) and not too populated
      for e=1:sys(a,b,c).habnum
        d=d+ sys(a,b,c).habit.size(e)*(sys(a,b,c).habit.good(e)==3)*(sys(a,b,c).habit.temp(e)==4);
        endfor
      sys(a,b,c).trade(4)= 1*(d>sys(a,b,c).population);
      sys(a,b,c).trade(5)=1*(sys(a,b,c).population>8);       #5=  hi population system 9 or better
      sys(a,b,c).trade(6)=1*(sys(a,b,c).tech>13);            #6=  hi tech system 14 or better  
      if (sys(a,b,c).tech>7)                         #7=  ice capped world, hydro 5+ and cold or worse habitable world
          for e=1:sys(a,b,c).habnum
            sys(a,b,c).trade(7)=sys(a,b,c).trade(7)+ ((sys(a,b,c).habit.hydro(e)>5)*(sys(a,b,c).habit.temp(e)<3));
            endfor
          sys(a,b,c).trade(7)=min(sys(a,b,c).trade(7),1);
        else
          if (sys(a,b,c).bestm>0)  
              sys(a,b,c).trade(7)= 1*((sys(a,b,c).moon.hydro(sys(a,b,c).bestp,sys(a,b,c).bestm)>4)*(sys(a,b,c).moon.temp(sys(a,b,c).bestp,sys(a,b,c).bestm)<3));
            else
              sys(a,b,c).trade(7)= 1*((sys(a,b,c).hydro(sys(a,b,c).bestp)>4)*(sys(a,b,c).temp(sys(a,b,c).bestp)<3));
            endif
        endif
      if (sys(a,b,c).tech>7)                         #8=  industrial world, populous and poor atm
          for e=1:sys(a,b,c).habnum
            sys(a,b,c).trade(8)=sys(a,b,c).trade(8)+ ((sys(a,b,c).population>6)*((sys(a,b,c).habit.atm(e)==4)+(sys(a,b,c).habit.atm(e)==7)+(sys(a,b,c).habit.atm(e)==9)));
            endfor
          sys(a,b,c).trade(8)=min(sys(a,b,c).trade(8),1);
        endif
      if (sys(a,b,c).habnum==0)
          if (sys(a,b,c).bestm>0)  
              sys(a,b,c).trade(8)= 1*(sys(a,b,c).population>6)*((sys(a,b,c).moon.atm(sys(a,b,c).bestp,sys(a,b,c).bestm)==4)+(sys(a,b,c).moon.atm(sys(a,b,c).bestp,sys(a,b,c).bestm)==7)+(sys(a,b,c).moon.atm(sys(a,b,c).bestp,sys(a,b,c).bestm)==9));
            else
              sys(a,b,c).trade(8)= 1*(sys(a,b,c).population>6)*((sys(a,b,c).atm(sys(a,b,c).bestp)==4)+(sys(a,b,c).atm(sys(a,b,c).bestp)==7)+(sys(a,b,c).atm(sys(a,b,c).bestp)==9));
            endif
        endif
      sys(a,b,c).trade(9)=1*(sys(a,b,c).population<3);       #9=  low population system less than 3
      sys(a,b,c).trade(10)=1*(sys(a,b,c).tech<6);            #10= low tech world without any spaceflight                                 
      d=0;                               #11= non-agricultural, meaning no hab 2 or 3 worlds
      for e=1:sys(a,b,c).habnum
        d=d+ (sys(a,b,c).habit.good(e)>1);
        endfor
      sys(a,b,c).trade(11)=min(1,((sys(a,b,c).habnum==0)+(d==0))); 
      d=0;                                   #12= non-industrial, low pop, at least 1 untainted atmosphere, no asteroids
      f=0;
      d=sys(a,b,c).asteroids+ 1*(sys(a,b,c).population>5);
      for e=1:sys(a,b,c).habnum
        f=f+ 1*((sys(a,b,c).habit.atm(e)==5)+ (sys(a,b,c).habit.atm(e)==6)+ (sys(a,b,c).habit.atm(e)==8));
        endfor
      sys(a,b,c).trade(12)=((d==0)*(f>0));     
      sys(a,b,c).trade(13)=1*(sys(a,b,c).gdpmod<.8);         #13= poor world with gdp modifier less than .8
      sys(a,b,c).trade(14)=1*(sys(a,b,c).gdpmod>1.9);        #14= rich system with gdp modifier greater than 1.9

      if (sys(a,b,c).tech>7)                         #15= water world, either 90%+ on only world, 100% on any world
          for e=1:sys(a,b,c).habnum
            sys(a,b,c).trade(15)=sys(a,b,c).trade(15)+ (sys(a,b,c).habit.hydro(e)>9);
            endfor
          sys(a,b,c).trade(15)=min(sys(a,b,c).trade(15),1);
        else
          if (sys(a,b,c).bestm>0)  
              sys(a,b,c).trade(15)= 1*(sys(a,b,c).moon.hydro(sys(a,b,c).bestp,sys(a,b,c).bestm)>8);
            else
              sys(a,b,c).trade(15)= 1*(sys(a,b,c).hydro(sys(a,b,c).bestp)>8);
            endif
        endif
      sys(a,b,c).trade(16)=1*(sys(a,b,c).atm(sys(a,b,c).bestp)<3);   #16= vacuum worlds
      sys(a,b,c).populate=[];
      # determine native race
      if (sys(a,b,c).native>0)
          new=alien(sys(a,b,c));   #create, print, and identify it
          xenowrite(new);
          new.name= input("What is the name of this race?", "s");
          sys(a,b,c).race=new;
          newrace(raccnt+1)=sys(a,b,c);
          printf("\n\n\n");
          raccnt=raccnt+1;
        endif  
      endif   # from starum>0 early on
      endfor
    endfor
  endfor  
      
      
      