# populate by starport- Class A is required
# also requires determination of favored race by planet
# requires a different description of influence for each world
# replaces influence determination and other pocket empire methods
# should not have confederation, hierarchy, or explorer society
# should not use tech max for a dominant world!
# may need a starbase booster for lower tech clusters


if (exist("newrace.mat")==2)
    load "newrace.mat"  # get all of the possible races
  endif  
more off
favrace=(-1)*ones(length(sys(:,1,1)), length(sys(1,:,1)), length(sys(1,1,:)));  # make favrace vector -1

spccnt=1; # count of worlds making spacecraft
spacerace(spccnt,:)=[0 0 0 0];  # array for worlds making spacecraft
for a=1:length(sys(:,1,1))          # find all spacefaring worlds and their dominant race
  for b=1:length(sys(1,:,1))
    printf("Calculating local influence and starfaring races for subsector %d,%d.\n", a, b);
    for c=1:length(sys(1,1,:))
      if (sys(a,b,c).starnum>0)         # must be a system
          sys(a,b,c).influ.self= influence(sys(a,b,c));   # calculate independent influence of each world
          sys(a,b,c).influ.independent=0;    # worlds default to dependent!
          sys(a,b,c).influ.ally(1,:)=[0 0 0];  # zero out all other influence variables
          sys(a,b,c).influ.ally=sys(a,b,c).influ.ally(1,:);
          sys(a,b,c).influ.dominate=0;
          sys(a,b,c).influ.ndx(1,:)=[0 0 0];
          sys(a,b,c).influ.ndx=sys(a,b,c).influ.ndx(1,:);
          sys(a,b,c).influ.score=0;
          sys(a,b,c).influ.confed=0;
          if (sys(a,b,c).starport=='A')
              spacerace(spccnt,:)=[a b c 0];  # add a new spacefaring world
              if (sys(a,b,c).native>0)
                  for d=1:length(newrace)
                    e=distance(sys(a,b,c), newrace(d));
                    if (e==0)                      # if the spacefaring world is a homeworld, it is the favored race
                        spacerace(spccnt,4)=d+10;
                        break
                      endif
                    endfor  
                else
                  if (roll(2)>(5+floor(syst_uplifts/5))*syst_nouplift)  # choose an uplifted race if available
                      spacerace(spccnt,4)=4+ceil(rand()*3);
                    else
                      if (sys(a,b,c).habnum==0)         # choose a random major race if no habitable worlds
                          spacerace(spccnt,4)=floor(rand()*5);     
                        else                            # choose a habitable world and make it's favored race the empire's
                          spacerace(spccnt,4)= sys(a,b,c).favor(sys(a,b,c).habit.planet(ceil(rand()*sys(a,b,c).habnum)));
                        endif  
                    endif  
                endif
              favrace(a,b,c)=spacerace(spccnt,4); # make the favored race the same as the spacerace
              spccnt=spccnt+1;
              sys(a,b,c).influ.independent=1;  # spacefaring worlds are all independent but may still be dominated by local spacefaring powers
            endif    
        endif
      endfor
    endfor
  endfor
spccnt=spccnt-1; # cut count back to actual number of spacefaring races


#government modifiers for influence determination
gov(1,:)= [ 3  0  0 -3  0  0  3 -3  0  0 -3 -3 -3 -3];
gov(2,:)= [ 0  3  0  0  0  0  3 -3  0  0  0  0  0 -3];
gov(3,:)= [ 0  0  3 -3  3  0  3 -3  0  0 -3 -3 -3 -3];
gov(4,:)= [-3  0 -3  3 -3  0  3 -3 -3 -3  3  3  3 -3];
gov(5,:)= [ 0  0  3 -3  3  0  3 -3  0  0 -3 -3 -3 -3];
gov(6,:)= [ 0  0  0 -3  0  3  3 -3  3  3 -3 -3 -3 -3];
gov(7,:)= [-5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5];
gov(8,:)= [-5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5];
gov(9,:)= [ 0  0  0 -3  0  3  3 -3  3  3 -3 -3 -3 -3];
gov(10,:)=[ 0  0  0 -3  0  3  3 -3  3  3 -3 -3 -3 -3];
gov(11,:)=[-3 -3 -3  3 -3 -3  3 -3 -3 -3  3  3  3 -3];
gov(12,:)=[-3 -3 -3  3 -3 -3  3 -3 -3 -3  3  3  3 -3];
gov(13,:)=[-3 -3 -3  3 -3 -3  3 -3 -3 -3  3  3  3 -3];
gov(14,:)=[-3 -3 -3 -3 -3 -3  3 -3 -3 -3 -3 -3 -3 -3];

# race names for non-native sophonts
nm=['human';'avian';'insectan';'merfolk';'reptilian';'uplifted ape';'uplifted feline';'uplifted mongoose';'uplifted dolphin'];

for a=1:length(sys(:,1,1))          # find dominant systems and favorite race for each system
  for b=1:length(sys(1,:,1))
    printf("Identifying dominant systems for subsector %d,%d.\n", a, b);
    for c=1:length(sys(1,1,:))
      if (sys(a,b,c).starnum>0)         # must be a system
          clear infs
          for d=1:spccnt  #calculate all spacefaring influences
            spacer= sys(spacerace(d,1),spacerace(d,2),spacerace(d,3));
            e=distance(sys(a,b,c), spacer);              
            infs(d)=spacer.influ.self-2*e +(2-abs(spacer.law-sys(a,b,c).law))+gov(spacer.govern+1,sys(a,b,c).govern+1);
            endfor
          e=1;
          while (e<6)  # loop through up to 5 times
            [d sr]= max(infs);  # d is the max influence, sr is the spacerace doing the influencing
            loccheck=(a==spacerace(sr,1))+(b==spacerace(sr,2))+(c==spacerace(sr,3));
            if ((d>sys(a,b,c).influ.self)*(loccheck<3))
                sys(a,b,c).influ.ndx(e,:)=[spacerace(sr,1) spacerace(sr,2) spacerace(sr,3)];
                sys(a,b,c).influ.score(e)=d;
#                if ((e==1)*(sys(a,b,c).native==0))
#                    favrace(a,b,c)=spacerace(sr,4); # favorite race is the dominant spacefaring one
#                  endif
                # add the current world to the list of dominated worlds for the spacefaring empire
                f=length(sys(spacerace(sr,1),spacerace(sr,2),spacerace(sr,3)).influ.ally(:,1));
                f=f+ 1- (sys(spacerace(sr,1),spacerace(sr,2),spacerace(sr,3)).influ.ally(1,1)==0);
                sys(spacerace(sr,1),spacerace(sr,2),spacerace(sr,3)).influ.ally(f,:)=[a b c];
                sys(spacerace(sr,1),spacerace(sr,2),spacerace(sr,3)).influ.dominate(f)=d;
                infs(sr)=-25;  # don't select the same world again
              endif  
            if ((sys(a,b,c).population>0)*(e==1)*(sys(a,b,c).influ.self==d)) # no worlds have more influence than the locals
                sys(a,b,c).influ.indpendent=1;
                if (sys(a,b,c).starport!='A')  # but not a class A starport, then some race may provide transport
                    sys(a,b,c).influ.ally(1,:)=[spacerace(sr,1) spacerace(sr,2) spacerace(sr,3)];
                    sys(a,b,c).influ.dominate(1)=d;
#{
                    if (sys(a,b,c).native>0)
                        for f=1:length(newrace)
                          g=distance(sys(a,b,c), newrace(f));
                          if (g==0)                      # if the world is a homeworld, it is the favored race
                              favrace(a,b,c)=f+10;
                              break;
                            endif
                          endfor  
                      else
                        if (roll(2)>(5+floor(syst_uplifts/5))*syst_nouplift)  # choose an uplifted race if available
                            g=0;
                            for f=1:sys(a,b,c).habnum        #add dolphins if a habitable world is 50% water
                              g=max(g,(sys(a,b,c).habit.hydro(f)>4));
                              endfor             
                            favrace(a,b,c)=4+ceil(rand()*(3+g));
                          else
                            if (sys(a,b,c).habnum==0)         # choose a random major race if no habitable worlds
                                  favrace(a,b,c)=floor(rand()*5);     
                                else                            # choose a habitable world and make it's favored race the world's
                                  favrace(a,b,c)= sys(a,b,c).favor(sys(a,b,c).habit.planet(ceil(rand()*sys(a,b,c).habnum)));
                                endif  
                          endif  
                      endif
#}
                  endif
  
              endif
              if (d<0)   #choose 5 top starfaring race influencers on this world; stop if influence <0
                  e=6;
                else
                  e=e+1;
                endif
              endwhile
            endif
      endfor
    endfor
  endfor
more on
  
#{
for a=1:length(sys(:,1,1))          # populating worlds with a mix of races
  for b=1:length(sys(1,:,1))
    printf("Populating systems in subsector %d,%d.\n", a, b);
    for c=1:length(sys(1,1,:))
      domrace=0;
      if (sys(a,b,c).starnum>0)         # must be a system 
          if (sys(a,b,c).native>0)               # there is a native race
              if (sys(a,b,c).starport=='A')        # starfaring native race dominates its home planet
                  sys(a,b,c).populate.pp(1)=100;
                  for d=1:length(spacerace)
                    e=distance(spacerace(d,1:3), sys(a,b,c));  
                    if (e==0)
                        sys(a,b,c).populate.pn(1)=spacerace(d,4);
                        sys(a,b,c).populate.name(1)=newrace(spacerace(d,4)-10).name;
                        break
                      endif
                    endfor  
                else                               #the spacefaring race has a presence
                  sys(a,b,c).populate.pn(1)=favrace(a,b,c);
                  sys(a,b,c).populate.name(1,:)=nm(favrace(a,b,c)+1,:);
                  for d=1:length(newrace)
                    e=distance(sys(a,b,c), newrace(d));
                    if (e==0)
                        sys(a,b,c).populate.pn(2)=d+10;
                        sys(a,b,c).populate.name(2,:)=newrace(d).race.name;
                        break
                      endif  
                    endfor
                  if (sys(a,b,c).influ.independent==1)     # a large presence if dependent, a smaller one if independent
                      sys(a,b,c).populate.pp(1)=ceil(rand()*(syst_race_numbers*3))+syst_race_numbers;
                    else
                      sys(a,b,c).populate.pp(1)=ceil(rand()*(syst_race_numbers*9))+syst_race_numbers*6;
                    endif
                  sys(a,b,c).populate.pp(2)=100-sys(a,b,c).populate.pp(1);
                endif
            else                       # if there is no native race    
              if (sys(a,b,c).starport=='A')    # if it is a spacefaring system, its favrace dominates
                  sys(a,b,c).populate.pn(1)=favrace(a,b,c);
                  sys(a,b,c).populate.name(1,:)= nm(favrace(a,b,c)+1,:)
                  domrace=4;
                  e=2;                
                  for d=1:length(sys(a,b,c).influ.ndx(:,1))    # other spacefaring races may have species
                    if (sys(a,b,c).influ.score(d)>sys(a,b,c).influ.self)
                        g=0; 
                        for f=1:e-1
                          if (sys(a,b,c).populate.pn(f)==favrace(sys(a,b,c).influ.ndx(d,1), sys(a,b,c).influ.ndx(d,2), sys(a,b,c).influ.ndx(d,3)))
                              g=f;
                              break
                            endif
                          endfor
                        if (g==0)  
                            sys(a,b,c).populate.pp(e)=ceil(rand()*(syst_race_numbers*3))+syst_race_numbers;
                            sys(a,b,c).populate.pn(e)=favrace(sys(a,b,c).influ.ndx(d,1), sys(a,b,c).influ.ndx(d,2), sys(a,b,c).influ.ndx(d,3));
                            if (sys(a,b,c).populate.pn(e)<10)
                                sys(a,b,c).populate.name(e,:)=nm(sys(a,b,c).populate.pn(e)+1,:);
                              else
                                sys(a,b,c).populate.name(e)=newrace(sys(a,b,c).populate.pn(e)-10).name;
                              endif
                            e=e+1;
                          else
                            sys(a,b,c).populate.pp(g)=2* ceil(rand()*(syst_race_numbers*3))+syst_race_numbers;
                          endif    
                      endif  
                    endfor
                  psum=0;       
                  for d=2:e-1
                    psum=psum+sys(a,b,c).populate.pp(d);
                    endfor
                  sys(a,b,c).populate.pp(1)=100-psum;
                else    #not a starfaring system and no native race
                  sys(a,b,c).populate.pn(1)=favrace(a,b,c);
                  if (favrace(a,b,c)<10)
                      sys(a,b,c).populate.pname(1,:)=nm(favrace(a,b,c)+1,:);
                    else
                      sys(a,b,c).populate.pname(1,:)=newrace(favrace(a,b,c)-10).race.name;
                    endif  
                  if (sys(a,b,c).habnum==0)   # no habitable planets, only the starfaring race lives here
                      sys(a,b,c).populate.pp(1)=100;
                    else 
                      #does the dominant race like any of the planets present?
                      domrace=2;
                      if (sys(a,b,c).populate.pn(1)>10)     # dominant race is a new minor race
                          for d=1:sys(a,b,c).habnum
                            for e=1:newrace(sys(a,b,c).populate.pn(1)-10).race.traits  #find worlds where they can live easily
                              domrace=domrace+ (sys(a,b,c).habit.atm(d)<6)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==3);
                              domrace=domrace+ (sys(a,b,c).habit.temp(d)<4)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==7);
                              domrace=domrace+ (sys(a,b,c).habit.temp(d)<4)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==8);
                              domrace=domrace+ (sys(a,b,c).habit.temp(d)>4)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==12);
                              domrace=domrace+ (sys(a,b,c).habit.temp(d)>4)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==15);
                              domrace=domrace+ (sys(a,b,c).habit.hydro(d)>5)*(sys(a,b,c).habit.hydro(d)<0)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==63);
                              domrace=domrace+ (sys(a,b,c).habit.hydro>7)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==64);
                              domrace=domrace+ (sys(a,b,c).habit.hydro<2)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==8);
                              if (sys(a,b,c).habit.moon==0)
                                  grav= sys(a,b,c).gravity(sys(a,b,c).habit.planet(d));
                                else
                                  grav= sys(a,b,c).moon.gravity(sys(a,b,c).habit.planet(d), sys(a,b,c).habit.moon(d));
                                endif  
                              domrace=domrace+ (grav<0.5)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==72);
                              domrace=domrace+ (grav>1.1)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==73);
                              domrace=domrace+ (grav<.75)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==74);
                              taint=(sys(a,b,c).habit.atm(d)==2)+(sys(a,b,c).habit.atm(d)==4)+(sys(a,b,c).habit.atm(d)==7)+(sys(a,b,c).habit.atm(d)==9);
                              domrace=domrace+ (taint==1)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==78);
                              domrace=domrace+ (taint==1)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==79);
                              domrace=domrace+ (sys(a,b,c).habit.atm(d)<4)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==80);
                              domrace=domrace+ (sys(a,b,c).habit.atm(d)>7)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==80);
                              domrace=domrace+ (sys(a,b,c).habit.atm(d)<6)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==81);
                              domrace=domrace+ (sys(a,b,c).habit.atm(d)>7)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==81);
                              domrace=domrace+ (sys(a,b,c).habit.atm(d)>7)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==82);
                              domrace=domrace+ (sys(a,b,c).habit.hydro(d)>5)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==83);
                              domrace=domrace+ (sys(a,b,c).habit.hydro(d)>5)*(newrace(sys(a,b,c).populate.pn(1)-10).race.trait(e)==87);
                              endfor
                            endfor
                        elseif (sys(a,b,c).populate.pn(1)<5)  # major race
                          for d=1:sys(a,b,c).habnum
                            if (sys(a,b,c).habit.moon(d)==0)
                                domrace=domrace+(sys(a,b,c).favor(sys(a,b,c).habit.planet(d))==sys(a,b,c).populate.pn(1));
                              else
                                domrace=domrace+(sys(a,b,c).moon.favor(sys(a,b,c).habit.planet(d), sys(a,b,c).habit.moon(d))==sys(a,b,c).populate.pn(1));                      
                              endif
                            endfor
                        else
                          for d=1:sys(a,b,c).habnum
                            if (sys(a,b,c).habit.moon(d)==0)
                                domrace=domrace+(sys(a,b,c).favor(sys(a,b,c).habit.planet(d))==0);
                              else
                                t1= sys(a,b,c).habit.planet(d);
                                t2=sys(a,b,c).habit.moon(d);
                                domrace=domrace+(sys(a,b,c).mooon.favor(t1,t2)==0);                      
                              endif
                            endfor
                        endif
                    endif    
                  if (sys(a,b,c).population<7) # pick 1 race as the non-dominant race
                      if (roll(2)>(5+floor(syst_uplifts/5))*syst_nouplift)  # choose an uplifted race if available
                          g=0;
                          for f=1:sys(a,b,c).habnum        #add dolphins if a habitable world is 50% water
                            g=max(g,(sys(a,b,c).habit.hydro(f)>4));
                            endfor             
                          sys(a,b,c).populate.pn(2)=4+ceil(rand()*(3+g));
                        else
                          if (sys(a,b,c).habnum==0)         # choose a random major race if no habitable worlds
                                sys(a,b,c).populate.pn(2)=floor(rand()*5);     
                              else                            # choose a habitable world and make it's favored race the world's
                                sys(a,b,c).populate.pn(2)= sys(a,b,c).favor(sys(a,b,c).habit.planet(ceil(rand()*sys(a,b,c).habnum)));
                              endif  
                        endif
                      sys(a,b,c).pname(2,:)=nm(sys(a,b,c).populate.pn(2)+1,:);
                      if (sys(a,b,c).populate.pn(1)==sys(a,b,c).populate.pn(2)) # if same race chosen, zero out second
                          sys(a,b,c).populate.pp(1)=100;
                          sys(a,b,c).populate.pn(2)=0;
                          sys(a,b,c).populate.pname(2)="";
                          sys(a,b,c).populate.pp(2)=0;
                        else                       # populate the dominant race, 2nd race is the remainder
                          domrace=min(domrace,8);
                          domrace=max(domrace,0);
                          if (sys(a,b,c).populate.pn(1)==2)   # insectans like to be in groups
                              domrace=max(domrace,2);
                            endif  
                          sys(a,b,c).populate.pp(1)=10*domrace+ceil(rand()*9);
                          sys(a,b,c).populate.pp(2)=100-sys(a,b,c).populate.pp(1);
                        endif  
                    else      # pick several races that have favored planets here plus the dominant one
                      clear raccnt  
                      for d=1:sys(a,b,c).habnum
                        if (sys(a,b,c).habit.moon(d)==0)
                            fav=sys(a,b,c).favor(sys(a,b,c).habit.planet(d));
                          else
                            fav=sys(a,b,c).moon.favor(sys(a,b,c).habit.planet(d),sys(a,b,c).habit.moon(d));
                          endif
                        if (fav==0)
                            if ((roll(2)>(5+floor(syst_uplifts/5)))*syst_nouplift)  # choose an uplifted race if available
                                g=(sys(a,b,c).habit.hydro(d)>4);
                                raccnt(d)=4+ceil(rand()*(3+g));
                              else
                                raccnt(d)=0;
                              endif
                          else
                            raccnt(d)=fav;
                          endif
                        endfor
                      cnt=1;
                      for d=cnt+1:length(raccnt)
                        if (raccnt(cnt)==raccnt(d))    # if a race is repeated
                            for e=d:(length(raccnt)-1)    # remove it and renumber
                              raccnt(e)=raccnt(e+1);
                              endfor
                            raccnt=raccnt(1:end-1);   #remove the last element
                            break;                      #keep from going past the end of raccnt  
                          endif
                        cnt=cnt+1;  
                        endfor  
                      per=floor(100/(2+length(raccnt)));
                      e=0;
                      for d=1:length(raccnt)
                        sys(a,b,c).populate.pp(d+1)=per-ceil(rand()*5);
                        sys(a,b,c).populate.pn(d+1)=raccnt(d);
                        e=e+sys(a,b,c).populate.pp(d+1);
                        sys(a,b,c).populate.pname(d+1,:)=nm(sys(a,b,c).populate.pn(d+1)+1,:);
                        endfor
                      sys(a,b,c).populate.pp(1)=100-e;
                    endif  
                endif      
            endif          
        endif
      endfor
    endfor
  endfor    
#}



