# calculate seasonal and temperature variations for a given habitable planet

tempstart=[-19 -9 1 11 21 31 41];
temprange=[10 10 10 10 10 10 10];

plan= sy.habit.planet(pl);
tp= sy.habit.temp(pl);
moddown=0;
modup=0;

if (plan>1)
    if (tp<sy.temp(plan-1))  #use lowest of that temp range if earlier planet is same or colder
        moddown=0;
      endif
  else
    moddown=1;
  endif
if (plan<sy.planets)
    if (tp>sy.temp(plan+1))  #use highest of that temp range if later planet is same or warmer
        modup=0;
      else
        modup=1;
      endif
  else
    modup=0;
  endif
if ((moddown==0)*(modup==0))  
    sy.habit.axis.temp(pl)=floor(rand()*temprange(sy.habit.temp(pl)))+tempstart(sy.habit.temp(pl));  
  elseif (moddown==1)
    sy.habit.axis.temp(pl)=floor(rand()*3)+tempstart(sy.habit.temp(pl));   # must be on cooler side of the range
  else
    sy.habit.axis.temp(pl)=tempstart(sy.habit.temp(pl))+temprange(sy.habit.temp(pl))-ceil(rand()*3);  # upper end of range  
  endif

if (sy.habit.moon(pl)==0)                   # determine the diameter of the habitable world
    siz= sy.radius(sy.habit.planet(pl));
  else
    siz= sy.moon.radius(sy.habit.planet(pl), sy.habit.moon(pl));
  endif
  
change=0.30*siz/100;                       #using size and atm type, calculate degree change equator to pole
change=change+ ((sy.habit.atm(pl)==3)+(sy.habit.atm(pl)==2))*0.5;    # modify change by atmosphere density
change=change+ ((sy.habit.atm(pl)==4)+(sy.habit.atm(pl)==5))*0.8;
change=change+ ((sy.habit.atm(pl)==6)+(sy.habit.atm(pl)==7))*1;  
change=change+ ((sy.habit.atm(pl)==8)+(sy.habit.atm(pl)==9))*1.4;
sy.habit.axis.chg(pl)=ceil(change);
  if (sy.companion(plan)==0)     #determine the gravity felt depending on which system planets are in
      gravfelt=primgrav;
    else
      gravfelt=compgrav;
    endif
orbfrac= (sqrt((sy.orbit(plan)/150)^3/gravfelt))^(.5+(0.5*(sy.orbit(plan)<150))); # close planets change less per season
sy.habit.axis.sea(pl)= sy.axis.tilt(sy.habit.planet(pl))*.18* orbfrac;  #0.18 per degree tilt for seasonal change

  
  