#combined functions for mapping
1;
function NShex(h,v,a,b,c)
  plot([h+.1 h+.1], [(v+a+c+.1) v+a+.1])
  plot([h+0.1 h+b+.1], [v+a+.1 v+0.1]);
  plot([h+b+.1 h+2*b+.1], [v+0.1 v+a+.1]);
  plot([h+2*b+.1 h+2*b+.1], [v+a+.1 v+a+c+.1]);
  plot([h+2*b+.1 h+b+.1], [v+a+c+.1 v+2*c+.1]);
  plot([h+b+.1 h+.1], [v+2*c+.1 v+a+c+.1]);
  endfunction

function EWhex(h,v,a,b,c)
  
  line([h+.1 h+.1+a], [v+.1+b v+.1], "color", "k")
  line([h+.1+a h+.1+a+c], [v+.1 v+.1], "color", "k")
  line([h+.1+a+c h+.1+2*c], [v+.1 v+.1+b], "color", "k")
  line([h+.1+2*c h+.1+a+c], [v+.1+b v+.1+2*b], "color", "k")
  line([h+.1+a+c h+.1+a], [v+.1+2*b v+.1+2*b], "color", "k")
  line([h+.1+a h+.1], [v+.1+2*b v+.1+b], "color", "k")
  endfunction

function colorhex(h,v,a,b,c,co)
  plot([h+.1 h+.1+a], [v+.1+b v+.1], "color", co, "linewidth",2)
  plot([h+.1+a h+.1+a+c], [v+.1 v+.1], "color", co, "linewidth",2)
  plot([h+.1+a+c h+.1+2*c], [v+.1 v+.1+b], "color", co, "linewidth",2)
  plot([h+.1+2*c h+.1+a+c], [v+.1+b v+.1+2*b], "color", co, "linewidth",2)
  plot([h+.1+a+c h+.1+a], [v+.1+2*b v+.1+2*b], "color", co, "linewidth",2)
  plot([h+.1+a h+.1], [v+.1+2*b v+.1+b], "color", co, "linewidth",2)
  endfunction


#draw hex subsectors 8x10
function mapdraw(sx,sy)
c=1;
a=0.5*c;
b=sin(pi/3)*c;
axis ([0 13 0 19]);

for y=0:9
  for x=0:7
    ex=num2str(dec2hex(x+1,1));
    ey=num2str(dec2hex(10-y,1));
    loc=[sx ex sy ey];

    if (x/2== floor(x/2))
        EWhex((floor(x/2)*3*c), (y*2*b),a,b,c);
        text((floor(x/2)*3*c+b/2+.45), (y*2*b+1.7),loc,"fontsize",8);
      else
        EWhex(floor(x/2)*3*c+(a+c), y*2*b+b,a,b,c)
        text((floor(x/2)*3*c+(a+c)+b/2+.45), (y*2*b+b+1.7),loc,"fontsize",8);         
      endif
    endfor
  endfor

endfunction  

function hexoutline(x,y,co)  #x=xpos, y=ypos, co=[r g b] color array
c=1;
a=0.5*c;
b=sin(pi/3)*c;
axis ([0 13 0 19]);

  x=x-1;
  y=10-y;

    if (x/2== floor(x/2))
        colorhex((floor(x/2)*3*c), (y*2*b),a,b,c,co);
      else
        colorhex(floor(x/2)*3*c+(a+c), y*2*b+b,a,b,c,co)
      endif

endfunction

function starcircle(x,y,co,q,s) # x=Xpos  y=Ypos  co=[R G B] q= scaling oval s=restriction
  col(1,:)=[1 0 0];
  col(2,:)=[.90 .57 .16];
  col(3,:)=[1 1 0];
  col(4,:)=[1 1 1];
  col(5,:)=[.7 .7 .7];
  col(6,:)=[.6 .3 .15];
  col(7,:)=[.5 .5 1];
  col(8,:)=[0 0 1];
  red=[.75 0 0];
  amber=[.7 .7 0];
  t=(1/80:1/40:1)'*2*pi;
  sx=cos(t)/10;
  sy=sin(t)/10;
  c=1;
  a=0.5*c;
  b=sin(pi/3)*c;
  x=x-1;
  y=y-1;
  y=9-y;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
  
      
  fill(1.5*sx+xm, 1.5*sy+0.2+ym, col(co(1),:));
  plot(2.5*sx*q+xm, 2.5*sy+0.2+ym, "color", col(co(1),:), "linewidth", 1)

cx= -.5:.01:.5;
  if (s==1)  # draw restriction line
      plot(xm+cx, ym-.05, "color", amber, "linewidth",1);
    elseif(s==2)
      plot(xm+cx, ym-.05, "color", red, "linewidth",1);
    endif
    
  endfunction
  
function rightstar(ex,ey,co) # ex=Xpos  ey=Ypos  co=[R G B]
  t=(1/80:1/40:1)'*2*pi;
  x=cos(t);
  y=sin(t);
  x=x/10;           # x and y are experimentally determined for drawing a circle around the stars
  y=y/10 + 0.08;    #     starting at a baseline of 0
  ex=ex-1;
  ey=10-ey;
  c=1;          # c,a, and b are from drawing hexes
  a=0.5*c;
  b=sin(pi/3)*c;
  xoff=1.96;
  yoff=0.88;  
  if (ex/2==floor(ex/2))
      fill((floor(ex/2)*3*c)+x+xoff,(ey*2*b)+y+yoff,co)   # even position offsets plus circle offsets above
    else
      fill(x+(floor(ex/2)*3*c+(a+c)+xoff), y+(ey*2*b+b)+yoff,co)    # odd position offsets plus circle offsets above
    endif
  endfunction  

function leftstar(ex,ey,co) # ex=Xpos  ey=Ypos  co=[R G B]
  t=(1/80:1/40:1)'*2*pi;
  x=cos(t);
  y=sin(t);
  x=x/10;           # x and y are experimentally determined for drawing a circle around the stars
  y=y/10 + 0.08;    #     starting at a baseline of 0
  ex=ex-1;
  ey=10-ey;
  c=1;          # c,a, and b are from drawing hexes
  a=0.5*c;
  b=sin(pi/3)*c;
  xoff=0.22;
  yoff=0.88;
  if (ex/2==floor(ex/2))
      fill((floor(ex/2)*3*c)+x+xoff,(ey*2*b)+y+yoff,co)   # even position offsets plus circle offsets above
    else
      fill(x+(floor(ex/2)*3*c+(a+c)+xoff), y+(ey*2*b+b)+yoff,co)    # odd position offsets plus circle offsets above
    endif    
  endfunction

function leftcenter(ex,ey,co) # ex=Xpos  ey=Ypos  co=[R G B]
  t=(1/80:1/40:1)'*2*pi;
  x=cos(t);
  y=sin(t);
  x=x/10;           # x and y are experimentally determined for drawing circles around stuff
  y=y/10 + 0.08;    #     starting at a baseline of 0
  ex=ex-1;
  ey=10-ey;
  c=1;          # c,a, and b are from drawing hexes
  a=0.5*c;
  b=sin(pi/3)*c;
  xoff=0.60;
  yoff=1.105;  
  if (ex/2==floor(ex/2))
      fill((floor(ex/2)*3*c)+x+xoff,(ey*2*b)+y+yoff,co)   # even position offsets plus circle offsets above
    else
      fill(x+(floor(ex/2)*3*c+(a+c)+xoff), y+(ey*2*b+b)+yoff,co)    # odd position offsets plus circle offsets above
    endif   
  endfunction
  
  
function highlight(ex,ey,co) # ex=Xpos  ey=Ypos  co=[R G B] 
  ex=ex-1;
  ey=10-ey;
  c=1;          # c,a, and b are from drawing hexes
  a=0.5*c;
  b=sin(pi/3)*c;
  if (ex/2==floor(ex/2))
      fill((floor(ex/2)*3*c)+ xoff,(ey*2*b)+yoff,co)   # even position offsets plus circle offsets above
    else
      fill(x+(floor(ex/2)*3*c+(a+c)+xoff), y+(ey*2*b+b)+yoff,co)    # odd position offsets plus circle offsets above
    endif
endfunction
 
 
function stardraw(x,y,n,ty,s,q,locate)  #x=xpos, y=ypos, n=#stars, ty=startype, s= system status q= giant scaling factor
sx= [0 -.03 -.12 -.03 0 .03 .12 .03 0];           # locate>1 for distant binaries, anything else is not relevant
sy= [.12 .03 0 -.03 -.12 -.03 0 .03 .12];
col(1,:)=[1 0 0];
col(2,:)=[.90 .65 .35];
col(3,:)=[1 1 0];
col(4,:)=[1 1 1];
col(5,:)=[.75 .75 .75];
col(6,:)=[.4 .25 .25];
col(7,:)=[.5 .75 1];
col(8,:)=[0 0 1];
red=[.75 0 0];
amber=[.7 .7 0];
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1;
y=y-1;
y=9-y;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
# printf("sx%d sy%d q%d xm%d ym%d, ty:%d r:%d g:%d b:%d", sx, sy, q, xm, ym, ty, col(ty(1),1), col(ty(1),2), col(ty(1),3));
if (n==1)
    fill(2*sx*q+xm, 2*sy*q+0.2+ym, col(ty(1),:));
    
  elseif (n==2)
    if (locate==2)     # distant binaries should be further apart
        wide=0.15;
      else
        wide=0;
      endif
    fill(sx*1.6-.2+xm-wide, sy*1.6+.2+ym, col(ty(1),:));
    fill(sx*1.6+.2+xm+wide, sy*1.6+.2+ym, col(ty(2),:));
  else
    fill(sx*1.4-.25+xm, sy*1.4+.1+ym, col(ty(1),:));
    fill(sx*1.4+xm-.1, sy*1.4+.3+ym, col(ty(2),:));
    fill(sx*1.4+.35+xm, sy*1.4+.1+ym, col(ty(3),:));
  endif  
cx= -.5:.01:.5;

if (s==1)
    plot(xm+cx, ym-.05, "color", amber, "linewidth",1);
  elseif(s==2)
    plot(xm+cx, ym-.05, "color", red, "linewidth",1);
  endif
endfunction  

function startext(x,y,name, uwp, code)
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1;
y=y-1;
y=9-y;
    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
    text(xm-0.086*length(name), ym-.23 , name,"fontsize",12);      
    text(xm-.7, ym-.55 ,uwp,"fontsize",9);
    text(xm-.5, ym-.8, code, "fontsize",9);    

endfunction  

function basetext(x,y,n,s,e,co)
c=1;
a=0.5*c;
b=sin(pi/3)*c;
x=x-1;
y=y-1;
y=9-y;

    if (x/2== floor(x/2))
        xm=(floor(x/2)*3*c+b/2+.7);
        ym=(y*2*b+1.1);
      else
        xm=(floor(x/2)*3*c+(a+c)+b/2+.7);
        ym=(y*2*b+b+1.1);         
      endif
if (n==1)
    text(xm-.6, ym+.4, 'N');    
  endif
if (s==1)
    text(xm-.8, ym+.1, 'S');    
  endif
if (e==1)
    text(xm+.4, ym+.4, 'E');    
  endif
if (co==1)
    text(xm+.6, ym+.1, 'C');    
  endif
  
endfunction


function draw_subsector(trav);
  
hold on
tx= trav(1).sector(1);
ty= trav(1).sector(2);
if (tx<10)
    sx=num2str(tx);
  else
    sx=char('A'-1+tx);
  endif
if (ty<10)
    sy=num2str(ty);
  else
    sy=char('A'-1+ty);
  endif

mapdraw(sx, sy);

for j=1:length(trav)
  sn=trav(j).starnum;
  st=[0 0 0];
  for a=1:sn    # choose color for drawing stars
    if ((trav(j).startype(a,1)=='r')+(trav(j).startype(1,6)=='S')+(trav(j).startype(1,1)=='M'))
        st(a)=1;
      elseif ((trav(j).startype(a,1)=='o')+(trav(j).startype(1,1)=='f'))
        st(a)=2;
      elseif ((trav(j).startype(a,1)=='y')+(trav(j).startype(1,1)=='R'))
        st(a)=3;
      elseif ((trav(j).startype(a,1)=='w')+(trav(j).startype(1,6)=='W'))
        st(a)=4;
      elseif ((trav(j).startype(a,6)=='D')+(trav(j).startype(1,1)=='p')+ (trav(j).startype(a,1)=='T'))
        st(a)=5;
      elseif ((trav(j).startype(a,6)=='T')+(trav(j).startype(1,6)=='N'))
        st(a)=6;
      elseif ((trav(j).startype(a,6)=='A')+(trav(j).startype(a,1)=='C'))
        st(a)=7;
      elseif ((trav(j).startype(a,6)=="B")+(trav(j).startype(a,6)=='O'))
        st(a)=8;  
      endif
    endfor
# define scaling factor for size of star
if ((trav(j).startype(1,6)=='S')+(trav(j).startype(1,6)=='O')+(trav(j).startype(1,6)=='W')+(trav(j).startype(1,6)=='N')+ (trav(j).startype(1,1)=='p'))
    q=2;
  elseif ((trav(j).startype(1,6)=='A')+(trav(j).startype(1,6)=='B'))
    q=1.4;
  else  
    q=1;
  endif
  

#  if (trav(j).influ.independent==1)    # include 2 circles for indpendent worlds only
 #     if (trav(j).influ.dominate(1)>0) # has at least 1 ally as well
  #        co=[.33 .33 .33];            # choose unique color
   #       starcircle(trav(j).subsector(1), trav(j).subsector(2), co)   #draw all 4 stars same unique color
    #      rightstar(trav(j).subsector(1), trav(j).subsector(2), co)
    #      leftstar(trav(j).subsector(1), trav(j).subsector(2), co)  
#        else
 #         co=[.75 1 1];                # choose the singleton color
  #        starcircle(trav(j).subsector(1), trav(j).subsector(2), co)   #draw just 2 middle stars 
   #     endif
#    elseif (trav(j).influ.dominate(1)>0) #not independent but does have allies
 #     co=[.1 .8 .8];             #choose the dominant world's color
  #    rightstar(trav(j).subsector(1), trav(j).subsector(2), co)
   #   co=[.33 .33 .33];                 #choose 1 unique color
    #  leftcenter(trav(j).subsector(1), trav(j).subsector(2), co)
#    else   #not independent, no allies
 #     co=[.1 .8 .8];              #choose the dominant world's color
  #    rightstar(trav(j).subsector(1), trav(j).subsector(2), co)
   # endif                  
  if ((trav(j).period(2)>0)+(trav(j).startype(1,1)=='p')+(trav(j).startype(1,1)=='T'))
      starcircle(trav(j).subsector(1), trav(j).subsector(2), st, q, trav(j).restriction);
    else  
      stardraw(trav(j).subsector(1), trav(j).subsector(2), sn, st, trav(j).restriction,q,trav(j).starlocation);
    endif  
  if (trav(j).bestm>0)
      uwp=trav(j).moon.uwp(trav(j).bestp, trav(j).bestm,:);
      uwp=char(reshape(uwp,1,9));
    else
      uwp=trav(j).uwp(trav(j).bestp,:);
    endif
  code=['a' num2str(trav(j).asteroids) 'g' num2str(trav(j).giants) 'h' num2str(trav(j).habnum)];
  startext(trav(j).subsector(1), trav(j).subsector(2), trav(j).name, uwp, code);
  basetext(trav(j).subsector(1), trav(j).subsector(2), trav(j).naval, trav(j).scout, trav(j).aid, trav(j).consul);  
  endfor
  
title(strcat(' [', num2str(trav(1).sector(1)), ',', num2str(trav(1).sector(2)), ']- ', trav(1).subsectname, " Subsector"),"fontsize",18);  
orient("tall");
axis("off");
papersize = [8.5 11];
        set (gcf, "papersize", papersize)
        set (gcf, "paperposition", [0.25 0.25, papersize-0.5])
        
hold off
 namefile= strcat('S', num2str(trav(1).sector(1)), ',', num2str(trav(1).sector(2)), trav(1).subsectname,'.ps');

#  print(1, namefile);
saveas(1,namefile, "epsc");

# fflush(1);
# close;
endfunction

for c=1:length(sys(1,1,:))
      if (sys(a,b,c).starnum>0)
          trav(c)= sys(a,b,c);
        endif
      endfor  
# chdir(newdir);
draw_subsector(trav);
# chdir(olddir);
